/**
 * PaintTest osztly - Ezen applet a paint() hasznlatt szemllteti.
 */
public class PaintTest extends java.applet.Applet
                       implements java.awt.event.MouseListener {
  String text;                                         //aktulis lthat kirs
  String inText;                                  //szveg, ha a kurzor bent van
  String outText;                                 //szveg, ha a kurzor kint van
  java.awt.Image background;                                         //httrkp
  boolean noUpdate;                        //igaz, ha nem kell az eredeti update
  boolean offScreen;                    //igaz, ha offScreen trtnik a rajzols

  public String[][] getParameterInfo() {                   //paramterekrl inf
    String info[][]={
       {"inText", "String", "Bent kirand szveg"},
       {"outText", "String", "Kint kirand szveg"},
       {"background", "Kpfjlnv", "Httrkp"},
       {"noUpdate", "boolean", "Nincs update"},
       {"offScreen", "boolean", "Offscreen rajzols"}};
    return info;
  }

  public String getAppletInfo() {                      //az appletrl informci
    return "Ezen applet a paint() hasznlatt szemllteti";
  }

  public void init(){                                    //kezdeti inicializls
    String image;                                           //httrkp fjlneve

    if ((inText=getParameter("inText"))==null)
       inText="benne van a kurzor";                     //alaprtelmezett inText
    if ((outText=getParameter("outText"))==null)
       outText="nincs benn a kurzor";                  //alaprtelmezett outText
    text=outText;                                  //kezdetben kinn van a kurzor
 
    noUpdate=(getParameter("noUpdate"))!=null;
    offScreen=(getParameter("offScreen"))!=null;
 
   if ((image=getParameter("background"))!=null) {
       background=getImage(getCodeBase(), image);
       prepareImage(background, this);                       //betlts indtsa
       java.awt.MediaTracker tracker=new java.awt.MediaTracker(this);
       tracker.addImage(background, 0);                          //kp figyelse
       try {
            tracker.waitForID(0);                     //megvrni, mg betltdik
       } catch (Exception e) {
            System.err.println("PaintTest: "+e);                          //hiba
       }
       if (tracker.isErrorID(0)) {                         //sikertelen betlts
          System.err.println("Hiba: "+tracker.getErrorsAny()[0]);
          background=null;
       }
    }
    addMouseListener(this);                     //egresemnyeket figyelni fogja
  }

  public void update(java.awt.Graphics g) {
    if (noUpdate) paint(g);                      //egybl tirnytani a paintre
    else super.update(g);                       //alaprtelmezs szerinti update
  }

  public void paint(java.awt.Graphics g) {
    int actx, acty;                           //aktulis mozaikkocka koordinti
    java.awt.Graphics actg;                             //ide kell majd rajzolni
    java.awt.FontMetrics fm;                             //fontmret informcik
    java.awt.Image imageBuffer=null;

    if (offScreen) {                                        //offScreen rajzols
       imageBuffer=createImage(getSize().width, getSize().height);      //buffer
       actg=imageBuffer.getGraphics();                             //ltrehozsa
       actg.setClip(0, 0, getSize().width, getSize().height);
       actg.setColor(getBackground());                                  //trls
       actg.fillRect(0, 0, getSize().width, getSize().height);
       actg.setColor(getForeground());
    } else actg=g;                                         //kpernyre rajzols
    if (background!=null) {                                      //van httrkp
       acty=0;
       while (acty<getSize().height) {                            //kimozaikozs
             actx=0;
             while (actx<getSize().width) {
                   actg.drawImage(background, actx, acty, this);
                   actx+=background.getWidth(this);
             }
             acty+=background.getHeight(this);
       }
    }                                        //kirand szveg kzpre helyezse
    fm=g.getFontMetrics();                                         //lekrdezse
    if (fm!=null) {
       actx=(int)(getSize().width-fm.stringWidth(text))/2;
       acty=(int)(getSize().height-fm.getHeight())/2+fm.getAscent();
       actg.drawString(text, actx, acty);                       //szveg kirsa
    }
    if (offScreen) g.drawImage(imageBuffer, 0, 0, this); //offScreen kirajzolsa
  }

  public void mouseEntered(java.awt.event.MouseEvent me) {        //kurzor belp
    text=inText;                                    //a benti szveg az aktulis
    repaint();
  }

  public void mouseExited(java.awt.event.MouseEvent me) {         //kurzor kilp
    text=outText;                                   //a kinti szveg az aktulis
    repaint();
  }

  public void mousePressed(java.awt.event.MouseEvent me) {};     //MouseListener
  public void mouseReleased(java.awt.event.MouseEvent me) {};        //interfsz
  public void mouseClicked(java.awt.event.MouseEvent me) {};    //miatt kellenek
}
