import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

/**
  * SecurityTest osztly
  * Ez az alkalmazs/applet a biztonsgi megszortsokat szemllteti.
  */
public class SecurityTest extends Applet implements ActionListener {
  Panel buttonPanel=new Panel();                                //fellet elemei
  Button threadButton=new Button("thread");
  Button exitButton=new Button("exit");
  Button clearButton=new Button("clear");
  Button propertiesButton=new Button("properties");
  Button execButton=new Button("exec");
  Button socketButton=new Button("socket");
  Button readButton=new Button("read");
  Button writeButton=new Button("write");
  Button deleteButton=new Button("delete");
  Button protocolButton=new Button("protocol");
  TextArea textArea=new TextArea();

  public SecurityTest() {
    super();
    buttonPanel.setLayout(new GridLayout(0, 1));            //fellet felptse
    threadButton.addActionListener(this);
    propertiesButton.addActionListener(this);
    protocolButton.addActionListener(this);
    readButton.addActionListener(this);
    writeButton.addActionListener(this);
    deleteButton.addActionListener(this);
    execButton.addActionListener(this);
    socketButton.addActionListener(this);
    clearButton.addActionListener(this);
    exitButton.addActionListener(this);
    buttonPanel.add(threadButton);
    buttonPanel.add(propertiesButton);
    buttonPanel.add(protocolButton);
    buttonPanel.add(readButton);
    buttonPanel.add(writeButton);
    buttonPanel.add(deleteButton);
    buttonPanel.add(execButton);
    buttonPanel.add(socketButton);
    buttonPanel.add(clearButton);
    buttonPanel.add(exitButton);
    textArea.setEditable(false);
    textArea.append("Aktulis SecurityManager: " +
                     System.getSecurityManager() + "\n");
    setLayout(new BorderLayout());
    add("West", buttonPanel);
    add("Center", textArea);
    validate();
  }

  public String getAppletInfo() {                              //programrl inf
    return "Ez az alkalmazs/applet a biztonsgi megszortsokat szemllteti.";
  }

  public static void main(String args[]) {              //indts alkalmazsknt
    SecurityTest mySecurityTest=new SecurityTest();              //pldnyosts
    Frame myFrame=new Frame(mySecurityTest.getClass().getName()+" alkalmazs");
    myFrame.add("Center", mySecurityTest);
    myFrame.pack();
    myFrame.show();
  }

  public void actionPerformed(ActionEvent e) {           //gombnyoms lekezelse
   try {
    if (e.getSource()==clearButton) {                                    //clear
       textArea.setText("");
       return;
    } else if (e.getSource()==exitButton) {                               //exit
         textArea.append("System.exit(0): ");
         System.exit(0);
    } else if (e.getSource()==threadButton) {                           //thread
           textArea.append("setMaxPriority on ");
           ThreadGroup tg=Thread.currentThread().getThreadGroup().getParent();
           textArea.append(tg+": ");
           tg.setMaxPriority(tg.getMaxPriority());
    } else if (e.getSource()==propertiesButton) {                   //properties
           textArea.append("System.getProperties(): ");
           System.getProperties();
    } else if (e.getSource()==execButton) {                               //exec
           textArea.append("Runtime.getRuntime().exec("+
               '"'+"/usr/bin/rm /tmp/SecurityTest.tmp"+'"'+"): ");
           Runtime.getRuntime().exec("w:\\winnt\\system32\\cmd.exe /c "+    //:)
                                     "\"del e:\\tmp\\SecurityTest.tmp\"");  //:)
    } else if (e.getSource()==socketButton) {                           //socket
           textArea.append("Echo server(socket 7) ludens.elte.hu teszt: ");
           Socket socket=new Socket("ludens.elte.hu", 7);
           BufferedReader in=new BufferedReader(
                             new InputStreamReader(socket.getInputStream()));
           PrintWriter out=new PrintWriter(socket.getOutputStream());
           out.println("O.K.");
           out.flush();
           textArea.append(in.readLine());
           in.close();
           out.close();
           socket.close();
    } else if (e.getSource()==readButton) {                               //read
           textArea.append("Read /tmp/SecurityTest.tmp: ");
           FileInputStream in=new FileInputStream(
                              new File("e:\\tmp\\SecurityTest.tmp"));       //:)
           in.read();
           in.close();
    } else if (e.getSource()==writeButton) {                             //write
           textArea.append("Write /tmp/SecurityTest.tmp: ");
           FileOutputStream out=new FileOutputStream(
                                new File("e:\\tmp\\SecurityTest.tmp"));     //:)
           out.write(0);
           out.close();
    } else if (e.getSource()==deleteButton) {                           //delete
           textArea.append("Delete /tmp/SecurityTest.tmp: ");
           new File("e:\\tmp\\SecurityTest.tmp").delete();                  //:)
    } else if (e.getSource()==protocolButton) {                      //protokoll
           textArea.append("newAudioClip(getCodeBase(), "+
                               '"'+"../clip.au "+'"'+"): ");
           URL base=getClass().getClassLoader().getResource("audio/bark.au");
           newAudioClip(new URL(base, "../../clip.au"));
    }
    textArea.append("O.K.\n");                                        //sikerlt
   } catch (Throwable ex) {                                               //hiba
     textArea.append(ex+"\n");
   }
  }
}
