/**
 * SoundList osztly - hanganyagokat trol s azok letltst vezrli.
 * @see java.util.HashTable
 * @see SoundList$SoundLoader
 */
public class SoundList extends java.util.Hashtable {
  java.applet.Applet applet;                               //a tulajdonos applet
  String baseURL;                                  //hanganyag knyvtrnak neve

  /**Hanganyag trol s letltst vezrl ltrehozsa
   * @param applet a hanganyagot ignyl applet
   * @param baseURL a letltend hanganyagok bziscme
   */
  public SoundList(java.applet.Applet applet, String baseURL) {
    super(5);                                     //helyfoglals 5 klip szmra
    this.applet = applet;
    this.baseURL = baseURL;
  }

  /**Hanganyag letltsnek megkezdse
   * @param relativeURL a letltend hanganyag relatv cme a bziscmhez kpest
   */
  public void startLoading(String relativeURL) {
    new SoundLoader(relativeURL);
  }

  /**Hanganyag lekrdezse
   * @param relativeURL a letltend hanganyag relatv cme a bziscmhez kpest
   * @result null, ha mg nincs betltve a hanganyag,
   *         klnben a hanganyagot tartalmaz AudioClip
   * @see java.applet.AudioClip
   */
  public java.applet.AudioClip getClip(String relativeURL) {
    java.applet.AudioClip clip=(java.applet.AudioClip)get(relativeURL);
    if (clip==null) applet.showStatus("Letlts alatt: "+baseURL+relativeURL);
    else applet.showStatus("Lejtszs indul: "+baseURL+relativeURL);
    return clip;
  }

  /**Hanganyag eltrolsa
   * @param clip az eltroland hanganyag
   * @param relativeURL a letltend hanganyag relatv cme a bziscmhez kpest
   * @see java.applet.AudioClip
   */
  public void putClip(java.applet.AudioClip clip, String relativeURL) {
    put(relativeURL, clip);
  }

  /*****************************************************************************
   * SoundLoader osztly - hanganyagot tlt le a httrben.
   * @see java.lang.Thread
   */
  class SoundLoader extends Thread {
    String relativeURL;                                   //letltend fjl neve

    /**
     * Hanganyagot letlt programszl ltrehozsa
     * @param relativeURL a letltend hanganyag relatv cme
     *                    a hanganyaglista bziscmhez kpest
     */
    public SoundLoader(String relativeURL) {
      this.relativeURL=relativeURL;
      start();                                   //httrben val futs indtsa
    }

    public void run() {                                        //httrben futs
      setPriority(MIN_PRIORITY);                           //senkit se zavarjunk
      applet.showStatus("Letlts indul: "+baseURL+relativeURL);
      try {
          putClip( java.applet.Applet.newAudioClip(
             applet.getClass().getResource(baseURL+relativeURL)) ,relativeURL );
      } catch (Throwable th) {                               //meg lett szaktva
        System.err.println("Hiba a letltskor: "+baseURL+relativeURL+th);
        applet.showStatus("Hiba a letltskor: "+baseURL+relativeURL+th);
      }
    }
  }
}
