package javabook.smiley;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class IntBox extends TextField
                implements Serializable {

    public IntBox() {
       super();
       enableEvents( AWTEvent.KEY_EVENT_MASK );  
   }

    // 0-val tr vissza, ha nem tudja kiparse-olni a textfield rtkt
    public int getValue() {
       int i;
       try {
          i = Integer.parseInt( getText() );
          return i;
       } catch ( NumberFormatException e ) {
          return 0;
       }
   }

    public void setValue( int value ) {
       int oldValue = prev;
       setText( Integer.toString( value ) );
       int newValue = getValue();
       
       changes.firePropertyChange("value", 
                           new Integer( oldValue ), 
                           new Integer( newValue ) );
       prev = newValue;
    }

    public void addPropertyChangeListener(PropertyChangeListener l) {
       changes.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l) {
       changes.removePropertyChangeListener(l);
    }

    public void processKeyEvent( KeyEvent event ) {
       char c = event.getKeyChar();
       
       if ( ( c >= '0' && c <= '9' ) ||
              c == KeyEvent.VK_DELETE ||
              c == KeyEvent.VK_BACK_SPACE ) {
           return;
       }
       
       if ( c == KeyEvent.VK_ENTER ) {
          int i = getValue();
          setValue( i );
          return;
       }
       
       event.consume();
    }
    
    private PropertyChangeSupport changes = new PropertyChangeSupport( this );
    private int prev = 0;
    
}

