package javabook.smiley;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

public class IntBox3 extends TextField
                implements Serializable {

    public IntBox3() {
       super();
       addKeyListener( myKeyAdapter );  
   }

    // 0-val tr vissza, ha nem tudja kiparse-olni a textfield rtkt
    public int getValue() {
       int i;
       try {
          i = Integer.parseInt( getText() );
          return i;
       } catch ( NumberFormatException e ) {
          return 0;
       }
   }

    public void setValue( int value ) {
       int oldValue = prev;
       setText( Integer.toString( value ) );
       int newValue = getValue();
       
       changes.firePropertyChange("value", 
                           new Integer( oldValue ), 
                           new Integer( newValue ) );
       prev = newValue;
    }

    public void addPropertyChangeListener(PropertyChangeListener l) {
       changes.addPropertyChangeListener(l);
    }

    public void removePropertyChangeListener(PropertyChangeListener l) {
       changes.removePropertyChangeListener(l);
    }



    //----------------------------------------------------------------------
    // Privt adatmezk:

    private PropertyChangeSupport changes = new PropertyChangeSupport( this );
    private int prev = 0;
    private MyKeyAdapter myKeyAdapter;

    class MyKeyAdapter extends KeyAdapter {

       public void keyPressed( KeyEvent event ) {
          char c = event.getKeyChar();
          System.out.println( c );

           if ( ( c >= '0' && c <= '9' ) ||
               c == KeyEvent.VK_DELETE ||
               c == KeyEvent.VK_BACK_SPACE ) {
               return;
           }

           if ( c == KeyEvent.VK_ENTER ) {
              int i = getValue();
              setValue(i);
              return;
           }
           event.consume();
        }

    }

}

