/***** Java Chat Program - Felhasznli fellet                 *****/
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.rmi.*;
import java.util.Hashtable;
import java.util.Enumeration;

public class JavaChat extends Applet    /* Java Chat applet.        */
     implements ActionListener, TextListener   {

     /***
        * Az appleten tallhat ablakelemek.
        ***/
     private TextArea  Uzenetek;        /* A beszlgets folysa.   */
     private List      Tarsak;          /* A rsztvevk listja.    */
     private TextField Uzenet;          /* A kldend zenet.       */
     private Button    Kuldes;          /* Az zenet elkldse.     */
     private TextField SajatNev;        /* A felhasznl neve.      */
     private Button    Belepes;         /* Nyomgomb a belpshez.  */
     private Button    Kilepes;         /* Nyomgomb a kilpshez.  */

     private RMIChatClientIf Kli;       /* Kliensoldali kommunikci */
     private RMIChatServerIf Srv;       /* Szerveroldali kommunikci */
     private static String hn;          /* Chatszerver szmtgp neve */

/***
   * Az applet konstruktora.
   * Ltrehozza a szksges felletelemeket.
   ***/
public JavaChat()   {                   /* Konstruktormetdus       */
     super();                           /* rkltt konstruktor hvsa. */
     /* Nem lltunk be LayoutManagert, mert az ablakban minden     */
     /* komponenst kzzel helyeznk el s mreteznk a setBounds    */
     /* metdus segtsgvel.                                       */
     setLayout(null);                   /* Nincs LayoutManager.     */
     setSize(400,355);                  /* tmretezi az appletet.  */

     /* Ltrehozza az ablakon tallhat komponenseket.              */
     /* A fogadott zeneteket megjelent szvegdoboz.              */
     Uzenetek = new TextArea();         /* Ltrehozza, felrakja az  */
     add(Uzenetek);                     /* ablakra s elhelyezi a   */
     Uzenetek.setBounds(5,5,290,260);   /* fogadott zenetek dobozt*/
     Uzenetek.setEditable(false);       /* A szveg csak olvashat. */

     /* A beszlgetsben rsztvevk nevt megjelent lista.        */
     Tarsak = new List();               /* Ltrehozza, felrakja az  */
     add(Tarsak);                       /* ablakra s elhelyezi a   */
     Tarsak.setBounds(300,5,95,260);    /* rsztvevk listjt.     */

     /* Felirat a felhasznl zenett bekr szvegdoboz fltt.   */
     Label L = new Label("zenet:");    /* Ltrehoz egy feliratot,  */
     add(L);                            /* s felrakja az appletre. */
     L.setBounds(5,270,290,20);         /* A felirat mretezse.    */

     /* A felhasznl zeneteit bekr szvegmez.                  */
     Uzenet = new TextField();          /* Ltrehozza, felrakja az  */
     add(Uzenet);                       /* ablakra s elhelyezi az  */
     Uzenet.setBounds(5,290,290,30);    /* zenetbekr szvegmezt.*/
     Uzenet.setEnabled(false);          /* A belpsig nem zenhet. */
     /* Regisztrlja az objektumot az editor esemnyfigyeljnek,   */
     /* hogy rzkeljk a szveg megvltozst, gy res zenet-    */
     /* editor esetn le tudjuk tiltani a klds gombot, ha akarjuk */
     /* Megjegyzs: a tnyleges implementciban megengedjk res   */
     /* sorok elkldst is, amit ignyeink szerint letilthatunk.   */
     /* A programban a szerver szri ki az res sorokat.            */
     
     Uzenet.addTextListener(this);      /* Szvegvltozs figyelse.*/
     Uzenet.addActionListener(this);    /* Return bill. figyelse.  */ 

     /* Az zenet elkldsre szolgl nyomgomb.                   */
     Kuldes = new Button("Klds");     /* Ltrehozza, felrakja az  */
     add(Kuldes);                       /* ablakra s elhelyezi az  */
     Kuldes.setBounds(305,293,85,25);   /* zenetkld nyomgombot. */
     Kuldes.setEnabled(false);          /* A belpsig nem zenhet. */
     /* Regisztrlja az objektumot esemnyfigyelnek, hogy reaglni */
     /* tudjon a nyomgomb lenyomsra.                             */
     Kuldes.addActionListener(this);    /* Return bill. figyelse.  */

     /* A felhasznl becenevnek bekrsre szolgl szvegmez.   */
     SajatNev = new TextField();        /* Ltrehozza, felrakja az  */
     add(SajatNev);                     /* ablakra s elhelyezi a   */
     SajatNev.setBounds(5,322,200,30);  /* nvbekr szvegmezt.   */
     SajatNev.addTextListener(this);    /* Szvegvltozs figyelse.*/

     /* A felhasznl bejelentkezsre szolgl nyomgomb.          */
     Belepes = new Button("Belps");   /* Ltrehozza, felrakja az  */
     add(Belepes);                      /* ablakra s elhelyezi a   */
     Belepes.setBounds(210,325,85,25);  /* belps-nyomgombot.     */
     Belepes.addActionListener(this);   /* Gomblenyoms figyelse.  */
     Belepes.setEnabled(false);         /* Be kell rni valami nevet*/

     /* A felhasznl kijelentkezsre szolgl nyomgomb.          */
     Kilepes = new Button("Kilps");   /* Ltrehozza, felrakja az  */
     add(Kilepes);                      /* ablakra s elhelyezi a   */
     Kilepes.setBounds(305,325,85,25);  /* kilps-nyomgombot.     */
     Kilepes.setEnabled(false);         /* Amg a felhasznl nem   */
     /* lpett be, addig kilpni sem lehet a beszlgetsbl.        */
     Kilepes.addActionListener(this);   /* Gomblenyoms figyelse.  */
} /* JavaChat() */

/***
   * Billentyzet fkusz belltsa a program elejn a becenv mezre
   ***/
public void kezdeti_focus()             /* Kezdetben a felhasznl  */
{                                       /* beceneve kell, oda ir-  */
  SajatNev.requestFocus();              /* nytjuk a fkuszt, ezrt */
} /* kezdeti_focus() */                 /* a felhasznl oda r ... */

/***
   * Ltrehozzuk a hlzati kommunikcit megvalst objektumot
   ***/
private void com_init(boolean applet_e) /* Kommunikcis objektum   */
{                                       /* inicializlsa           */
     try {
       if (applet_e)                    /* Appleteknl ahhoz a szer-*/
       {                                /* verhez kapcsoldunk,     */
         hn=getCodeBase().getHost();    /* ahonnan letltttek ...  */
         if (hn == null) 
         {
           System.err.println("Chatszerver host alaprtelmezs: localhost");
           hn="localhost";              /* Prba-szerencse :)       */
         }
       }
       Kli=RMIChatClient.init(this,applet_e); /* Ltrehozzuk a kliensoldali */
                                              /* kommunikcis objektumot   */
       Srv=(RMIChatServerIf) Naming.lookup("rmi://"+hn+"/DefaultChatSzoba");
                                              /* Megkerestk a szerveroldali*/
                                              /* kommunikcis objektumot   */
     } catch (java.lang.Exception e) 
     {
       System.err.println("Szerveroldal nem rhet el, vrj amg elindul!");
     }
} /* com_init() */

/***
   * A nyomgombok lenyomsra (akciesemny) reagl metdus.
   * Az Uzenet mezben a Return billenty lenyomsnak kezelse is itt van.
   ***/
public void actionPerformed(ActionEvent e)   {
     Object src = e.getSource();        /* Ezt a gombot nyomtk le. */
     if ((src==Kuldes)||(src==Uzenet))  /* Az zenet elkldse.     */
     {
        /* A klds nyomgomb lenyomsra elkldi a begpelt ze- */
        /* netet, s trli az zeneteditor tartalmt.             */
        String uzenet = Uzenet.getText();       /* Az zenet.     */
        Uzenet.setText("");           /* Trli a szvegmezt.     */
        Uzenet.requestFocus();        /* Fkusz ismt Uzenet-re   */
        try {
         int resztvevok_szama = 
           Srv.uzenetFogadas(SajatNev.getText(),uzenet); /*zenetet kld ...*/
         /* Ha a rsztvevk szma vltozott (pl. kiesett valaki), */
         /* akkor jra feltltjk a listaobjektumot a szerverrl. */
         if (resztvevok_szama != Tarsak.getItemCount())
         {
           /* Valoszinuleg valaki bontott ... tarsak nevet ujraallitja */
           Hashtable ujlista=Srv.nevlistaSzinkronizalas();
           Tarsak.removeAll();           /* Trli a nevek listjt.  */
           Enumeration rvEnum=ujlista.keys();
           while (rvEnum.hasMoreElements()) {
             String rnev=(String) rvEnum.nextElement();
             Tarsak.add(rnev);
           }
         }
        } catch (java.rmi.RemoteException ex) {
         System.err.println("Komoly hiba trtnt - szerver elrhetetlen!");
        }
     } else if (src==Belepes) {       /* Bejelentkezs-gomb.   */
        SajatNev.setEnabled(false);   /* A kvetkez kilpsig    */
        Belepes.setEnabled(false);    /* nem lehet jra belpni.  */
        Kilepes.setEnabled(true);     /* Most mr szabad kilpni. */
        Uzenet.setEnabled(true);      /* Most mr rhat zenetet. */
        Uzenet.requestFocus();        /* csb                      */
        /* Felveszi a felhasznl nevt a beszlgetk listjba.  */
        /* Bejelentkezs a chatszerverhez                         */
        try {
         Srv.tarsBelepes(SajatNev.getText(),Kli);
        } catch (java.rmi.RemoteException ex) {
         System.out.println("Komoly hiba trtent - szerver elerhetetlen:"+ex);
        }
     } else if (src==Kilepes)   {     /* Kijelentkezs-gomb.      */
        SajatNev.setEnabled(true);    /* Most mr jra be lehet   */
        Belepes.setEnabled(true);     /* lpni (ms nvvel is).   */
        Kilepes.setEnabled(false);    /* Most nem szabad kilpni. */
        Uzenet.setEnabled(false);     /* Nem lehet zenetet rni  */
        Kuldes.setEnabled(false);     /* s kldeni.              */
        Uzenet.setText("");           /* Kirti a szvegmezt.   */
        Tarsak.removeAll();           /* Trli a nevek listjt.  */
        /* Kijelentkezs a chatszerverbl                         */
        try {
         Srv.tarsKilepes(SajatNev.getText());
        } catch (java.rmi.RemoteException ex) {
         System.out.println("Komoly hiba trtnt - szerver elrhetetlen!");
        }
     }
} /* actionPerformed() */

/***
   * Az editorok szvegnek megvltozsra reagl metdus.
   * Az editor tartalmt felhasznl nyomgomb (pl: bejelenkezs
   * a megadott nven vagy egy zenet elkldse) csak akkor
   * engedlyezett, ha az editor szvege nem res.
   ***/
public void textValueChanged(TextEvent e)   {
     Object src = e.getSource();        /* Ez az editor vltozott.  */
     if (src==Uzenet)   {               /* Az elkldend zenet.    */
          String uzenet = Uzenet.getText();
          boolean ures = uzenet.equals("");
          Kuldes.setEnabled(!ures);
     } else if (src==SajatNev)   {      /* A felhasznl neve.      */
          String uzenet = SajatNev.getText();
          boolean ures = uzenet.equals("");
          Belepes.setEnabled(!ures);
     }
} /* textValueChanged() */

/***** A kommunikcis modul az albbi hrom eljrst hvja meg.*****/

/***
   * Egy j zenet rkezett a "nev" nev felhasznltl.
   ***/
public void uzenetFogadas(String nev, String szoveg)   {
     /* Hozzadja az zenetek szvegdobozhoz az j zenetet.       */
     /* Az j zenet utn egy soremels is kerl a szvegbe.        */
     Uzenetek.append(nev+": "+szoveg+"\n");
} /* uzenetFogadas() */

/***
   * Egy j beszlgettrs belpse.
   * Az j belp nevt felveszi a beszlgettrsak listjba.
   ***/
public void tarsBelepes(String nev)   {
     Tarsak.add(nev);         /* Berakja a listba az j nevet.     */
} /* tarsBelepes() */

/***
   * Egy beszlgettrs kilpse. Trli a nevet a listbl.
   ***/
public void tarsKilepes(String nev)   {
     try   {                  /* Eltvoltja a listbl a megadott  */
          Tarsak.remove(nev); /* elemet.                            */
     }
     catch (Exception E)   {  /* A remove mvelet kivtelt vlthat, */
          System.err.println(E);        /* a kivtelt kirjuk a     */
     }                                  /* szabvnyos hibakimenetre.*/
} /* tarsKilepes() */

/***
   * Appleteknl a kommunikcis modul inicializlst itt vgezzk el.
   ***/
public void init()
{
  com_init(true);
} /* init() */

/***
   * Alkalmazsknt indtja el a programot.
   * Ltrehoz egy  ablakot, s felrak r egy JavaChat appletet.
   ***/
public static void main(String arg[])   {
     hn="localhost";
     if (arg.length > 0)
     {
       hn=arg[0]; /* Ha megadtak egy chatszervert a parancssorba, oda megynk */
     }
     Frame Ablak = new Frame("Java Chat");  /* Ltrehoz egy ablakot.*/
     Ablak.setBounds(50,50,410,385);    /* Az ablak helye s mrete.*/
     JavaChat jco=new JavaChat();       /* Ltrehoz egy appletet.   */
     Ablak.add(jco);                    /* Beteszi az ablakba.      */
     jco.com_init(false);               /* Kommunikcis modul inic.*/
     Ablak.setVisible(true);            /* Megjelenti az ablakot.  */
     jco.kezdeti_focus();               /* Becenv beadst vrja.  */
} /* main() */
}
