/***** Java Chat Program - Kommunikcis objektum/kliensoldal  *****/

import java.rmi.Naming;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.util.*; 

public class RMIChatClient extends UnicastRemoteObject 
                                     implements RMIChatClientIf {

  private JavaChat kepernyo = null;   /* Felhasznli fellet obj.   */

  /***
     * Konstruktormeddus.
     ***/
  private RMIChatClient(JavaChat jc) throws java.rmi.RemoteException {
    super();                    /* Ez exportlja a tvoli objektumot */
    kepernyo=jc;                /* Eltrolja a megjelentst vgz   */
  } /* RMIChatClient() */       /* JavaChat objektum referencijt.  */

  public void uzenetFogadas(String nev, String szoveg) 
              throws java.rmi.RemoteException 
  {
    kepernyo.uzenetFogadas(nev,szoveg); /* Kirjuk a felh. felletre */
  }

  public void tarsBelepes(String nev) throws java.rmi.RemoteException
  {
    kepernyo.tarsBelepes(nev); /* Meghvjuk a felh. fellet metdust */
  }

  public void tarsKilepes(String nev) throws java.rmi.RemoteException
  {
    kepernyo.tarsKilepes(nev); /* Meghvjuk a felh. fellet metdust */
  }

  public void kirugtak() throws java.rmi.RemoteException
  {
    System.err.println("Kirgtak a csetbl, a program lell ...");
    System.exit(-1);
  }

  /***
     * Ezzel a metdussal hozunk ltre egy kliensoldali kommunikcis
     * objektumot. 
     * Nem applet alkalmazsnl installljuk az RMI biztonsgi
     * felgyeljt (appleteknl a bngszben mr van ilyen, gy
     * ez a mvelet ott nem futna le).
     ***/
  public static RMIChatClientIf init(JavaChat jc, boolean applet_e) {
    if (!applet_e) // Appleteknl mr van securitymanager ...
    {
      System.setSecurityManager(new RMISecurityManager());
    }
    try {
      RMIChatClient k = new RMIChatClient(jc);
      return k;
    } catch (Exception e) {
      System.out.println("ChatSzerver nem elrhet ...");
      System.out.println("Hiba oka:"+e.getMessage());
    }
    return null;
  }
}
