//                                                                    //
//                    Kliens-szerver Demo, 1999-2001.                 //
//                                                                    //
//            Ksztette: Fodor Szabina s Gulys Lszl              //
//                                                                    //
//                                                                    //
//    Ez a program nagyon egyszer kliens-applet a kapcsolatpts    //
//    bemutatshoz.                                                  //
//                                                                    //

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

public class Client extends JApplet implements ActionListener {

//  Vltozk definilsa
    // Szvegmezk
    private JTextField     nameField;  // A felhasznli nv beviteli mezje
    private JPasswordField passField;  // A jelsz beviteli mezje
    private JTextArea      infoField;  // A kliens tjkoztat mezje

    // Cimkk
    private JLabel     nameLabel;  // A nv cimkje
    private JLabel     passLabel;  // A jelsz cimkje 
    private JLabel     infoLabel;  // A tjkoztatmez cimkje 
    
    // Nyomgombok
    private JButton    logButton;  // A Ki/Bejelentkezs gombja

    // A hlzati kapcsolat felptshez szksges vltozk
    // A kapcsolatban rsztvev szerver megadsa
    private String      serverHost  = "localhost";
    private Socket    clientSocket  = null;    // A hlzati kapcsolat objektuma
    private PrintWriter         os  = null;    // A kapcsolattarts csatorni:
    private BufferedReader      is  = null;    // input- s outputstream
//  A felhasznli felletel kapcsolatos metdusok    
  // Az applet indtsa
    public void init()  {
        // A pakolsi stratgia ltrehozsa s belltsa
        GridBagLayout      gridbag     = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        setFont(new Font("TimesRoman", Font.BOLD, 14));
        getContentPane().setLayout(gridbag);
        constraints.anchor  = GridBagConstraints.WEST;
        constraints.weighty = 0.0;

        // 'nv' cimke s szvegmez elksztse
        nameLabel = new JLabel("Nv : ", Label.LEFT);
        nameField = new JTextField(20);
        constraints.gridwidth = 1;
        constraints.weightx   = 0.1;
        addFormComponent(gridbag, nameLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        addFormComponent(gridbag, nameField, constraints);
 
        // 'jelsz' cimke s szvegmez elksztse
        passLabel = new JLabel("Jelsz : ", Label.LEFT);
        passField = new JPasswordField(20);
        passField.setEchoChar('#');
        constraints.gridwidth = 1;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        constraints.weightx   = 0.1;
        addFormComponent(gridbag, passLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, passField, constraints);
 
        // 'zenetek' szvegmez elhelyezse
        infoLabel = new JLabel("zenetek:", Label.LEFT);
        infoField = new JTextArea(5,40);
        infoField.setEditable(false);
        constraints.gridwidth = 1;
        constraints.weightx   = 0.1;
        constraints.weighty   = 0.1;
        constraints.fill      = GridBagConstraints.NONE;
        addFormComponent(gridbag, infoLabel, constraints);
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.7;
        addFormComponent(gridbag, infoField, constraints);
 
        // A 'Bejelentkezs' gomb elksztse
        logButton = new JButton( "BEJELENTKEZS",
                                 new ImageIcon("Icon.gif")
                               );
        logButton.addActionListener(this);
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.5;
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridheight= GridBagConstraints.REMAINDER;        
        constraints.gridx     = 1;
        constraints.gridwidth = GridBagConstraints.REMAINDER;     
        addFormComponent(gridbag, logButton, constraints);
        resize(500, 350);    
    }
  // Segdeljrs a komponensek kpernyre helyezshez   
    private void addFormComponent( GridBagLayout grid, Component comp, 
                                   GridBagConstraints c )  {
        grid.setConstraints(comp, c);
        getContentPane().add(comp);
    }
  // Informci az appletrl
    public String getAppletInfo() {
        return "Az egyszer kliens-szerver demo kapcsolatfelpt appletje.";
    }
  // Informci az applet paramtereirl
    public String[][] getParameterInfo() { return null; }
  // Esemnyek kezelse
    public void actionPerformed(ActionEvent event)  {
          // Melyik gomb volt? A megfelel kezeleljrs hvsa
          if (event.getSource() == logButton)  {
             log();
          } 
    }
  // Be- es kijelentkezs
    private void log()  {
        // A rendszerzenetek trlse
        infoField.setText("");
           
        // A kapcsolat felptse
        try{ clientSocket = new Socket(serverHost, 1234);
             os = new PrintWriter(clientSocket.getOutputStream());
             is = new BufferedReader(new InputStreamReader(
                  clientSocket.getInputStream()));
           } // A lehetsges hibk lekezelse
           catch (UnknownHostException e)  {
               infoField.append("Ismeretlen szerver\n");
           } 
           catch (IOException e)  {
               infoField.append("A szerver nem elrhet\n");
           }              
        // Ha minden rendben, akkor folytatjuk
        if (clientSocket != null && is != null && os != null) {
           try{ infoField.append("Kliens: Els zenet\n");
                os.println("Kliens: Els zenet"); os.flush();
                String fromServer = is.readLine();
                infoField.append( "A vlasz r: " + fromServer + "\n");
              } // A lehetsges hibk lekezelse
              catch (IOException e) {
                  infoField.append("A kapcsolat megszakadt\n");
              }
           closeSocket();
        }    
    }
  // A kapcsolat lezrsa
    private void closeSocket() {
        try{ // A csatornk lezrsa
             os.close();
             is.close();
             clientSocket.close();    
        } catch (Exception e) {
             infoField.append("Hiba a kapcsolat lezrsnl\n");
          } finally {// A kapcsolat vltozjnak trlse 
              clientSocket = null;     
              infoField.append("A kijelentkezs megtrtnt\n");        
            }
    }
} 
