//                                                                      //
//                   Kliens-szerver Demo, 1999-2001.                    //
//                                                                      //
//            Ksztette: Fodor Szabina s Gulys Lszl                //
//                                                                      //
//                                                                      //
// A demoprogram egy egyszer kliens-szerver alkalmazs. A szerver      //
// a felhasznl azonostsa (vagy az j felhasznl felvtele) utn    //
// kpes egy szvegfajl tovbbtsra, illetve annak megadsra, hogy   //
// ez a felhasznl lekrdezte-e mr az adott fjlt.                    //

//  Az alkalmazs kliensoldala
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import javax.swing.*;

//  Az 'adatbzis'-kliens applet osztlya
//  A felhasznl egy egyszer felleten keresztl berhatja
//  nevt s jelszavt, majd bejelentkezhet a szerverre az 1234-es porton.
//  A bejelentkezs utn az appletben egy checkbox jelzi,
//  hogy az adott felhasznl olvasta-e mr a szerver aktulis
//  zenett, amit - e jelzstl fggetlenl - a felhasznl
//  egy gombnyomssal megjelenthet.
//  Az applet folyamatosan informlja felhasznljt az ppen
//  vgrehajtott folyamatokrl.
public class Client extends JApplet implements ActionListener {

// Vltozk definilsa
    // Szvegmezk
    private JTextField     nameField;   // A felhasznli nv beviteli mezje
    private JPasswordField passField;   // A jelsz beviteli mezje
    private JTextArea      infoField;   // A kliens tjkoztat mezje
    private JTextArea      frameText;   // A szerver zenett megjelent mez

    // Cimkk
    private JLabel     nameLabel;   // A nv cimkje
    private JLabel     passLabel;   // A jelsz cimkje
    private JLabel     infoLabel;   // A tjkoztatmez cimkje

    // Checkbox-ok
    private JCheckBox  changeField; // A vltozs (olvasta-e mr) checkbox

    // Nyomgombok
    private JButton    logButton;   // A Ki/Bejelentkezs gombja
    private JButton    showButton;  // A Megmutats/Elrejts gombja

    // Frame-ek
    private JFrame     frameField;  // A szervertl rkez zenetet
                                    // megjelent  ablak (frame)

    // A hlzati kapcsolat felptshez szksges vltozk
    // A kapcsolatban rsztvev szerver megadsa
    private String   serverHost = "localhost";
    private Socket clientSocket = null;  // A hlzati kapcsolat objektuma
    private PrintWriter     os = null;   // A kapcsolattarts csatorni:
    private BufferedReader  is = null;   // input- s outputstream

// A felhasznli felletel kapcsolatos metdusok
    //    A kliens indtsa
    public void init()  {
        // A pakolsi stratgia ltrehozsa s belltsa
        GridBagLayout      gridbag     = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        setFont(new Font("TimesRoman", Font.BOLD, 14));
        getContentPane().setLayout(gridbag);
        constraints.anchor  = GridBagConstraints.WEST;
        constraints.weighty = 0.0;

        // 'nv' cimke s szvegmez elksztse
        nameLabel = new JLabel("Nv : ", Label.LEFT);
        nameField = new JTextField(20);
    	nameField.setToolTipText("A nv bevitelre szolgl mez.");
        constraints.gridwidth = 1;
        constraints.weightx   = 0.1;
        addFormComponent(gridbag, nameLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        addFormComponent(gridbag, nameField, constraints);

        // 'jelsz' cimke s szvegmez elksztse
        passLabel = new JLabel("Jelsz : ", Label.LEFT);
        passField = new JPasswordField(20);
        passField.setEchoChar('#');
    	passField.setToolTipText("A jelsz bevitelre szolgl mez.");
        constraints.gridwidth = 1;
        constraints.fill      = GridBagConstraints.NONE;
        constraints.weightx   = 0.1;
        addFormComponent(gridbag, passLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, passField, constraints);

        // 'Vltozs' checkbox
        changeField = new JCheckBox("j zenet");
        changeField.setEnabled(false);
	changeField.setToolTipText("Olvastuk-e mr a szerver zenett.");
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag,changeField, constraints);

        // 'zenetek' szvegmez elhelyezse
        infoLabel = new JLabel("zenetek:", Label.LEFT);
        infoField = new JTextArea(5,40);
        infoField.setEditable(false);
	infoField.setToolTipText("A program zenetei.");
        constraints.gridwidth = 1;
        constraints.weightx   = 0.1;
        constraints.weighty   = 0.1;
        constraints.fill      = GridBagConstraints.NONE;
        addFormComponent(gridbag, infoLabel, constraints);
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.7;
        addFormComponent(gridbag, infoField, constraints);

        // A 'Megmutat/Elrejt' s a 'Bejelentkezs/Kijelentkezs'
        // gomb elksztse
        logButton = new JButton( "BEJELENTKEZS",
                                 new ImageIcon("Icon.gif")
                               );
	logButton.setToolTipText( "A szerverhez fzd kapcsolat " +
                                  "felvtele, illetve lebontsa." );
        logButton.addActionListener(this);
        showButton = new JButton( "MEGMUTAT", 
                                  new ImageIcon("Icon1.gif")
                                );
	showButton.setToolTipText( "A szerver zenetnek kijelzse, " +
                                   "illetve elrejtse." );
        showButton.addActionListener(this);
        showButton.setEnabled(false);
        constraints.gridwidth = 1;
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.5;
        constraints.gridx     = 0;
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridheight= GridBagConstraints.REMAINDER;
        addFormComponent(gridbag, showButton, constraints);
        constraints.gridx     = 1;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        addFormComponent(gridbag, logButton, constraints);

        // Az zenetmegjelent frame elksztse
        frameText = new JTextArea();
	frameText.setEditable(false);
        frameField = new JFrame("jdonsgok");
        frameField.setSize(500, 300);
        frameField.getContentPane().add("Center", frameText);
        resize(500, 350);
    }
  // Segdeljrs a komponensek kpernyre helyezshez
    private void addFormComponent( GridBagLayout grid, Component comp,
                                   GridBagConstraints c )  {
        grid.setConstraints(comp, c);
        getContentPane().add(comp);
    }
  // Informci az appletrl
    public String getAppletInfo() {
        return "Az egyszer kliens-szerver demo vgleges kliens appletje.";
    }
  // Infromci az applet paramtereirl
    public String[][] getParameterInfo() {
        return null;
    }
  // Esemnyek kezelse
    public void actionPerformed(ActionEvent event)  {
         // Melyik gomb volt? A megfelel kezeleljrs hvsa
         if (event.getSource() == logButton) log();
         else if (event.getSource() == showButton) handleMessage();
    }
  // Az applet lezrsa
    public void destroy() {
        // A kapcsolat lezrsa (amennyiben volt)
        if (clientSocket != null)   closeSocket();
    }
  // Be- es kijelentkezs
    private void log()  {
        // Van mr mkd kapcsolat?
        if (clientSocket == null)  {
        // Ha nem, akkor ltrehozzuk s bejelentkeznk
            boolean ok = false;
            // A rendszerzenetek trlse
            infoField.setText("");
            // A kapcsolat felptse
            try{ clientSocket = new Socket(serverHost, 1234);
                 os = new PrintWriter(clientSocket.getOutputStream());
                 is = new BufferedReader(new InputStreamReader(
                      clientSocket.getInputStream()));
               } catch (UnknownHostException e)  {
                     infoField.append("Ismeretlen szerver\n");
               } catch (IOException e)  {
                     infoField.append("A szerver nem elrhet\n");
                 }
            if (clientSocket != null && is != null && os != null) {
                try{ ok = logOn(); // Bejelentkezs
                   } catch (EmptyFieldException e) {
                         infoField.append("Kitltetlen beviteli mez\n");
                   } catch (SystemErrorException e) {
                         infoField.append("Rendszerhiba: " +
                               e.getMessage() + "\n");
                   } catch (NullPointerException e) {
                         infoField.append("A kapcsolat megszakadt\n");
                     }
                // Sikeresen bejelentkeztnk?
                if (ok)  {
                    // Ha igen, akkor..
                    infoField.append("A bejelentkezs megtrtnt\n");
                    // A 'Megmutat' gomb hasznlhat
                    showButton.setEnabled(true);
                    // A 'Ki/Bejelentkezs' gomb szvegnek cserje
                    logButton.setText("KIJELENTKEZS");
                    // Olvasta mr a felhasznl a szerver zenett?
                    try{ changeField.setSelected(isNewMessage());
                    } catch (SystemErrorException e) {
                      infoField.append("Rendszerhiba: " +e.getMessage()+"\n");
                      closeSocket();
                      }
                }
                // Ha nem, akkor lezrjuk a kapcsolatot
                else   closeSocket();
            }
        }
        else   // Ha mr volt kapcsolat, akkor megprbljuk bezrni
            try{ closeSocket();
               } catch (Exception e)  {
                     infoField.append("Nincs lezrhat kapcsolat\n");
                 }
    }
  // A kapcsolat lezrsa
    private void closeSocket() {
        try{ // A zrzenet elkldse a szerver fel
             os.println("BYE"); os.flush();
             os.close();   // A csatornk lezrsa
             is.close();
             clientSocket.close();
           } catch (Exception e) {
                 infoField.append("Hiba a kapcsolat lezrsnl\n");
             } finally {
                // A kapcsolat vltozjnak trlse
                // (ez alapjn dntjk el, hogy van-e l kapcsolat)
                clientSocket = null;
                // A 'Ki/Bejelentkezs gomb visszalltsa
                logButton.setText("BEJELENTKEZS");
                // Ha az zenetablak aktv, akkor eltntetjk
                // s a 'Megmutat' gomb szvegt lecserljk
                if (frameField.isShowing()) {
                  showButton.setText("MEGMUTAT");
                  frameField.setVisible(false);
                 }
                 // A 'Megmutat' gomb zemen kvl helyezse
                 showButton.setEnabled(false);
                 // Az 'olvasta-e mr' checkbox hamisra lltsa
                 changeField.setSelected(false);
                 // A tjkoztat szveg kirsa
                 infoField.append("A kijelentkezs megtrtnt\n");
               }
    }
  // Bejelentkezs a szerverre
    private boolean logOn() throws SystemErrorException,
              NullPointerException, EmptyFieldException {
        String name = nameField.getText();      // A bevitt felhasznli nv
        String pass = new String (              // A bevitt jelsz
                        passField.getPassword()
                      ); 
        boolean  ok = false;                // Sikeres bejelentkezs?
        try{ // Az 'USER nv' parancs elkldse s a vlasz leolvassa
             os.println("USER " + name); os.flush();
             String fromServer = is.readLine();
             // A vlasz rtelmezse
             if (fromServer.compareTo("##NEW") == 0)  {
                 // j felhasznl
                 infoField.append("j felhasznl\n");
                 // Elkldjk a jelszavt is a 'PSWD jelsz'
                 // paranccsal s leolvassuk a vlaszt
                 os.println("PSWD " + pass); os.flush();
                 fromServer = is.readLine();
                 // Ha valamilyen hibazenet jtt, akkor tovbbadjuk,
                 // hogy jelezhessk a felhasznlnak
                 if (fromServer.compareTo("##EMPTY FIELD") == 0)
                     throw new EmptyFieldException();
                 else if (fromServer.compareTo("##OK") != 0)
                     throw new SystemErrorException(1);
                 ok = true;  // sikeres bejelentkezs
             }
             // Ha valamilyen hibazenet jtt, akkor tovbbadjuk,
             // hogy jelezhessk a felhasznlnak
             else if (fromServer.compareTo("##EMPTY FIELD") == 0)
                 throw new EmptyFieldException();
             else if (fromServer.compareTo("##KNOWN") != 0)
                 throw new SystemErrorException(2);
             // Ha nincs hiba s nem j felhasznl, akkor
             // jelszellenrzs is lesz...
             else { // Elkldjk a jelszt a 'PSWD jelsz'
                    // paranccsal s leolvassuk a vlaszt
                 os.println("PSWD " + pass); os.flush();
                 fromServer = is.readLine();
                 // Helyes jelsz volt?
                 if (fromServer.compareTo("##OK") == 0)
                     //Ha igen, akkor sikeres bejelentkezs
                     ok = true;
                 // Ha nem, akkor jelezzk
                 else if (fromServer.compareTo("##BAD") == 0)
                     infoField.append("Rossz jelsz\n");
                 // Ha res jelsz volt, akkor tovbbtjuk az zenetet
                 else if (fromServer.compareTo("##EMPTY FIELD") == 0)
                     throw new EmptyFieldException();
                 // Ha egyb zenet jtt, akkor a kommunikcis
                 // csatorna vagy a szerver srlt
                 else throw new SystemErrorException(3);
             }
           } // Ha nem tudtunk olvasni a csatornrl, akkor
             // a kommunikcis csatorna srlt
             catch (IOException e) {
                 throw new SystemErrorException(4);
             }
        // Visszaadjuk, hogy volt-e sikeres bejelentkezs
        return ok;
    }
  // j zenet ltnek lekrdezse
    private boolean isNewMessage() throws SystemErrorException {
        try{ // Az 'ASK' zenet elkldse s a vlasz leolvassa
             os.println("ASK"); os.flush();
             String fromServer = is.readLine();

             // Ha '##YES' vagy '##NO' jtt, akkor rtelmezzk
             if ( (fromServer.compareTo("##YES") == 0) ||
                  (fromServer.compareTo("##NO") == 0) )    {
                // rtelmezzk a vlaszt s tovbbadjuk az eredmnyt
                return (fromServer.compareTo("##YES") == 0);
             }
             // Ha ms zenet jtt, akkor a kommunikcis
             // csatorna, vagy a szerver srlt
             else throw new SystemErrorException(5);
           } // Ha nem tudtunk olvasni, akkor a kommunikcis csatorna srlt
             catch (IOException e) {
                 throw new SystemErrorException(6);
             }
    }
  // Az zenetlekrdezs megvalstsa
    private void handleMessage() {
        // A szervertl kapott zenet egy sora
        String fromServer;

        // Mr megjelentettk az zenetet?
        if (frameField.isShowing()) {
           // Ha igen, akkor..
           // A 'Megmutat' gomb szvegnek cserje
           showButton.setText("MEGMUTAT");
           // Az zenet elrejtse
           frameField.setVisible(false);
        }
        // Ha nem, akkor
        else { // A 'Megmutat' gomb szvegnek cserje
            showButton.setText("ELREJT");
            // Az zenetablak megjelentse
            frameField.show();
            try{ // A 'GET' zenet elkldse s a vlasz leolvassa
                 os.println("GET"); os.flush();
                 fromServer = is.readLine();
                 // Ha hibazenet, akkor jelezzk s visszalltjuk
                 // a fellet megvltoztatott elemeit
                 if (fromServer.compareTo("##NOT FOUND") == 0) {
                     infoField.append("Szerver hiba: az adatllomny " +
                             "nem elrhet.\n");
                     showButton.setText("MEGMUTAT");
                     frameField.setVisible(false);
                 }
                 // Ha nem a vrt zenet, akkor a kommunikcis
                 // csatorna vagy a szerver srlt
                 else if (fromServer.compareTo("##START") != 0)
                     throw new SystemErrorException(7);
                 // Ha elkezddtt a szerver adsa, akkor fogadjuk
                 else { // Trljk a megjelent mezt
                     frameText.setText("");

                     // Az els sor fogadsa
                     fromServer = is.readLine();

                     // Amg nem lezrs, addig olvasunk
                     while (fromServer.compareTo("##STOP") != 0)  {
                         // Ha hibs adat jtt, akkor jelezzk
                         if (fromServer.compareTo("##READ ERROR") == 0)
                             infoField.append("Olvassi hiba " +
                                          "a szerveren\n");
                         // Ha nem, akkor kirjuk
                         else frameText.append(fromServer + "\n");
                             // A kvetkez sor olvassa
                             fromServer = is.readLine();
                     }
                     // Az 'olvasta-e mr' checkbox tlltsa
                     changeField.setSelected(false);
                 }
               } // Ha nem tudtunk olvasni, akkor jelezzk
                 // s lezrjuk a kapcsolatot
                 catch (NullPointerException e) {
                     infoField.append("A kapcsolat megszakadt\n");
                     closeSocket();
               } catch (IOException e) {
                     infoField.append("A kapcsolat megszakadt\n");
                     closeSocket();
               } // Ha rendszerhiba volt, akkor jelezzk
                 catch (SystemErrorException e) {
                    infoField.append("Rendszerhiba: " +
                           e.getMessage() + "\n");
                    closeSocket();
                 }
        }
    }
}

//  A 'Rendszerhiba' kivtel definilsa
class SystemErrorException extends Exception {
    // A kivtel ltrehozsa, a megadott sorszmmal
    public SystemErrorException(int i) {
        // A sorszm szvegg konvertlsa s tovbbadsa
        super(Integer.toString(i));
    }
}

// Az 'res mez' kivtel definilsa
class EmptyFieldException extends Exception {}
