/**
 * AranyConstraints osztly
 *                        Pakolsi jellemz az AranyLayout pakolsi stratgihoz
 */
public class AranyConstraints {
  /**
   * A komponens maga hatrozza meg a mrett
   */
  public static float EREDETIMRET = -1;
  private float xarny, yarny;                   //szlessg s magassg arnya  
  /**
   * Konstruktor
   * @param pXarny szlessgi arny
   * @param pYarny magassgi arny
   */
  public AranyConstraints( float pXarny, float pYarny ) {
    setXarny( pXarny );
    setYarny( pXarny );
  }  
  /**
   * Szlessgi arny belltsa
   * @param pXarny szlessgi arny
   * @throws IllegalArgumentException ha rvnytelen a paramter
   */
  public void setXarny( float pXarny ) {
    if ((pXarny!=EREDETIMRET)                          //paramter ellenrzse
        && (pXarny < 0 || pXarny > 1))
              throw new IllegalArgumentException("rvnytelen Xarny:"+pXarny);
    xarny = pXarny;
  }
  /**
   * Szlessgi arny lekrdezse
   * @return szlessgi arny
   */
  public float getXarny() {
    return xarny;
  }
  /**
   * Magassgi arny belltsa
   * @param pYarny magassgi arny
   * @throws IllegalArgumentException ha rvnytelen a paramter
   */
  public void setYarny( float pYarny ) {
    if ((pYarny!=EREDETIMRET)                          //paramter ellenrzse
        && (pYarny < 0 || pYarny > 1))
              throw new IllegalArgumentException("rvnytelen Yarny:"+pYarny);
    yarny = pYarny;
  }
  /**
   * Magassgi arny lekrdezse
   * @return magassgi arny
   */
  public float getYarny() {
    return yarny;
  }
}
