/**
 * ScrollPaneTest osztly
 *                      Grgetheten megjelenti a paramterknt kapott kpfjlt
 */
public class ScrollPaneTest extends java.awt.event.WindowAdapter {
  public static void main( String args[] ) {
    if (args.length==0) {                     //kpfjlnv paramter ellenrzse
       System.err.println("Hinyzik a kpfjlnv paramter!");
       return;
    }
    ScrollPaneTest test = new ScrollPaneTest();                  //pldnyosts
    java.awt.Frame ablak = new java.awt.Frame();            //fellet felptse
    test.felpt( ablak );
    String kpfjlnv = args[0];
    test.megmutat( kpfjlnv );                  //kp betltse s kirajzolsa
    ablak.setTitle("ScrollPaneTest - " + kpfjlnv);
    ablak.addWindowListener( test );                    //ablakbezrs figyelse
    ablak.pack();                                        //fellet megjelentse
    ablak.show();
  }

  private GorgethetoKep grgethetkp;                    //kpgrget komponens
  void felpt( java.awt.Container pKontner ) {            //fellet felptse
    if (!(pKontner.getLayout() instanceof java.awt.BorderLayout))
       pKontner.setLayout( new java.awt.BorderLayout() );
    pKontner.add( grgethetkp = new GorgethetoKep());
  }

  void megmutat( String pKpfjlnv ) {         //kp betltse s megjelentse
    grgethetkp.megmutat( pKpfjlnv );
  }

  public void windowClosing( java.awt.event.WindowEvent we ) {  //ablak bezrsa
    System.exit(0);                                       //kilps a programbl
  }
  /*****************************************************************************
   * Grgethet kp megvalstsa ScrollPane s Canvas felhasznlsval
   */
  private class GorgethetoKep extends java.awt.ScrollPane {
                                                             //aktulis kpmret
    private java.awt.Dimension kpmret = new java.awt.Dimension(200, 150);
    private java.awt.Image kp;                             //megjelentend kp
    private String zenet = "Nincs megadva kp!";     //kzpre igaztott szveg
    
    KepCanvas kpcanvas= new KepCanvas();           //a kpmegjelent komponens
    GorgethetoKep() {                                              //konstruktor
      add( kpcanvas  );                                    //fellet felptse
    }
    void megmutat( String pKpfjlnv ) {            //kp megjelentse fjlbl
      synchronized (this) {                         //kp betltsnek ignylse
        kp = java.awt.Toolkit.getDefaultToolkit().createImage( pKpfjlnv );
        zenet = "Kpbetlts folyamatban...";
      }
      String lzenet = null;
      try {                             //kpbetlts elvgeztetse s megvrsa
        java.awt.MediaTracker tracker = new java.awt.MediaTracker(this);
        tracker.addImage( kp, 0 );
        tracker.waitForID(0);                                 //megvrni a vgt
        if (tracker.isErrorID(0)) lzenet = "Kpbetltsi hiba!";         //hiba
      } catch (InterruptedException ie) {            //esetn hibazenet jelzse
        lzenet = "Kpbetlts megszaktva: " + ie;
      }
      synchronized (this) {
        zenet=lzenet;                //megjelentend zenet s kp belltsa
        if (zenet==null) {             //ha nem volt hiba, kpmret lekrdezse
           kpmret.width = kp.getWidth(this);
           kpmret.height = kp.getHeight(this);
           mret.width = 0;                             //mret jraszmoltatsa
        } else kp = null;                //hiba esetn nincs megjelentend kp
      }
      invalidate();                          //grgetsvok helyes megjelentse
      validate();
      kpcanvas.repaint();                                //j kp megjelentse
    }
                                                         //grgethet kp mrete
    private java.awt.Dimension mret = new java.awt.Dimension(0, 0);
    public java.awt.Dimension getPreferredSize() {    //optimlis mret=kpmret
      if (mret.width==0) {                      //kiszmtott mret cache-else
         java.awt.Insets insets = getInsets();//keretvastagsg figyelembe vtele
         mret.width = kpmret.width+insets.left+insets.right;
         mret.height = kpmret.height+insets.top+insets.bottom;
      }
      return mret;                          //optimlis mret=kiszmtott mret
    }    
    /***************************************************************************
     * Kp s szvegmegjelents Canvas segtsgvel
     */
    private class KepCanvas extends java.awt.Canvas {
      /**
       * Grafikus megjelents elvgzse
       */
      public void paint( java.awt.Graphics g ) {
        java.awt.Image skp = null;      //loklisan szinkronizlt kp s szveg
        String szenet = null;
        synchronized (this) {         //megjelentend kp s szveg lekrdezse
          skp = kp;
          szenet = zenet;
        }
        if (skp==null) {       //ha nincs megadva kp, a httr pirosra festse
           g.setColor( java.awt.Color.red );
           g.fillRect( 0, 0, getWidth(), getHeight() );
        } else g.drawImage( skp, 0, 0, this );   //klnben a kp megjelentse
        if (szenet != null) {    //ha van zenet, kzpre igaztva mejelenteni
           g.setColor( java.awt.SystemColor.textText );          //sznbellts
           java.awt.FontMetrics fm = g.getFontMetrics();    //aktulis jellemzk
           java.awt.Dimension vps = getViewportSize();   //lekrdezse a kzpre
           java.awt.Point sp = getScrollPosition();                //igaztshoz
           g.drawString( szenet,       //zenet kzpre igaztott megjelentse
             sp.x + (vps.width-fm.stringWidth(szenet)) / 2,
             sp.y+fm.getLeading()+fm.getAscent()+(vps.height-fm.getHeight())/2);
        }
      }
      public java.awt.Dimension getPreferredSize() {    //megjelents mretnek
        if (kp!=null) return kpmret;
        return getViewportSize();                                    //igaztsa
      }    
    }
  }
}
