import java.awt.*;
import java.awt.geom.*;
import java.awt.color.*;
import java.awt.event.*;

// peldaprogram a ColorSpace osztaly hasznalatara
// (irta: Antal Gyorgy es Csonka Ferenc, 1999. marcius)

class Szinmodell extends Canvas {

	public void paint (Graphics g) {
		Graphics2D g2 = (Graphics2D) g;

		// CS_GRAY szurke szintartomanyban definialunk egy szint
		ColorSpace szurkeSzintartomany = ColorSpace.getInstance (ColorSpace.CS_GRAY);
		float[] szurkeErtek = { 0.5f };
		Color szurke = new Color (szurkeSzintartomany, szurkeErtek, 1.0f);

		// ezzel kirajzolunk egy teglalapot
		g2.setColor (szurke);
		g2.fillRect (50, 50, 100, 100);

		// az elobbi szurke szint atkonvertaljuk a CIEXYZ szintartomanyba
		ColorSpace CIEXYZSzintartomany = ColorSpace.getInstance (ColorSpace.CS_CIEXYZ);
		float[] szurkeErtekCIEXYZ = new float[1];
		szurkeErtekCIEXYZ = szurkeSzintartomany.toCIEXYZ (szurkeErtek);
		szurke = new Color (CIEXYZSzintartomany, szurkeErtekCIEXYZ, 1.0f);

		// az atkonvertalt szinnel is kirajzolunk egy teglalapot
		g2.setColor (szurke);
		g2.fillRect (50, 200, 100, 100);

	}

	public static void main (String[] args) {
		Frame f = new Frame ();
		f.add (new Szinmodell ());

		f.addWindowListener (
			new WindowAdapter () {
				public void windowClosing (WindowEvent e) {
					System.exit (0);
				}
			}
		);

		f.setSize (200, 400);
		f.setVisible (true);
	}
}