/**
 *  File neve : FoMenu.java (Fomenu osztly)
 *
 *  Lers : Ez az osztly a Frame amihez kapcsolva van egy
 *           ScrollPane amelyhez van csatolva a RajzPanel amin
 *           a grafikus mveletek trtnnek. A konstruktor
 *           egyetlen paramtere a Frame cimkje.
 *
 *  Ksztette Takcs Mihly 1998.06. 
 */

import java.awt.*;
import java.awt.event.*;

public class FoMenu extends Frame implements ActionListener, AdjustmentListener {

  Menu fajl,  csoportok, segit;
  MenuItem uj, megnyit, ment, bezar, kilepes,       // File
           modosit,                      // Csoport menpont
	   segitseg, about;           // Segt menpont

  ScrollPane scp;
  Adjustable scpHadjust,scpVadjust;  //A grgetsvokhoz
  Rajzpanel rajzpanel;
  String dir="";      // A betlttt file directory-ja
  String filenev="";  // A betlttt file neve

  FoMenu(String s) {
    super(s);

    MenuBar mb=new MenuBar();
      fajl=new Menu("Fajl");
        uj=new MenuItem("Uj");
	uj.addActionListener(this);          //parancs hozzrendelse
	fajl.add(uj);
	fajl.addSeparator();
	megnyit=new MenuItem("Megnyit..");
	megnyit.addActionListener(this);
	fajl.add(megnyit);
	ment=new MenuItem("Ment..");
	ment.addActionListener(this);
	ment.setEnabled(false);
	fajl.add(ment);
	bezar=new MenuItem("Bezar");
	bezar.addActionListener(this);
	bezar.setEnabled(false);
	fajl.add(bezar);
	fajl.addSeparator();
	kilepes=new MenuItem("Kilepes");
	kilepes.addActionListener(this);
	fajl.add(kilepes);
      mb.add(fajl);
      csoportok=new Menu("Csoportok");
      csoportok.setEnabled(false);
	modosit=new MenuItem("Modosit..");
	modosit.addActionListener(this);
	csoportok.add(modosit);
      mb.add(csoportok);
      segit=new Menu("Segit");
        segitseg=new MenuItem("Segit");
	segitseg.addActionListener(this);
	segit.add(segitseg);
        about=new MenuItem("A programrol");
	about.addActionListener(this);
	segit.add(about);
      mb.setHelpMenu(segit);
    setMenuBar(mb);
    scp=new ScrollPane();

    scpHadjust=scp.getHAdjustable();
    scpHadjust.setUnitIncrement(50);  // Grgetsi mozgs
    scpHadjust.setBlockIncrement(getSize().width-50);   // Ugrsnl a mozgs
    scpHadjust.addAdjustmentListener(this);

    scpVadjust=scp.getVAdjustable();
    scpVadjust.setUnitIncrement(50);  // Grgetsi mozgs
    scpVadjust.setBlockIncrement(getSize().height-50);   // Ugrsnl a mozgs
    scpVadjust.addAdjustmentListener(this);
    add("Center",scp);

    setSize(600,400);
    setResizable(false);
    validate();
    paintAll(getGraphics());
  }

  /* Adjustable interfsz megvalstsa a ScrollPane-hoz*/
  public void adjustmentValueChanged(AdjustmentEvent e) {
    rajzpanel.repaint();
    scpHadjust.setBlockIncrement(getSize().width-50);   // Ugrsnl a mozgs
    scpVadjust.setBlockIncrement(getSize().height-50);  // Ugrsnl a mozgs
  }

  /* ActionListener interfsz megvalstsa a parancsok lekezelshez */
  public void actionPerformed(ActionEvent ae) {
    Object s=ae.getSource();
       /* File menpont */
    if (s.equals(uj)) {
      menthakell(); // Csinl mentst ha volt vltoztats
      ment.setEnabled(true);  // Menpontok engedlyezse
      bezar.setEnabled(true);
      csoportok.setEnabled(true);
      dir="";           // Ennek mg nincs file-neve
      filenev="";
      scp.removeAll();  // Kivesszk az sszes komponenst a ScrollPane-bl
      rajzpanel=null;   // Erre mr nincs szksgnk
      rajzpanel=new Rajzpanel(scp,"");  // s jra felptjk
      scp.add(rajzpanel);
    }
    else if (s.equals(megnyit)) {   /* Ltez file megnyitsa */
      menthakell();
      FileDialog fd=new FileDialog(this,"File megnyitsa",FileDialog.LOAD);
      fd.show();
      if ((filenev=fd.getFile())!=null) {
	ment.setEnabled(true);  // Menpontok engedlyezse
	bezar.setEnabled(true);
	csoportok.setEnabled(true);
	scp.removeAll();  // Kivesszk az sszes komponenst a ScrollPane-bl
	rajzpanel=null;   // Erre mr nincs szksegnk
	dir=fd.getDirectory();
	rajzpanel=new Rajzpanel(scp,dir+filenev); //s felptjk
	scp.add(rajzpanel);
      }
    }
    else if (s.equals(ment)) {
      FileDialog fd=new FileDialog(this,"Aktulis mentse",FileDialog.SAVE);
      fd.setDirectory(dir);
      fd.setFile(filenev);
      fd.show();
      dir=fd.getDirectory();
      filenev=fd.getFile();
      rajzpanel.ment(dir+filenev);
    }
    else if (s.equals(bezar)) {
      menthakell();
      ment.setEnabled(false);  // Menpontok tiltsa
      bezar.setEnabled(false);
      csoportok.setEnabled(false);
      dir="";
      filenev="";
      scp.removeAll();  // Kivesszk az sszes komponenst a ScrollPane-bl
      rajzpanel=null;   // Erre mr nincs szksgnk
    }
    else if (s.equals(kilepes)) {
      menthakell();
      System.exit(0);
    }
    /* Csoport menpont */
    else if (s.equals(modosit)) {
      CsopDialog csopdialog=new CsopDialog(this,"Csoportok mdostsa");
      csopdialog.show();
    }
    /* Segt menpont */
    else if (s.equals(segitseg)) {
      Help help=new Help(this,"SzHelp.hlp");
    }
    else if (s.equals(about)) {
      About about=new About(this);
      about.show();
    }
  }

    /**
     *  Ha trtnt vltoztats akkor csinl mentst (rkrdezs mellett)
     **/
  private void menthakell() {
    try {  // Lehet, hogy nem ltezik rajzpanel
      if (rajzpanel.valtozas) {
	Uzenet kerdes=new Uzenet(this,"Krds","A regiben volt valtozas. Akarsz mentest rola?",Uzenet.kerdes);  // krdez ablak
	if (kerdes.valasztasa()==Uzenet.igen) {
	  FileDialog fd=new FileDialog(this,"Aktulis mentse",FileDialog.SAVE);
	  fd.setDirectory(dir);
	  fd.setFile(filenev);
	  fd.show();
	  rajzpanel.ment(fd.getDirectory()+fd.getFile());
	}
      }
    } catch (NullPointerException err) {}
  }

}
