/**
 *  File neve : MenMenu.java (MenMenu osztly)
 *
 *  Lers : Ez az osztly a Frame amihez kapcsolva van egy
 *           ScrollPane amelyhez van csatolva a Viewpanel amin
 *           a grafikus mveletek trtnnek. A konstruktor
 *           egyetlen paramtere a Frame cmkje.
 *
 *  Ksztette Takcs Mihly 1998.06. 
 */

import java.awt.*;
import java.awt.event.*;

public class MenMenu extends Frame implements ActionListener, AdjustmentListener {

  Menu fajl, csoportok, segit;
  MenuItem megnyit, bezar, kilepes,              // File
           megtekint,                   // Csoport menpont
	   segitseg, about;           // Segt menpont

  ScrollPane scp;
  Adjustable scpHadjust,scpVadjust;  //A grgetsvokhoz
  Viewpanel viewpanel;

  MenMenu(String s) {
    super(s);

    MenuBar mb=new MenuBar();
      fajl=new Menu("Fajl");
	megnyit=new MenuItem("Megnyit..");
	megnyit.addActionListener(this);
	fajl.add(megnyit);
	bezar=new MenuItem("Bezar");
	bezar.addActionListener(this);
	bezar.setEnabled(false);
	fajl.add(bezar);
	fajl.addSeparator();
	kilepes=new MenuItem("Kilepes");
	kilepes.addActionListener(this);
	fajl.add(kilepes);
      mb.add(fajl);
      csoportok=new Menu("Csoportok");
      csoportok.setEnabled(false);
	megtekint=new MenuItem("Megtekint..");
	megtekint.addActionListener(this);
	csoportok.add(megtekint);
      mb.add(csoportok);
      segit=new Menu("Segit");
        segitseg=new MenuItem("Segit");
	segitseg.addActionListener(this);
	segit.add(segitseg);
        about=new MenuItem("A programrol");
	about.addActionListener(this);
	segit.add(about);
      mb.setHelpMenu(segit);
    setMenuBar(mb);
    scp=new ScrollPane();

    scpHadjust=scp.getHAdjustable();
    scpHadjust.setUnitIncrement(50);  // Grgetsi mozgs
    scpHadjust.setBlockIncrement(getSize().width-50);   // Ugrsnl a mozgs
    scpHadjust.addAdjustmentListener(this);

    scpVadjust=scp.getVAdjustable();
    scpVadjust.setUnitIncrement(50);  // Grgetsi mozgs
    scpVadjust.setBlockIncrement(getSize().height-50);   // Ugrsnl a mozgs
    scpVadjust.addAdjustmentListener(this);
    add("Center",scp);

    setSize(600,400);
    setResizable(false);
    validate();
    paintAll(getGraphics());
  }

  /* Adjustable interfsz megvalstsa a ScrollPane-hoz*/
  public void adjustmentValueChanged(AdjustmentEvent e) {
    viewpanel.repaint();
    scpHadjust.setBlockIncrement(getSize().width-50);   // Ugrsnl a mozgs
    scpVadjust.setBlockIncrement(getSize().height-50);  // Ugrsnl a mozgs
  }

  /* ActionListener interfsz megvalstsa a parancsok lekezelshez */
  public void actionPerformed(ActionEvent ae) {
    Object s=ae.getSource();
    if (s.equals(megnyit)) {   /* Ltez file megnyitsa */
      FileDialog fd=new FileDialog(this,"File megnyitsa",FileDialog.LOAD);
      fd.show();
      if (fd.getFile()!=null) {
	bezar.setEnabled(true);
	csoportok.setEnabled(true);
	scp.removeAll();  // Kivesszk az sszes komponenst a ScrollPane-bl
	viewpanel=null;   // Erre mr nincs szkegnk
	viewpanel=new Viewpanel(scp,fd.getDirectory()+fd.getFile());
	scp.add(viewpanel);
      }
    }
    else if (s.equals(bezar)) {
      Uzenet kerdes=new Uzenet(this,"Krds","Biztos elhagyja a teruletet ?",Uzenet.kerdes);  // krdez ablak
      if (kerdes.valasztasa()==Uzenet.igen) {
	csoportok.setEnabled(false);     // Menpontok tiltsa
	bezar.setEnabled(false);
	scp.removeAll();  // Kivesszk az sszes komponenst a ScrollPane-bl
	viewpanel=null;   // Erre mr nincs szksgnk
      }
    }
    else if (s.equals(kilepes)) {
      Uzenet kerdes=new Uzenet(this,"Krds","Valoban kilepes a menedzserbol ?",Uzenet.kerdes);  // krdez ablak
      if (kerdes.valasztasa()==Uzenet.igen) {
	System.exit(0);
      }
    }
    /* Csoport menpont */
    else if (s.equals(megtekint)) {
      CsopView csopview=new CsopView(this,"Csoportok megtekintse");
      csopview.show();
    }
    /* Segt menpont */
    else if (s.equals(segitseg)) {
      Help help=new Help(this,"MHelp.hlp");
    }
    else if (s.equals(about)) {
      About about=new About(this);
      about.show();
    }
  }
}
