/**
 *  File neve : Rajzpanel.java (Rajzpanel osztly)
 *
 *  Lers : Ez az osztly amin a grafikus mveletek trtnnek
 *           a 'graf' tpus 'epulet' egyed segtsgvel.
 *           Az 'epulet' egyed segtsgvel teszi a grfot vizulisan is
 *           lthatv. Mindennem vltozs (cscsok mozgatsa, j cscs
 *           felvtele stb) azonnal megjelenik a grfban.
 *           A konstruktor parametrei : 'parent' : a szl ScrollPane,
 *           'filenev' : a file-nak a neve amelybl a grfot tltjk be.
 *
 *  Ksztette Takcs Mihly 1998.06. 
 */

import java.util.*;
import java.awt.event.*;
import java.awt.*;

class Rajzpanel extends Panel implements MouseListener, ActionListener,
				    MouseMotionListener {
  ScrollPane parent;  // A befoglal ScrollPane
  PopupMenu PopupUj,PopupRegi;  // j terminlhoz s mr meglv terminlhoz
  MenuItem ujterminal, // j terminlhoz s
           tulajdonsag,torles;  // mr meglv terminlhoz
  graf epulet;    // Maga a grf amit vizulisan is megjelentnk
  lista csucsok;  // A grf sszes cscsa egy vektorban
  boolean valtozas=false; // Ha trtnt vltoztats akkor igaz (mentshez)

  Rajzpanel(ScrollPane parent,String filenev) {
    if (filenev.equals("")) { // j grf gykernek a ltrehozsa
      TermDialog ujterm=new TermDialog((Frame)parent.getParent(),this,"j",new Point(100,100),"","","","","","");  // A msodik szl a Frame (FoMenu)
      ujterm.show();
    } else if (!beolvas(filenev)) {   // Ha rossz a beolvass akkor j grf
      setEnabled(false);
      setSize(5,5);
      ((FoMenu)parent.getParent()).csoportok.setEnabled(false);
      ((FoMenu)parent.getParent()).ment.setEnabled(false);
      ((FoMenu)parent.getParent()).bezar.setEnabled(false);
      Uzenet uzen=new Uzenet((Frame)parent.getParent(),"Hiba","HIBA : Nem letezo file vagy rossz file formatum!",Uzenet.hiba);  // zen ablak
      epulet=new graf("semmi");
    }

    if (isEnabled()) setSize(2000,1000);
    this.parent=parent;
    PopupUj=new PopupMenu();  /* A PopupMenu-k */
      ujterminal=new MenuItem("Uj terminal");
      ujterminal.addActionListener(this);
      PopupUj.add(ujterminal);
    PopupRegi=new PopupMenu();
      tulajdonsag=new MenuItem("Tulajdonsag");
      tulajdonsag.addActionListener(this);
      PopupRegi.add(tulajdonsag);
      torles=new MenuItem("Torles");
      torles.addActionListener(this);
      PopupRegi.add(torles);
    add(PopupUj);
    add(PopupRegi);
    addMouseListener(this);
    addMouseMotionListener(this);
  }

  Image offscreen;  // Pufferelt rajzolshoz
  Dimension offscreensize;
  Graphics offgraphics;
  
  final Color selectColor = Color.pink;
  final Color lineColor = Color.black;
  final Color csucsColor = new Color(250, 220, 100);

  public void paintcsucs(Graphics g, csucs n, FontMetrics fm) {
    int x = n.x;
    int y = n.y;
    g.setColor(n.select ? selectColor : csucsColor);
    int w = fm.stringWidth(n.neve)+10;
    int h = fm.getHeight()+4;
    n.dx = w;
    n.dy = h;
    g.fillRect(x,y,w,h);
    g.setColor(Color.black);
    g.drawRect(x,y,w-1,h-1);
    g.drawString(n.neve,x+5,y+2+fm.getAscent());
  }

  public void update(Graphics g) {
    setSize(2000,1000);
    Dimension d=size();
    csucs aktualis,rakovetkezo;

    if ((offscreen==null) || /* Ha mg nem volt vagy t volt mretezve */
	(d.width!=offscreensize.width) || (d.height!=offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }
    offgraphics.setColor(getBackground());  // Offscreen trlse
    offgraphics.fillRect(0, 0, d.width, d.height);
    /*
     * Sorra vesszk a cscskat s a rkvetkez cscsaival sszektjk
     * t. Vagyis a cscskat sszekt szakaszok kirajzolsa. 
     */
    csucsok=epulet.csucsok();
    for (Enumeration e=csucsok.elements(); e.hasMoreElements(); ) {
      aktualis=(csucs)e.nextElement();
      if (!aktualis.torolt && (aktualis.x!=csucs.valotlan)) {
	for (Enumeration f=aktualis.kovetkezo.elements();
	     f.hasMoreElements(); ) { // A rkvetkez cscsok sorban
	  rakovetkezo=(csucs)f.nextElement();
	  if (!rakovetkezo.torolt && (rakovetkezo.x!=csucs.valotlan)) {
	             /* A szakasz kirajzolsa */
	    /* A cscsok kzepnek koordinti */
	    int kozepx1 = aktualis.x+aktualis.dx/2;
	    int kozepy1 = aktualis.y+aktualis.dy/2;
	    int kozepx2 = rakovetkezo.x+rakovetkezo.dx/2;
	    int kozepy2 = rakovetkezo.y+rakovetkezo.dy/2;
	    offgraphics.setColor(lineColor); // A szakasz megrajzolsa
	    offgraphics.drawLine(kozepx1,kozepy1,kozepx2,kozepy2);
	    /* A nyl kirajzolsa a szakaszra. */
	    int Xtav=kozepx2-kozepx1; // A szakasz vektor x koordintja
	    int Ytav=kozepy2-kozepy1; // A szakasz vektor y koordintja
	    double len=Math.abs(Math.sqrt(Xtav*Xtav+Ytav*Ytav));//szakaszhossz
	    if (len>10) {  // Csak ekkor rajzolunk nylat
	      double arany=5/len;  // A nyl hossza mindig 5 egysg
	      int vx=(int)(Xtav*arany); //Ez a nyl helyt mutatja
	      int vy=(int)(Ytav*arany);
	      // Oda nyl
	      int szakaszkozepex=(kozepx2+kozepx1)/2; //A szakasz felez
	      int szakaszkozepey=(kozepy2+kozepy1)/2; //    pontja
	      offgraphics.drawLine(szakaszkozepex+vx*2, szakaszkozepey+vy*2,
				   szakaszkozepex+vy  , szakaszkozepey-vx);
	      offgraphics.drawLine(szakaszkozepex+vx*2, szakaszkozepey+vy*2,
				   szakaszkozepex-vy  , szakaszkozepey+vx);
	    }
	  }
	}
      }
    }
    /* A cscsok kirajzolsa */
    FontMetrics fm = offgraphics.getFontMetrics();
    for (Enumeration e=csucsok.elements(); e.hasMoreElements(); ) {
      aktualis=(csucs)e.nextElement();
      if (!aktualis.torolt && (aktualis.x!=csucs.valotlan)) {
	paintcsucs(offgraphics, aktualis, fm);
      }
    }
    g.drawImage(offscreen, 0, 0, null);  // Kpernyvlts
  }
  
     /* MouseMotionListener interfsz implementals */

  int tavX,tavY;  /* A cscs balfels sarktl ennyire klikkeltnk */
  csucs pick;  // Melyik cscs felett klikkeltnk (pl. mozgats)
  int duplaklikk=0;  // A duplakattints szmolshoz a mouseClicked fv-ben
  public void mouseMoved(MouseEvent evt) {duplaklikk=0;}

  public void mouseDragged(MouseEvent evt) {
    try {
      int x=evt.getX();
      int y=evt.getY();
      Dimension d=getSize();
      if (x<tavX) pick.x=0;  // Bal szln akarja kimozgatni
      else if (d.width<(x-tavX+pick.dx)) pick.x=d.width-pick.dx;// Jobbszle
      else pick.x = x-tavX;  // Kzepe
      if (y<tavY) pick.y=0;  // Teteje
      else if (d.height<(y-tavY+pick.dy)) pick.y=d.height-pick.dy; // Alja
      else pick.y = y-tavY;  // Kzepe
      valtozas=true;
    } catch (Exception err) {} // NullPointer hiba lehet, pick=null
    repaint();
  }

     /* MouseListener interfsz implementlsa */
  Point TermPosition=new Point(0,0);  // A terminal pozcija (esemny helye)
  csucs popupselect;  // Melyik cscs fltt nyomtunk popup ment

  public void mouseClicked(MouseEvent evt) {
    if ((++duplaklikk)%2==0) {
      duplaklikk=0;
      TermPosition=evt.getPoint();
      if ((popupselect=epulet.Keres(TermPosition.x,TermPosition.y))!=null) {
	tavX=TermPosition.x-popupselect.x;
	tavY=TermPosition.y-popupselect.y;
	actionPerformed(new ActionEvent(tulajdonsag,ActionEvent.ACTION_PERFORMED,"Tulajdonsag",0));
      } else {  // Nem cscs felett klikkelt dupln
	actionPerformed(new ActionEvent(ujterminal,ActionEvent.ACTION_PERFORMED,"UjTerminal",0));
      }
    }
  }

  public void mousePressed(MouseEvent evt) {
    if (evt.isPopupTrigger()) {  // Ha PopupMenu-t aktivizltunk
      TermPosition=evt.getPoint();
      if ((popupselect=epulet.Keres(TermPosition.x,TermPosition.y))!=null) {
	// Ha cscson klikkeltnk
	tavX=TermPosition.x-popupselect.x;
	tavY=TermPosition.y-popupselect.y;
	PopupRegi.show(this,TermPosition.x,TermPosition.y); //PopupMenu
      } else {  // Ha nem cscson klikkeltnk
	PopupUj.show(this,TermPosition.x,TermPosition.y);
      }
    } else {  // Lehet hogy cscsot fogunk mozgatni
      int x=evt.getX();
      int y=evt.getY();
      if ((pick=epulet.Keres(x,y))!=null) {  // Ha cscson klikkeltnk
	tavX=x-pick.x;
	tavY=y-pick.y;
      	pick.select=true;  // Szrke sznnel rajzoljuk ki
      }
    }
    repaint();
  }

  public void mouseReleased(MouseEvent evt) {
    try {
      pick.select=false;  // Mr nem kell szrkn kirajzolni
      pick = null;
      tavX=0;
      tavY=0;
    }
    catch (Exception err) {} // NullPointer hiba lehet, pick=null
    repaint();
  }

  public void mouseEntered(MouseEvent evt) {repaint();}
  public void mouseExited(MouseEvent evt) {}

	/* ActionListener interfsz implementlsa a PopupMenu-khz */
  public void actionPerformed(ActionEvent evt) {
    Object s=evt.getSource();  // Visszaadja honnan jtt az esemny
    /* A popup men menpontjai */
    if       (s.equals(ujterminal  )) {
      TermDialog ujterm=new TermDialog((Frame)parent.getParent(),this,"j Terminl",TermPosition,"","","","","","");  // A msodik szl a Frame (FoMenu)
      ujterm.show();
    }else if (s.equals(tulajdonsag )) {
      TermDialog regiterm=new TermDialog((Frame)parent.getParent(),
	 this,"Terminl tulajdonsgai",TermPosition,popupselect.neve,
	 popupselect.azonosito,popupselect.kovetkezok(),popupselect.csoport,
	 popupselect.tol,popupselect.ig);
                   // A msodik szl a Frame (FoMenu)
      regiterm.show();
    }else if (s.equals(torles      )) {
      if (popupselect==epulet.getGyoker()) {
	Uzenet uzen=new Uzenet((Frame)parent.getParent(),"Hiba",
	   "HIBA : A gyokerelem nem torolheto!",Uzenet.hiba);  // zen ablak
      } else {
	epulet.torol(popupselect);
	popupselect=null;
	valtozas=true;
      }
    }
    repaint();
  }

   /** 
    * TermDialog pldny ad hozz j cscsot vagy mdost ezen keresztl
    **/
  public void hozzaad(String neve, String azonosito, String csoport,
		 String kovetkezok, int x, int y, String tol, String ig) {
    try {
      epulet.ujelem(neve,azonosito,csoport,kovetkezok,x-tavX,y-tavY,1,tol,ig);
    } catch (NullPointerException err) {
      /* Most hozzuk ltre az pletet, ez lesz a grf gykere */
      epulet=new graf(azonosito);
      epulet.ujelem(neve,azonosito,csoport,kovetkezok,x,y,1,tol,ig);
    }
    csucsok=epulet.csucsok();
    valtozas=true;
    tavX=0; tavY=0;
  }
    /** 
      * Ezen keresztl tud menteni a FoMenu egyed (a szl)
      **/
  public void ment(String filenev) {
    epulet.ment(filenev);
    valtozas=false;   // Mr nincs vltozs
  }

    /** 
     * Ezen keresztl tud beolvasni a FoMenu egyed (a szl)
     **/
  public boolean beolvas(String filenev) {
    boolean l;
    epulet=new graf();
    l=epulet.beolvas(filenev);
    if (l) csucsok=epulet.csucsok();  // Csak ha sikeres a beolvass
    valtozas=false;  // Ebben mg nincs vltozs
    return l;
  }
    /**
     * Ezen keresztl trlhet a TermDialog ablak cscsot
     **/
  public void torol(String azonosito) {
    csucs a;
    if ((a=epulet.Keres(azonosito))==epulet.getGyoker()) {
      Uzenet uzen=new Uzenet((Frame)parent.getParent(),"Hiba","HIBA : A gyoker elem nem torolheto!",Uzenet.hiba);  // zen ablak
    } else {
      try {
	epulet.torol(a);  // Az 'a' cscs null pointer is lehet
      } catch (NullPointerException err) {}
    }
  }
}
