/**
 *  File neve : Viewpanel.java (Viewpanel osztaly)
 *
 *  Lers : Ez az osztly a Viewpanel amin a grafikus mveletek
 *           trtnnek a 'graf' tpus 'epulet' egyed segtsgvel.
 *           Az 'epulet' egyed segtsgvel teszi a grfot vizulisan is
 *           lthatv. A konstruktor paramterei : 
 *           'parent' : a szl ScrollPane,
 *           'filenev' : a file-nak a neve amelybl a grfot tltjk be
 *           ha res vagy nem ltezik akkor j grfot hozunk ltre.
 *
 *  Ksztette Takcs Mihly 1998.06. 
 */

import java.util.*;
import java.awt.event.*;
import java.awt.*;

class Viewpanel extends Panel implements MouseListener, ActionListener,
				    MouseMotionListener {
  ScrollPane parent;  // A befoglal ScrollPane
  PopupMenu popup;  // Terminl felpattan menje
  MenuItem tulajdonsag,utvonal;  // Felpattan menhoz
  boolean utkerelem=false;   // Ha tvonalat kr akkor lesz igaz
  graf epulet;    // Maga a grf amit vizulisan is megjelenitnk
  lista csucsok;  // A grf sszes cscsa egy vektorban

  Viewpanel(ScrollPane parent,String filenev) {
    if (!beolvas(filenev)) {  // Rossz beolvass esetn
      setEnabled(false);
      setSize(5,5);
      ((MenMenu)parent.getParent()).csoportok.setEnabled(false);
      ((MenMenu)parent.getParent()).bezar.setEnabled(false);
      Uzenet uzen=new Uzenet((Frame)parent.getParent(),"Hiba","HIBA : Nem letezo file vagy rossz file formatum!",Uzenet.hiba);  // zen ablak
      epulet=new graf("semmi");
    } else {
      setSize(2000,1000);
    }
    this.parent=parent;
    popup=new PopupMenu();
      tulajdonsag=new MenuItem("Tulajdonsag");
      tulajdonsag.addActionListener(this);
      popup.add(tulajdonsag);
      utvonal=new MenuItem("Utvonal");
      utvonal.addActionListener(this);
      popup.add(utvonal);
    add(popup);
    addMouseListener(this);
    addMouseMotionListener(this);

    csucsok=epulet.csucsok();  // cscsok a listban (elg most az elejn frissteni, gy sem lehet vltoztatni a grfot)
  }

  Image offscreen;  // Pufferelt rajzolshoz
  Dimension offscreensize;
  Graphics offgraphics;
  
  final Color selectColor = Color.pink;
  final Color lineColor = Color.black;
  final Color csucsColor = new Color(250, 220, 100);

  public void paintcsucs(Graphics g, csucs n, FontMetrics fm) {
    int x = n.x;
    int y = n.y;
    g.setColor(n.select ? selectColor : csucsColor); // tvonalban van?
    int w = fm.stringWidth(n.neve)+10;
    int h = fm.getHeight()+4;
    n.dx = w;
    n.dy = h;
    g.fillRect(x,y,w,h);
    g.setColor(Color.black);
    g.drawRect(x,y,w-1,h-1);
    g.drawString(n.neve,x+5,y+2+fm.getAscent());
  }

  public void update(Graphics g) {
    setSize(2000,1000);
    Dimension d=size();
    csucs aktualis,rakovetkezo;

    if ((offscreen==null) || /* Ha mg nem volt vagy t volt mretezve */
	(d.width!=offscreensize.width) || (d.height!=offscreensize.height)) {
      offscreen = createImage(d.width, d.height);
      offscreensize = d;
      offgraphics = offscreen.getGraphics();
      offgraphics.setFont(getFont());
    }
    offgraphics.setColor(getBackground());  // Offscreen trlse
    offgraphics.fillRect(0, 0, d.width, d.height);
    /*
     * Vgig megynk az sszes cscson s a rkvetkez cscsaival sszektjk
     * t. Vagyis a szakaszok kirajzolsa. 
     */
    csucsok=epulet.csucsok();
    for (Enumeration e=csucsok.elements(); e.hasMoreElements(); ) {
      aktualis=(csucs)e.nextElement();
      if (!aktualis.torolt && (aktualis.x!=csucs.valotlan)) {
	for (Enumeration f=aktualis.kovetkezo.elements();
	     f.hasMoreElements(); ) { // A rkvetkez cscsok sorban
	  rakovetkezo=(csucs)f.nextElement();
	  if (!rakovetkezo.torolt && (rakovetkezo.x!=csucs.valotlan)) {
	             /* A szakaszok kirajzolsa */
	    /* A cscsok kzepnek koordintai */
	    int kozepx1 = aktualis.x+aktualis.dx/2;
	    int kozepy1 = aktualis.y+aktualis.dy/2;
	    int kozepx2 = rakovetkezo.x+rakovetkezo.dx/2;
	    int kozepy2 = rakovetkezo.y+rakovetkezo.dy/2;
	    offgraphics.setColor(lineColor); // A szakasz megrajzolsa
	    offgraphics.drawLine(kozepx1,kozepy1,kozepx2,kozepy2);
	    /* A nyl kirajzolsa a szakaszra. */
	    int Xtav=kozepx2-kozepx1; // A szakasz vektor x koordintja
	    int Ytav=kozepy2-kozepy1; // A szakasz vektor y koordintja
	    double len=Math.abs(Math.sqrt(Xtav*Xtav+Ytav*Ytav)); //szakaszhossz
	    if (len>10) {  // Csak ekkor rajzolunk nylat
	      double arany=5/len;  // A nyl hossza mindig 5 egysg
	      int vx=(int)(Xtav*arany); //Ez a nyl helyt mutatja
	      int vy=(int)(Ytav*arany);
	      // Oda nyl
	      int szakaszkozepex=(kozepx2+kozepx1)/2; //A szakasz felez
	      int szakaszkozepey=(kozepy2+kozepy1)/2; //    pontja
	      offgraphics.drawLine(szakaszkozepex+vx*2, szakaszkozepey+vy*2,
				   szakaszkozepex+vy  , szakaszkozepey-vx);
	      offgraphics.drawLine(szakaszkozepex+vx*2, szakaszkozepey+vy*2,
				   szakaszkozepex-vy  , szakaszkozepey+vx);
	    }
	  }
	}
      }
    }
    /* A cscsok kirajzolsa */
    FontMetrics fm = offgraphics.getFontMetrics();
    for (Enumeration e=csucsok.elements(); e.hasMoreElements(); ) {
      aktualis=(csucs)e.nextElement();
      if (aktualis.x!=csucs.valotlan) {
	paintcsucs(offgraphics, aktualis, fm);
      }
    }
    g.drawImage(offscreen, 0, 0, null);  // Kpernyvlts
  }
  
     /* MouseMotionListener interfsz implementlsa */

  int duplaklikk=0;  // A duplakattints szmolshoz a mouseClicked fv-ben
  public void mouseMoved(MouseEvent evt) {duplaklikk=0;}

  public void mouseDragged(MouseEvent evt) {}

     /* MouseListener interfsz implementlsa */
  Point TermPosition=new Point(0,0);  // A terminl pozcija (esemny helye)
  csucs popupselect=null;  // Melyik cscs felett nyomtunk popup ment
  csucs honnan=null, hova=null;   // tvonal: honnan, hova
  Vector ut;                      // maga az tvonal
  int lepesek=0;   // Az tvonal meghatrozsanak lpesei

  public void mouseClicked(MouseEvent evt) {
    csucs aktualis;

    TermPosition=evt.getPoint();
    try {
      for (Enumeration e=ut.elements(); e.hasMoreElements(); ) {
	aktualis=(csucs)e.nextElement();
	aktualis.select=false;   // Szrke sznnel kirajzols trlse
      }
    } catch (NullPointerException err) {}  // ha nincs t
    if (utkerelem) {  // tvonal krelem, most jelli ki a cscskat
      if (lepesek==0) {
	if ((honnan=epulet.Keres(TermPosition.x,TermPosition.y))==null) {
	  utkerelem=false;    // tkeress stornozva, nem cscson klikkelt
	  lepesek=0;
	} else { lepesek++; }  // Jhet a kvetkez lps
      } else if (lepesek==1) {
	if ((hova=epulet.Keres(TermPosition.x,TermPosition.y))==null) {
	  utkerelem=false;    // tkeress stornozva, nem cscson klikkelt
	  lepesek=0;
	} else {   // Na mostmr megvan mind a kt cscs
	  try {  // Lehet hogy nincs t
	    ut=epulet.BF(honnan,hova);
	    for (Enumeration e=ut.elements(); e.hasMoreElements(); ) {
	      aktualis=(csucs)e.nextElement();
	      aktualis.select=true;       // Kirajzoljuk szrke sznnel
	    }
	  } catch (NullPointerException err) {  // nincs t
	    Uzenet uzen=new Uzenet((Frame)parent.getParent(),"zenet","A ket csucs kozott nincs iranyitott ut.",Uzenet.hiba);  // zen ablak
	  }
	  lepesek=0;
	  utkerelem=false;
	  honnan=null;  hova=null;
	}
      }
    } else if ((++duplaklikk)%2==0) {
      duplaklikk=0;
      if ((popupselect=epulet.Keres(TermPosition.x,TermPosition.y))!=null) {
	actionPerformed(new ActionEvent(tulajdonsag,ActionEvent.ACTION_PERFORMED,"Tulajdonsag",0));
      }
    }
    repaint();
  }

  public void mousePressed(MouseEvent evt) {
    if (evt.isPopupTrigger()) {  // Ha PopupMenu-t aktivizltunk
      TermPosition=evt.getPoint();
      if ((popupselect=epulet.Keres(TermPosition.x,TermPosition.y))==null) {
	// Ha nem cscson klikkeltnk
	tulajdonsag.setEnabled(false);
      } else {  // Cscson klikkeltnk
	tulajdonsag.setEnabled(true);
      }
      popup.show(this,TermPosition.x,TermPosition.y); //PopupMenu
    }
    repaint();
  }

  public void mouseReleased(MouseEvent evt) {}
  public void mouseEntered(MouseEvent evt) {repaint();}
  public void mouseExited(MouseEvent evt) {}

	/* ActionListener interfsz implementlsa a PopupMenu-khz */
  public void actionPerformed(ActionEvent evt) {
    Object s=evt.getSource();  // Visszaadja honnan jtt az esemny
    /* A popup men menpontjai */
    if (s.equals(tulajdonsag )) {
      TermView regiterm=new TermView((Frame)parent.getParent(),
	 this,"Terminl tulajdonsgai",TermPosition,popupselect.neve,
	 popupselect.azonosito,popupselect.kovetkezok(),popupselect.csoport,
	 popupselect.tol,popupselect.ig);
                   // A msodik szl a Frame (MenMenu)
      regiterm.show();
      if (regiterm.utvonalkerelem) {
	actionPerformed(new ActionEvent(utvonal,ActionEvent.ACTION_PERFORMED,"Utvonal",0));
      }
    } else if (s.equals(utvonal)) {
      Uzenet uzen=new Uzenet((Frame)parent.getParent(),"zenet","Honnan hova akar eljutni? Klikkeljen a ket csucsra.",Uzenet.hiba);  // zen ablak
      utkerelem=true;
    }
    repaint();
  }

    /**
     *  Ezzel frissti az adatokat a TermView ablak
     */
  public csucs getcsucs(String azonosito) {
    return epulet.Keres(azonosito);
  }
    /** 
     * Ezen keresztl tud beolvasni a MenMenu egyed (a szl)
     **/
  public boolean beolvas(String filenev) {
    boolean l;
    epulet=new graf();
    l=epulet.beolvas(filenev);
    return l;
  }
}
