/***
 * File neve: graf.java
 * Szerz: Szatmry Botond
 * Utols mdosts: 1998. jun. 15.
 * Lers: Egy irnytott grf osztlyt valst meg. Ez az osztly szolgl a
 * terminlok kztti hierarchikus rendszer lersra. A grfok cscsai a
 * csucs osztly egy-egy pldnya. Minden a belptetrendszerben hasznlt
 * grfmvelet megvalstsa itt trtnik.
 ***/

import java.io.*;
import java.util.*;

public class graf
{
  /*
   * a krk kikszblshez kell
   */
  private lista korker=new lista(100);
  /*
   * a feltltetlen cscsokat tartalmazza
   */
  private Vector rosszak=new Vector(100);
  private csucs gyoker, aktualis, felett;
  private BufferedWriter out;
  private BufferedReader in;

  /**
   * a BF algoritmushoz kellenek
   * private int csucsSzam; // a grfban lv cscsok szma
   * private lista elek=new lista(100); // a grfban lv lek
   */
  private int csucsSzam; // a grfban lv cscsok szma
  private lista elek=new lista(100); // a grfban lv lek

  /**
   *Konstrukror ... amikor file-bl tltjk fel a grfot
   */
  public graf()
  {
  }
  /**
   * Konstuktor ... amikor j grfot hozunk ltre (nem file-bl)
   */
  public graf( String neve)
  {
    gyoker=new csucs(neve);
    aktualis=gyoker;
  }

  /**
   * Visszater a grf gykrevel.
   */
  public csucs getGyoker()
  {
    return gyoker;
  }
  
  /**
   * j elemet illeszt be a grfba.
   */
  public void ujelem( String neve, String azonosito, String csoport, lista kovetkezok, int x, int y, int emelet, String tol, String ig )
  {
    csucs p;
    if ( (p=Keres(gyoker,azonosito))==null )
      p=new csucs(neve,azonosito,csoport,x,y,emelet,tol,ig);
    else
      {
	// kiveszi azokat a p.kovetkezo-k kzl, amelyek nem szerepelnek
	// a paramterknt kapott kovetkezok kztt
	p.kovetkezo.torol(p,kovetkezok);
	p.set(neve,azonosito,csoport,x,y,emelet,tol,ig);
      }
    for ( Enumeration e=kovetkezok.elements(); e.hasMoreElements(); )
      {
	String s=(String)e.nextElement();
	if ( (aktualis=Keres(gyoker,s))!=null )
	  {	
	    if ( !p.kovetkezo.benne(s) )
	      {
		p.kovetkezo.addElement(aktualis);
		aktualis.elozo.addElement(p);
	      }
	  }
	else // ha mg nem volt, akkor ltre kell hozni.
	     // a fa csak egymasra eptve jhet ltre.
	  {
	    csucs uj=new csucs(s);
	    p.kovetkezo.addElement(uj);
	    uj.elozo.addElement(p);
	  }
      }
  }

  /**
   * j elemet illeszt be a grfba. Itt String-knt kell megadni a kvetkezket,
   * vesszvel elvlasztva
   */
  public void ujelem( String neve, String azonosito, String csoport, String kovetkezok, int x, int y, int emelet, String tol, String ig )
  {
    lista k;
    k=new lista(30);

    int index=0;
    while ( index < kovetkezok.length() )
      {
	int kov=kovetkezok.indexOf(",",index);
	if ( kov==-1 ) kov=kovetkezok.length();
	k.addElement(kovetkezok.substring(index,kov));
	index=kov+1;
      }

    ujelem( neve, azonosito, csoport, k, x, y, emelet, tol, ig );
  }

  /**
   * Kitrli p cscsot a grfbl.
   */
  public void torol( csucs p )
  {
    p.torolt=true;
  }

  /**
   * adott cscstl (p) kezdve lefel keres 'azonosito' azonostj cscsot
   */
  private csucs keres( csucs p, String azonosito )
  {
    if ( p.azonosito.equals(azonosito) )
      return p;
    korker.addElement(p);

    boolean l=false;
    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements() && !l; )
      {
	aktualis=(csucs)e.nextElement();
	if ( !korker.benne(aktualis.azonosito) )
	  l=((aktualis=keres(aktualis,azonosito))!=null);
      }

    if ( l )
      return aktualis;
    else
      return null;
  }
  /**
   * adott cscstl (p) kezve lefel keres x,y koordinata alapjn cscsot
   */
  private void keresxy( csucs p, int x, int y )
  {
    if ( p.x<=x && p.x+p.dx>=x && p.y<=y && p.y+p.dy>=y )
      {
	felett=p;
      }
    korker.addElement(p);

    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
      {
	aktualis=(csucs)e.nextElement();
	if ( !aktualis.torolt && !korker.benne(aktualis.azonosito) )
	  keresxy(aktualis,x,y);
      }
  }

  //  Ezen keresztul lehet a keres metodust meghivni. Kikszbli a krket.
  /**
   * Adott cscstl (p) kezdve lefel Keres 'azonosito' azonostj cscsot.
   * null-al tr vissza, ha nincs ilyen cscs. 
  */
  public csucs Keres( csucs p, String azonosito )
  {
    korker.removeAllElements();
    return keres(p,azonosito);
  }
  /**
   * A gykrtol kezve lefel Keres 'azonosito' azonositoju csucsot.
   * null-al ter vissza, ha nincs ilyen csucs.
   */
  public csucs Keres( String azonosito )
  {
    return Keres(gyoker,azonosito);
  }
  /**
   * A 'p' csucstol kezve lefel Keres x,y koordinata alapjan csucsot.
   * null-al ter vissza, ha nincs ilyen csucs.
   */
  public csucs Keres( csucs p, int x, int y )
  {
    felett=null;
    korker.removeAllElements();
    keresxy(p,x,y);
    return felett;
  }
  /**
   * A gykrtol kezve lefel Keres x,y koordinata alapjan csucsot.
   * null-al ter vissza, ha nincs ilyen csucs.
   */
  public csucs Keres( int x, int y )
  {
    return Keres(gyoker,x,y);
  }

  /**
   * kiirja a kepernyore a grf sszes csucsat valamilyen order bejarassal
   * lefel (kvetkez) haladva
   */
  private void kiir( csucs p )
  {
    p.kiir(); // ez itt a csucs kiir metodusa!!!
    korker.addElement(p);

    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
      {
	aktualis=(csucs)e.nextElement();
	if ( !aktualis.torolt && !korker.benne(aktualis.azonosito) )
	  kiir(aktualis);
      }
  }

  //  Ezen keresztl lehet a kiir metodust meghivni. Kikszbli a krket.
  /**
   * Kiirja a kepernyore a grf sszes cscsat valamilyen order bejarassal.
   */
  public void Kiir( csucs p )
  {
    korker.removeAllElements();
    kiir(p);
  }

  /**
   * Visszater a grf cscsait tartalmazo listaval.
   */
  public lista csucsok()
  {
    korker.removeAllElements();
    kiir(gyoker);
    return korker;
  }

  /**
   * elmenteshez kell
   */
  private void csucs_ki( csucs p )
  {
    korker.addElement(p);
    try
      {
	// kiirodik a neve
	out.write("#");
	out.write(p.neve,0,p.neve.length());
	out.write("#");

	// kiirodik az azonostja
	out.write(p.azonosito,0,p.azonosito.length());
	out.write("#");

	// kiirodik a csoportja
	out.write(p.csoport,0,p.csoport.length());
	out.write("#");

	// kiirodik az elz cscsok azonostja
	for ( Enumeration e=p.elozo.elements(); e.hasMoreElements(); )
	  {
	    aktualis=(csucs)e.nextElement();
	    if ( !aktualis.torolt )
	      {
		out.write(aktualis.azonosito,0,aktualis.azonosito.length());
		if ( e.hasMoreElements() )
		  out.write(",");
	      }
	  }
	out.write("#");

	// kiirodik a kvetkez cscsok azonostja
	for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
	  {
	    aktualis=(csucs)e.nextElement();
	    if ( !aktualis.torolt )
	      {
		out.write(aktualis.azonosito,0,aktualis.azonosito.length());
		if ( e.hasMoreElements() )
		  out.write(",");
	      }
	  }
	out.write("#");

	// kiirodik az x koordinataja
	Integer x=new Integer(p.x);
	out.write(x.toString(),0,x.toString().length());
	out.write("#");

	// kiirodik az y koordinataja
	Integer y=new Integer(p.y);
	out.write(y.toString(),0,y.toString().length());
	out.write("#");

	// kiirodik az emelet
	Integer emelet=new Integer(p.emelet);
	out.write(emelet.toString(),0,emelet.toString().length());
	out.write("#");

	// kiirodik a 'tol'
	out.write(p.tol,0,p.tol.length());
	out.write("#");

	// kiirodik az 'ig'
	out.write(p.ig,0,p.ig.length());
	out.write("#");
	
	out.newLine();
      }
    catch ( IOException e )
      {
	System.err.println(e);
      }
    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
      {
	aktualis=(csucs)e.nextElement();
	if ( !korker.benne(aktualis.azonosito) )
	  csucs_ki(aktualis);
      }
  }

  /**
   * Elmenti 'neve' neven file-ba a grfot.
   */
  public void ment( String neve )
  {
    korker.removeAllElements();
    try
      {
	out=new BufferedWriter( new FileWriter(neve) );
	out.write(gyoker.azonosito,0,gyoker.azonosito.length());
	out.newLine();
	csucs_ki(this.gyoker);
	out.close();
      }
    catch (IOException e)
      {
	System.err.println(e);
      }
  }

  /**
   * Felepiti a grfot adott file-bol. Csak ures grfra szabad hasznalni.
   */
  public boolean beolvas( String file )  // Misi belenyult
  {
    // beolvassa a nevet
    // cscsok adatait olvassa, beilleszti
    try
      {
	String sor;
	in=new BufferedReader( new FileReader(file) );
	sor=in.readLine();
	gyoker=new csucs(sor);
	sor=in.readLine();
	while ( sor!=null ) // ezek itt mar a benne levo cscsok
	  {
	    // neve
	    int nev_vege=sor.indexOf("#",1);
	    String neve=sor.substring(1,nev_vege);

	    // azonost
	    int azon_vege=sor.indexOf("#",nev_vege+1);
	    csucs p;
	    if ( (p=Keres(gyoker,sor.substring(nev_vege+1,azon_vege)))==null )
	      p=new csucs(sor.substring(nev_vege+1,azon_vege));
	    lista elozoek, kovetkezok;
	    elozoek=new lista(30);
	    kovetkezok=new lista(30);

	    // csoport
	    int csoport_vege=sor.indexOf("#",azon_vege+1);
	    String csoport=sor.substring(azon_vege+1,csoport_vege);

	    // elzk
	    int elozo_vege=sor.indexOf("#",csoport_vege+1);

	    // kvetkezk
	    int kov_vege=sor.indexOf("#",elozo_vege+1);
	    int kov1=elozo_vege+1;
	    int t1=sor.indexOf(",",kov1);
	    int t2=sor.indexOf("#",kov1);
	    int kov2=t1<t2?t1:t2;
	    if ( kov2==-1 ) kov2=t2;
	    while ( kov2!=-1 && kov2<=kov_vege )
	      {
		String s=sor.substring(kov1,kov2);
		if ( !s.equals("") )
		  kovetkezok.addElement(s);

		kov1=kov2+1;
		t1=sor.indexOf(",",kov1);
		t2=sor.indexOf("#",kov1);
		kov2=t1<t2?t1:t2;
		if ( kov2==-1 ) kov2=t2;
	      }

	    // x koordinata
	    int x_vege=sor.indexOf("#",kov_vege+1);
	    int x=Integer.parseInt(sor.substring(kov_vege+1,x_vege));

	    // y koordinata
	    int y_vege=sor.indexOf("#",x_vege+1);
	    int y=Integer.parseInt(sor.substring(x_vege+1,y_vege));

	    // emelet
	    int e_vege=sor.indexOf("#",y_vege+1);
	    int emelet=Integer.parseInt(sor.substring(y_vege+1,e_vege));

	    // tol
	    int tol_vege=sor.indexOf("#",e_vege+1);
	    String tol=sor.substring(e_vege+1,tol_vege);

	    // ig
	    int ig_vege=sor.indexOf("#",tol_vege+1);
	    String ig=sor.substring(tol_vege+1,ig_vege);

	    // uj cscs
	    ujelem(neve,p.azonosito,csoport,kovetkezok,x,y,emelet,tol,ig);
	    sor=in.readLine();
	  }
	return true;
      }
    catch (Exception e)
      {
	//System.err.println(e);
	return false;  // Misi belnyult
      }
  }

  /**
   * ellenrzi, hogy minden cscshoz (p alatt) normlis rtk van-e rendelve
   */
  private void helyes( csucs p )
  {
    if ( !p.helyes() ) // cscs helyes eljarasa!!!
      rosszak.addElement(p.azonosito);
    
    korker.addElement(p);

    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
      {
	aktualis=(csucs)e.nextElement();
	if ( !aktualis.torolt && !korker.benne(aktualis.azonosito) )
	  helyes(aktualis);
      }
  }

  //  Ezen keresztl lehet elerni a helyes metodust. Kikszbli a krket.
  /**
   * Ellenrzi, hogy minden cscshoz (p alatt) normlis rtk van-e rendelve.
   */
  public Vector Helyes( csucs p )
  {
    korker.removeAllElements();
    rosszak.removeAllElements();
    helyes(p);
    return rosszak;
  }

  /**
   * Eldnti, hogy adott cscsba tovbb mehet-e az adott szemly 
   * (ismerve a csoportjt, honnan jn ... )
   */
  public boolean mehet( String honnan, String hova, String csoport )
  {
    csucs hv=Keres(gyoker,hova);
    Calendar cal=new GregorianCalendar();
    cal.setTime( new Date() );
    String ido=cal.get(Calendar.HOUR)+":"+cal.get(Calendar.MINUTE);
    if ( ido.compareTo(hv.tol)<0 || ido.compareTo(hv.ig)>0 )
      return false; // itt lehet gond, mert ez lexigrafikusan hasonlit ssze

    if ( hv.elozo.benne(honnan) )
      if ( csoport.equals(hv.csoport) || hv.csoport.equals("all") || 
	   ( hv.csoport.equals("diak") && csoport.equals("tanar")) )
	{
	  hv.tortenet.addElement(csoport+"--"+ido);
	  return true;
	}
      else
	return false;
    else
      return false;
  }

  /**
   * Bellman-Ford algoritmus min. utkereseshez. Algoritmusok konyv 450-...
   */

  /**
   * az sszes cscson belltja a min. utkereseshez a kezdeti allapotokat,
   * megszamolja a cscsokat, legyartja az eleket
   */
  private void efk( csucs p )
  {
    p.utinit(); // ez itt belltja a kezdeti rtkeit a cscsnak
    ++csucsSzam;
    korker.addElement(p);

    for ( Enumeration e=p.kovetkezo.elements(); e.hasMoreElements(); )
      {
	aktualis=(csucs)e.nextElement();
	elek.addElement(new el(p,aktualis));
	if ( !aktualis.torolt && !korker.benne(aktualis.azonosito) )
	  efk(aktualis);
      }
  }

  /**
   * Ezen keresztl lehet az efk-t meghvni. Krbefuts elkerlsrt.
   * Az sszes cscson belltja a min. tkeresshez a kezdeti llapotokat,
   * megszmolja a cscsokat, legyrtja az leket.
   */
  public void EFK( csucs p )
  {
    korker.removeAllElements();
    csucsSzam=0;
    efk(getGyoker());
    p.d=0;
  }

  /**
   * Kzelt eljrs. Minimumot vlaszt.
   */
  public void kozelit( csucs u, csucs v )
  {
    if ( v.d > u.d + 1 ) // itt 1 a ket cscs kozotti cscs slya
      {
	v.d=u.d+1;
	v.pi=u;
      }
  }

  /**
   * Bellman-Ford algoritmus.
   */
  public lista BF( csucs honnan, csucs hova )
  {
    EFK(honnan);
    el e;
   
    for ( int i=0; i<csucsSzam; ++i )
      for ( Enumeration ee=elek.elements(); ee.hasMoreElements(); )
	{
	  e=(el)ee.nextElement();
	  kozelit(e.p1,e.p2);
	}

    csucs p=hova;
    lista v=new lista(30);
    while ( !p.azonosito.equals(honnan.azonosito) )
      {
	v.insertElementAt(p,0);
	p=p.pi;
      }
    v.insertElementAt(p,0);
    return v;
  }
}

/**
 * Ket cscsot kt ssze, l osztly.
 */
class el
{
  csucs p1,p2;

  public el( csucs p1, csucs p2 )
  {
    this.p1=p1;
    this.p2=p2;
  }
}
