/* 1999, Frohner kos <szamcsi@elte.hu> */
#include "History.h"
#include <readline/history.h>
#include <stdlib.h>
#include <string.h>
#include "jni_util.h"

JNIEXPORT jint JNICALL 
JNI_OnLoad(JavaVM* vm, void* reserved) {
	printf("onload\n");
	return JNI_VERSION_1_2;
}

JNIEXPORT void JNICALL 
JNI_OnUnload(JavaVM* vm, void* reserved) {
	printf("onunload\n");
}

JNINativeMethod		methods[] = {
	{"read", "(Ljava/lang/String;)V", hist_read},
	{"write", "(Ljava/lang/String;)V", hist_write},
	{"add", "(Ljava/lang/String;)V", hist_add}
};

JNIEXPORT void JNICALL 
Java_History_registerNatives (JNIEnv *env, jclass clazz) {
	(*env)->RegisterNatives(env, clazz, methods, 
			sizeof(methods)/sizeof(JNINativeMethod));
}

JNIEXPORT void JNICALL 
hist_add (JNIEnv *env, jclass clazz, jstring line) {
	char*		cline;

	if(line == NULL) return;
	
	cline = cstring(env, line);
	add_history(cline);
	free(cline);
}

void raiseOnError(JNIEnv *env, int errorno) {
	jclass		cIOException;
	
	if(errorno == 0) return;

	cIOException = (*env)->FindClass(env, "java/io/IOException");
	(*env)->ThrowNew(env, cIOException, strerror(errorno));
}

JNIEXPORT void JNICALL 
hist_read (JNIEnv *env, jclass clazz, jstring filename) {
	char*		cfilename;
	int		retval;
	
	cfilename = cstring(env, filename);
	retval = read_history(cfilename);
	if(cfilename != NULL) free(cfilename);

	raiseOnError(env, retval);
}

JNIEXPORT void JNICALL 
hist_write (JNIEnv *env, jclass clazz, jstring filename) {
	char*		cfilename;
	int		retval;
	
	cfilename = cstring(env, filename);
	retval = write_history(cfilename);
	if(cfilename != NULL) free(cfilename);
	
	raiseOnError(env, retval);
}

