/*
 * CoSeTest.java -- Egy sszekttets-alap szerveralkalmazs
 *
 * Ez az alkalmazs az egyetlen paramterben megadott sorszm TCP
 * porton vrakozik kliensalkalmazsok rkapcsoldsi krelmre. Ha
 * egy kliens rkapcsoldik, akkor vr tle egy egsz szmot,
 * s ngyzetre emelve visszakldi a kapott eredmnyt.

 * Ez egy szekvencilis szerver, vagyis a klienseket egyms utn 
 * szolglja ki (azaz ha egy kliens sokig nem kld adatot, akkor 
 * a szerver addig vrakozni fog ...).
 * A szerver lell, ha 0 szmot kld egy kliens (de a 0-t ngyzetre 
 * emelve visszakldi a kliensnek ilyenkor is).
 *
 * A programparamterek:
 *
 *  - A szerver TCP portjnak a sorszma
 *
 * Egy plda a futtatsra:
 *
 *  java CoSeTest 5678
 */

import java.io.*;
import java.net.*;

public class CoSeTest {

  public static void hasznalati_utasitas() {
      System.out.println("Hasznlat: java CoSeTest portsorszm");
      System.exit(-1);
  }

  public static void main(String[] args) {
    int server_port = 0;
    ServerSocket ss = null;
    Socket s = null;
    String keres = null, valasz = null;
    int keres_erteke = 0;
    boolean kilep = false;

    if (args.length != 1) hasznalati_utasitas();

    try { server_port = Integer.parseInt(args[0]); }
      catch (NumberFormatException e) { hasznalati_utasitas(); }

    try {

      /* Ltrehozzuk a kommunikcis vgpontunkat */
      ss = new ServerSocket(server_port);
      while (!kilep) {

        /* Felvesszk a kapcsolatot a kvetkez klienssel */
        /* A szerver itt vrakozik egy j kliensre, ha kell */
        s = ss.accept();

        /* Ezzel tudunk a kommunikcis vgpontunkrl adatot olvasni: */
        BufferedReader input = new BufferedReader(
          new InputStreamReader(s.getInputStream()));

        /* Ezzel tudunk a kommunikcis vgpontunkra adatot rni: */
        PrintWriter output = new PrintWriter(s.getOutputStream());



// Itt kezddik a szolgltatsfgg kdrszlet
        keres = input.readLine();
        try {
          keres_erteke = Integer.parseInt(keres);
          valasz = Integer.toString(keres_erteke*keres_erteke);
        } catch (NumberFormatException e) { valasz = "rvnytelen adat!"; }
        output.println(valasz); output.flush(); // Visszakldtk

        if (keres_erteke == 0) kilep = true; // lljon le a szerver

// Itt fejezdik be a szolgltatsfgg kdrszlet
        s.close();
      }

    } catch (IOException e) {
      System.err.println(e); // Kirtuk a hiba okt ...
    }
    finally { // Lezrjuk a kommunikcis vgponthoz tartoz socketot ...
      try { ss.close(); } catch (IOException ex) {
        System.err.println("Nem tudom lezrni a kapcsolatot!");
        }
    }
  }
}
