/* MCASTSzerver.java
 *
 * Multicast csomagokra vr a megadott csoportban a megadott UDP-porton.
 *
 * A programparamterek:
 *
 *  - az elrni kvnt multicast-csoport cme
 *  - A szerver UDP portjnak a sorszma
 *
 * Hvsa:
 *  java MCASTSzerver MCASTcsoportcm port
 *
 */

import java.net.*;
import java.io.IOException;

public class MCASTSzerver {

  public static void main(String[] args) {
    if (args.length == 2) {
      try {
        int port=Integer.parseInt(args[1]);
        byte[] uzenet = new byte[65536];
        DatagramPacket p = new DatagramPacket(uzenet, 65536);
        MulticastSocket ms = new MulticastSocket(port);
        ms.joinGroup(InetAddress.getByName(args[0]));
        ms.receive(p);
        ms.leaveGroup(InetAddress.getByName(args[0]));
        String kiir = new String(uzenet);
        System.out.println("A kapott zenet tartalma:"+kiir);
        System.out.println("A kld:"+p.getAddress().toString());
      } catch (SocketException e) {
        System.out.println("Kivtel kivltva: SocketException");
      } catch (IOException ie) {
        System.out.println("Kivtel kivltva: IOException");
      }
    } else {
      System.out.println("Hvsa: java MCASTSzerver MCASTcm portazon.");
    }
  }
}
