/*
 * Sorozatfogad.java -- Megbzhat adatcsatornnkon csomagokat fogad
 *
 * Ez az alkalmazs csomagokat fogad a futtat szmtgp
 * megadott sorszm UDP-portjrl, a fogadott csomag tartalmt pedig
 * kirja a kpernyre (szabvnyos kimenetre). Ha a csomagok nem a
 * vart sorrendben rkeznek, akkor a pozitv visszajelzsi s
 * jrakldsi eljrssal lesz biztostva a helyes tviteli sorrend
 * megtartsa.
 *
 * Programparamterek:
 *
 *  Els    : a szerver UDP-portjnak a sorszma
 *  Msodik : a fogadni kvnt adatcsomagok szma
 *
 * Egy plda a felhvsra:
 *
 *  java Sorozatfogad 6789 1
 *
 */

import java.io.*;
import java.net.*;

public class Sorozatfogad {

  public static void hasznlati_utasts() {
    System.out.println("Hasznlat: java Sorozatfogad " +
                       " portsorszm csomag_darabszm");
    System.exit(-1);
  }

  public static void main(String[] args) {
    int server_port = 0;

    if (args.length != 2) hasznlati_utasts(); // sok/kevs argumentum
    try {
      server_port = Integer.parseInt(args[0]); // szerver port-sorszma
    } catch (NumberFormatException e) {
      hasznlati_utasts();
    }

    try {
      MegbizhatoEgyiranyuDatagramSocket s =
             new MegbizhatoEgyiranyuDatagramSocket(server_port);
      byte[] zenet = new byte[1500]; // helyet csinlunk az zenetnek
      String szveg; // hely a Stringg konvertlt zenetnek (szksges,
                     // ugyanis Stringknt akarjuk kiratni, gy  
                     // konvertlni kell majd)

      // Ltrehozunk egy csomagot, ahov a berkez zenetet tesszk
      DatagramPacket p = new DatagramPacket(zenet, zenet.length);

      // Az adott UDP-porton ltrehozzuk a szerver kommunikcis vgpontot

      for (int i=0;i<Integer.parseInt(args[1]);i++) {

        s.nyugtzott_receive(p); // vrunk egy csomagot, s 
                                 // a tartalmt beolvassuk p-be
        // majd a kapott zenet tartalmt karakterlncc konvertljuk
        szveg = new String(zenet, 0, p.getLength());
        System.out.println("*Fogadtam egy csomagot a " +  // s kirjuk
                           p.getAddress().getHostName() +
                           " szmtgptl. " +
                           " A tartalma: " + szveg);
      } // for ciklus vge
      s.close();                            // vgpont lezrsa
    } catch (UnknownHostException e) {
      System.err.println("Ismeretlen host!");
    } catch (IOException e) {
      System.err.println("Nem sikerlt a klds!");
    }
  }
}
