import java.awt.*;
/**
 * Specialised layout manager, which handles absolute
 * coordinates, but answers the minimal size of this
 * canvas correctly. 
 */
class CanvasLayout implements LayoutManager {
    public void addLayoutComponent(String name, Component comp) {}
    
    public void layoutContainer(Container parent) {
    }
    
    public Dimension minimumLayoutSize(Container parent) {
        Component[] components = parent.getComponents();
        
        Dimension min = new Dimension(0, 0);
        Point location = new Point();
        Dimension cmin;

        // calculating the minimum size using absolute coordinates
        for(int i = 0; i < components.length; i++) {
            cmin =components[i].getMinimumSize();
            components[i].getLocation(location);
            if(cmin.width + location.x > min.width) {
                min.width = cmin.width + location.x;
            }
            if(cmin.height + location.y > min.height) {
                min.height = cmin.height + location.y;
            }
        } // end for

        return min;
    }
    
    public Dimension preferredLayoutSize(Container parent) {
        Component[] components = parent.getComponents();
        
        Dimension pref = new Dimension(0, 0);
        Point location = new Point();
        Dimension cpref;

        // calculating the preferred size using absolute coordinates
        for(int i = 0; i < components.length; i++) {
            cpref =components[i].getPreferredSize();
            components[i].getLocation(location);
            if(cpref.width + location.x > pref.width) {
                pref.width = cpref.width + location.x;
            }
            if(cpref.height + location.y > pref.height) {
                pref.height = cpref.height + location.y;
            }
        } // end for

        return pref;
    }
    
    public void removeLayoutComponent(Component comp) {}
} // CanvasLayout
