import java.lang.reflect.*;
public class Tracer implements InvocationHandler {
    private Object traced;

    public static Object newInstance(Object obj) {
        return java.lang.reflect.Proxy.newProxyInstance(
            obj.getClass().getClassLoader(),
            obj.getClass().getInterfaces(),
            new Tracer(obj));
    }

    private Tracer(Object obj) {
        traced = obj;
    }

    public Object invoke(Object proxy, Method m, Object[] args) throws Throwable {
        Object result;
        try {
            System.out.println("before method " + m.getName());
            result = m.invoke(traced, args);
            } catch (InvocationTargetException e) {
                throw e.getTargetException();
            } catch (Exception e) {
                throw new RuntimeException("unexpected invocation exception: " +
                       e.getMessage());
            } finally {
                System.out.println("after method " + m.getName());
            }
        return result;
    }
} // Tracer
