// FoglalExec.java
//
// Felhasznli meghajt program az osztott naptr tesztelsre
// Paramterezst lsd a FoglaloOsztaly.java fjlban

import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;
import java.rmi.Naming;
import java.rmi.server.*;
import java.net.*;

public class FoglalExec {

  public static void main(String args[]) {
    System.setSecurityManager(new RMISecurityManager());

    try {
      System.out.println("Megksrlem lefoglalni a megadott idpontokat!");
      FoglaloInterface inditando_alkalmazas = (FoglaloInterface)
          Naming.lookup("FoglaloOsztaly");
      if (inditando_alkalmazas.Elfoglaltsag_Bejegyzese(args)) {
        System.out.println("Minden rsztvevnl be lett jegyezve.");
      } else {
        System.out.println("Egy rsztvevnl se lett bejegyezve.");
      }
    } catch (NumberFormatException e) {
      System.out.println("Szablytalan formtum numerikus rtk!");
    } catch (java.rmi.UnknownHostException e) {
      System.out.println("Szmomra ismeretlen szmtgpre hivatkoztak!");
      System.out.println("Rszletesebb lers:"+e.getMessage()+
            ". Remlem segt!");
    } catch (java.net.MalformedURLException e) {
      System.out.println("A foglalst vgz osztly nem rheto el!");
    } catch (java.rmi.NotBoundException e) {
      System.out.println("A foglalst vgz obj. nincs a registryben!");
    } catch (java.rmi.RemoteException e) {
      System.out.println("A foglal osztly metdusa nem elrhet!");
    } catch (TranzakcioException e) {
      System.out.println("Tranzakcit nem lehetett vgrehajtani!");
      System.out.println("A tranzakci fggben maradhatott!");
      System.out.println("Problma oka:"+e.getMessage()+".");
    }
  }
}
