// Inicializal.java
//
// Bejegyzi a perzisztens naplz objektumot az RMI nvszolgltatjnl
// (s persze az aktivcis rendszernl is)

import java.rmi.*;
import java.rmi.activation.*;
import java.util.Properties;
import java.io.File;

public class Inicializal {

    // Ez az osztly jegyzi be a perzisztens naplz objektumot
    // az rmid s az rmiregistry folyamatoknl

    public static void main(String[] args) throws Exception {
	
      System.setSecurityManager(new RMISecurityManager());
	
      Properties p = new Properties(); 
      p.put("java.security.policy", // Az elindtand Java
         "/home/aktiv/POLICY");     // virtulis gp krnyezeti
                                    // jellemzinek a belltsa

      // Az aktivcis csoporthoz tartoz Java virtulis gp 
      // indtsi paramterei
      ActivationGroupDesc.CommandEnvironment pp = null; 
      ActivationGroupDesc aktCsop = new ActivationGroupDesc(p, pp);
	
      // A bejegyzssel megkaphatjuk a csoportazonostt
      ActivationGroupID csopAzon = 
         ActivationGroup.getSystem().registerGroup(aktCsop);
	
      // Itt hozzuk ltre magt a csoportot
      ActivationGroup.createGroup(csopAzon, aktCsop, 0);

      // Itt kell (lehet) megadni az osztlyaink elrsi URL-jt
      // (ami esetnkben egy directory lesz)
      String URL = "file:/home/aktiv/";

      // Kezdeti rtkknt tadjuk a naplfjl nevt
      MarshalledObject adat = new MarshalledObject(
          new String("/home/aktiv/Pnaplo.log"));

      // sszelltjuk az aktivcis informcis struktrt
      ActivationDesc ler = new ActivationDesc 
          (csopAzon, "PNaplo", URL, adat);
	
      NaploInterface napi = 
          (NaploInterface)Activatable.register(ler);

      // Bejegyezzk az objektumot a registrybe
      Naming.rebind("Naplo", napi);
      System.out.println("Naplzs fut");

      System.exit(0); // Lpjnk ki ...
    }

}
