// Naplo.java
//
// A tvoli naplzsi interfszt implementl objektumok osztlya.

import java.rmi.Naming;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.io.*; // Fjlba is naplzunk

public class Naplo extends UnicastRemoteObject implements NaploInterface {

  BufferedWriter bw = null; // A naplfjl elrse

  public Naplo() throws java.rmi.RemoteException {
    super(); // Ez exportlja a tvoli objektumot
    try {
      FileWriter fw = new FileWriter("naplo.log"); // fjl
      bw = new BufferedWriter(fw); // bufferelt r ltrehozsa
    } catch (IOException e) {
      System.out.println("Naplfjl nem hozhat ltre.");
      System.out.println("Lemezre naplzs sznetel.");
    }
  }

  public void naploz(String szoveg) throws java.rmi.RemoteException {
    System.out.println(szoveg); // Kpernyre is naplzunk
    if (bw != null) { // Ha tudunk, akkor fjlba is
      try {
        bw.write(szoveg);
        bw.newLine();
        bw.flush(); // Kiratjuk a diszkre
      } catch (IOException e) {
        System.out.println(">> Naplfjl nem rhat. <<");
      }
    }
  }

  public static void main(String args[]) {
    System.setSecurityManager(new RMISecurityManager());
    try {
      Naplo n = new Naplo();
      Naming.rebind("Naplo",n);     // Bejegyzi a registrybe
      System.out.println("Naplzs fut ...");
    } catch (Exception e) {
      System.out.println("Naplzs nem indthat ...");
      System.out.println("Hiba oka:"+e.getMessage());
    }
  }
}
