// PNaplo.java
//
// Aktivlhat naplz osztly.

import java.io.*;
import java.rmi.*;
import java.rmi.activation.*;

public class PNaplo extends Activatable implements NaploInterface {

  private String filenev;   // A naplfjl neve
  BufferedWriter bw = null; // A naplfjl elrse

  // Az RMI aktivcis rendszere ezt a konstruktort hvja meg, ha
  // szksg van egy j - korbban bejegyzett - naplz objektum
  // ltrehozsra (aktivlsra+exportlsra)
  public PNaplo(ActivationID azon, MarshalledObject adat)
      throws RemoteException, ClassNotFoundException, java.io.IOException {

    super(azon, 0); // port=0, azaz brmilyen TCP port j neknk

    // Mi volt a fjlnv, amit kezdeti rtkknt tadtak neknk
    // az aktivcis informcik kztt?
    filenev = (String)adat.get();

    try {
      boolean app=false; // Hozzfzni vagy ltrehozni kell?
      if (new File(filenev).exists()) app=true; // Hozzfznk ...
      FileWriter fw = new FileWriter(filenev,app); // fjl
      bw = new BufferedWriter(fw); // bufferelt r ltrehozsa
    } catch (IOException e) {
      System.out.println("Naplfjl nem rhat.");
      System.out.println("Lemezre naplzs sznetel.");
    }
  }

  public void naploz(String szoveg) throws java.rmi.RemoteException {
    // System.out.println(szoveg); // Kpernyre nem naplzunk
    if (bw != null) { // Ha tudunk, akkor fjlba is
      try {
        bw.write(szoveg);
        bw.newLine();
        bw.flush(); // Kiratjuk a diszkre
      } catch (IOException e) {
        System.out.println(">> Naplfjl nem rhat. <<");
      }
    }
  }

}
