// RMIMutexFactoryInterface.java
//
// Ez az RMIMutex objektumok konstruktornak a tvoli interfsze
//
// Eleg kezdetleges, van mit javitani a koncepcion, de arra megfelel, hogy
// szemleltesse egy tavoli szinkronizacios mechanizmus eleresenek elemeit.

public interface RMIMutexFactoryInterface extends java.rmi.Remote 
{
  // Egy j mutex ltrehozsa (a mutex neve a parameter)
  // A mutexet bejegyzi a registrybe is "RMI_mutex_"+nev neven.
  // Ha volt mar ilyen mutex, akkor a registrybol a regebbi torolve lesz
  public RMIMutexInterface Ujmutex(String nev) 
           throws java.rmi.RemoteException;

  // Visszaad egy referenciat egy meglevo mutex objektumra.
  // FONTOS: A referenciat a registrybol keresi vissza, igy ha azt kozben
  // leallitanak (ugy, hogy a mutexet kezelo Java Virtualis Gep azt tuleli), 
  // akkor a muvelet sikertelenul ter vissza, annak ellenere, hogy az illeto
  // tavoli mutex meg letezhet. Ha a registryt leallitanak, akkor persze az
  // "RMI_mutexek" bejegyzes is eltunne onnan, tehat a Refmutex() metodusnak
  // ekkor mar ezert sincs sok ertelme.
  public RMIMutexInterface Refmutex(String nev) 
           throws java.rmi.RemoteException, RMIMutexNemtalalt;
}
