// TranzakcioManagerFactory.java
//
// Ez a "TranzakcioManager" osztly konstruktornak tekinthet.
// A ltrehozott tranzakcikezelkhz egy-egy szveges azonostt rendel.

import java.rmi.Naming;
import java.rmi.server.UnicastRemoteObject;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.util.Hashtable;
import java.util.Enumeration; 
import java.lang.Thread;
import java.net.InetAddress;

public class TranzakcioManagerFactory extends UnicastRemoteObject 
      implements TranzakcioManagerFactoryInterface {

  private static Object mutex = new Object(); // klcsns kizrshoz
  private static String ip_cimem;

  public TranzakcioManagerFactory() throws RemoteException {
    super(); // Tvoli (konstruktor) objektum exportlasa
  }

  // Egy j tranzakcikezel ("koordinator") ltrehozsa
  public TranzakcioManagerInterface Ujtranzakcio() 
         throws java.rmi.RemoteException {

    synchronized(mutex) { // tranzakcik klcsnsen kizrva
      long most=System.currentTimeMillis(); // az ra llsa
      while (System.currentTimeMillis() <= most) {
        try {
          // legalbb 1 ezredmsodperc eltelik ...
          Thread.currentThread().sleep(1);
        } catch (Exception e) {
        }
      }
      most=System.currentTimeMillis(); // az ra j llsa
      String tid=(new Long(most)).toString()+"_"+ip_cimem;
      System.out.println("Tranzakci TID:"+tid);
      // Visszaadjuk az j tranzakcikezelt
      return new TranzakcioManager(tid);
    }
  }

  // A fprogramja pldnyost egy tranzakcikezelt s
  // bejegyzi a registrybe.
  public static void main(String args[]) {
    System.setSecurityManager(new RMISecurityManager());
    try {
      ip_cimem=(InetAddress.getLocalHost()).getHostAddress();
      TranzakcioManagerFactory tf = new TranzakcioManagerFactory();
      Naming.rebind("RMI_tranzakciok",tf); // bejegyzse
      System.out.println("Tranzakcimanager factory fut!");
    } catch (Exception e) {
      System.out.println("Tranzakcimanager f. NEM FUT!"+e.getMessage());
    }
  }
}
