import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class CookieTestServlet extends HttpServlet {

    public void doGet(HttpServletRequest krs, HttpServletResponse vlasz)
           throws IOException, ServletException {

        Cookie[] cookies = krs.getCookies();                 //kapott cookie-k
        Cookie jcookie = null;                                      //j cookie
        Exception cookiex = null;     //j cookie felvtelekor fellpett kivtel
        String jnv = krs.getParameter("cookiename");                 //jnv
        String jrtk = krs.getParameter("cookievalue");            //jrtk
        String jmegjegyzs = krs.getParameter("cookiecomment");//jmegjegyzs
        int jlejr = -1;                                              //jlejr
        boolean jbiztonsgos = krs.getParameter("cookiesecure")!=null;
        if (jnv!=null && jnv.length()>0 && jrtk!=null) {      //j cookie
           try {
               jlejr = Integer.parseInt(krs.getParameter("cookiemaxage"));
           } catch (Exception e) {}
           try {                                           //j cookie felvtele
               jcookie = new Cookie(jnv, jrtk);
               if (jmegjegyzs!=null) jcookie.setComment(jmegjegyzs);
               jcookie.setMaxAge(jlejr);
               jcookie.setSecure(jbiztonsgos);
               vlasz.addCookie(jcookie);
           } catch (Exception e) {                          //kivtel eltrolsa
             cookiex = e;
           }	
        } else {
          jnv = null;
        }

        String trlnv = krs.getParameter("deletename");             //trls
        if (trlnv!=null) for (int i=0; i<cookies.length; i++)
           if (cookies[i].getName().equals(trlnv)) {
           	cookies[i].setMaxAge(0);
                vlasz.addCookie(cookies[i]);
           }
        
        vlasz.setContentType("text/html");

        PrintWriter out = vlasz.getWriter();
        out.println("<html><head><title>" + getClass().getName());
        out.println("</title></head><body>");
        out.println("<H1>Klienstl kapott cookie-k</H1>");

        if (cookies.length > 0) {                          //tblzat felptse
           out.println("<TABLE BORDER=\"1\" CELLPADDING=\"3\" "+
                       "CELLSPACING=\"0\">");
           out.println("<TR><TD><B>Nv</B><TD><B>rtk</B><TD><B>Verzi</B>"+
                       "<TD><B>Megjegyzs</B><TD><B>lettartam(sec)</B>"+
                       "<TD><B>Biztonsgos?</B><TD><B>Domain</B><TD>"+
                       "<B>tvonal</B><TD><B>Trls</B>");
           for (int i = 0; i < cookies.length; i++) {       //cookie-k listzsa
                Cookie cookie = cookies[i];
                out.print("<TR><TD>"+cookie.getName()+"<TD>"+cookie.getValue()+
                          "<TD>"+cookie.getVersion()+"<TD>"+cookie.getComment()+
                          "<TD>"+cookie.getMaxAge()+"<TD>"+cookie.getSecure()+
                     "<TD>"+cookie.getDomain()+"<TD>"+cookie.getPath()+"<TD>");
                if (cookie.getName().equals(trlnv)) out.println("Trlve");
                else out.println("<A HREF="+vlasz.encodeURL(        //trlhet
                     getClass().getName()+"?deletename="+
                     java.net.URLEncoder.encode(cookie.getName()))+
                     ">trl</A>");
            }
            out.println("</TABLE>");
        } else out.println("Nem kldtt a kliens cookie-kat.");

        if (jnv!=null) {                                           //j cookie
           out.println("<H1>j cookie</H1>");
           if (jcookie==null || cookiex!=null) out.println("Hiba a \""+jnv+
              "\" nev cookie ltrehozsakor: <BR>"+cookiex);
           else {
                out.println("<TABLE BORDER=\"1\" CELLPADDING=\"3\" "+
                       "CELLSPACING=\"0\"");
              out.println("<TR><B><TD>Nv<TD>rtk<TD>Verzi<TD>Megjegyzs<TD>"+
                    "lettartam(sec)<TD>Biztonsgos?<TD>Domain<TD>tvonal</B>");
             out.print("<TR><TD>"+jcookie.getName()+"<TD>"+jcookie.getValue()+
                      "<TD>"+jcookie.getVersion()+"<TD>"+jcookie.getComment()+
                        "<TD>"+jcookie.getMaxAge()+"<TD>"+jcookie.getSecure()+
                         "<TD>"+jcookie.getDomain()+"<TD>"+jcookie.getPath());
                out.println("</TABLE>");
           }
        }

        out.println("<H1>Cookie hozzadsa</H1>");           //cookie hozzadsa
        out.println("<form action="+getClass().getName()+" method=POST>");
        out.println("Nv:<input type=text length=20 name=cookiename><br>");
        out.println("rtk:<input type=text length=20 name=cookievalue><br>");
        out.println("Megjegyzs:<textarea rows=3 name=cookiecomment>");
        out.println("</textarea><br>");
        out.print("lettartam(sec):");
        out.println("<input type=text length=20 name=cookiemaxage><br>");
        out.println("Biztonsgos?:<input type=checkbox name=cookiesecure>");
        out.println("<br><input type=submit value=\"elkld\"></form>");
                        
        out.println("</body>");
        out.println("</html>");
        out.close();
    }

    public void doPost(HttpServletRequest krs, HttpServletResponse vlasz)
           throws IOException, ServletException {
           doGet(krs, vlasz);
    }

}
