import java.io.*;
import java.util.Enumeration;
import javax.servlet.*;
import javax.servlet.http.*;

public class LifeTestServlet extends HttpServlet {

    static int pldnyszmll;                                //pldnyszmll
    int pldnysorszm = ++pldnyszmll;                     //pldnysorszm
    int futsszm;                                                   //futsszm

    public void init() {
           log(pldnysorszm+": init");                   //elinduls naplzsa
    }

    private int programszlszm;                      //programszlak szmllsa
    private synchronized void programszlEleje() {                     //belps
            programszlszm++;
    }
    private synchronized void programszlVge() {                      //kilps
            programszlszm--;
            if (programszlszm == 0 && megszntet()) notifyAll();
    }
    private synchronized int programszlSzm() {
            return programszlszm;
    }
    
    public void service(HttpServletRequest krs,
                        HttpServletResponse vlasz)
           throws ServletException, IOException {
       try {
           programszlEleje();
           log(pldnysorszm+": service");
           vlasz.setContentType("text/html");
           PrintWriter out = vlasz.getWriter();
           out.println("<PRE>"+getClass().getName()+" adatai");
           out.println("Pldnyszmll = "+pldnyszmll);
           out.println("Pldnysorszm = "+pldnysorszm);
           out.println("Futsszm = "+(++futsszm));
           out.println("Programszlszm = "+programszlSzm());
           out.println();
           out.println("Inicializl paramterek");   //inicializl paramterek
           Enumeration e = getInitParameterNames();                  //listzsa
           while (e.hasMoreElements()) {
                 String nv = (String)e.nextElement();
                 String rtk = getInitParameter(nv);
                 out.println("   " + nv + " = " + rtk); 
           }
           out.println(); out.flush();
           out.println("Kliens jellemzi");          //kliensjellemzk listzsa
           out.println("Kliens cme = " + krs.getRemoteAddr());
           out.println("Kliens gp = " + krs.getRemoteHost());
           out.println(); out.flush();
           out.println("Szerver jellemzi");        //szerverjellemzk listzsa
           out.println("Szerver neve = " + krs.getServerName());
           out.println("Szerver portja = " + krs.getServerPort());
           out.println(); out.flush();
           out.println("A krs jellemzi");          //krsjellemzk listzsa
           out.println("Karakterkdols = " + krs.getCharacterEncoding());
           out.println("Krs hossza = " + krs.getContentLength());
           out.println("Krs tpusa = "+ krs.getContentType());
           out.println("Krs protokollja = "+ krs.getScheme());
           out.println("Hasznlt protokoll = "+ krs.getProtocol());
           out.println(); out.flush();

           out.println("Krs paramterei");             //paramterek listzsa
           e = krs.getParameterNames();
           while (e.hasMoreElements()) {
                 String nv = (String)e.nextElement();
                 String[] rtk = krs.getParameterValues(nv);
                 out.print("   " + nv + " = ");
                 for (int i = 0; i < rtk.length; i++)
                     out.print(rtk[i] + " ");
                 out.println();
           }
           out.println(); out.flush();

           out.println("HTTP fejlc");                   //HTTP fejlc listzsa
           e = krs.getHeaderNames();
           while (e.hasMoreElements()) {
                 String nv = (String)e.nextElement();
                 String rtk = krs.getHeader(nv);
                 out.println("   " + nv + " : " + rtk);
           }
           out.println(); out.flush();

           out.println("HTTP jellemzk");             //HTTP jellemzk listzsa
           out.println("Biztonsg: " + krs.getAuthType());
           out.println("HTTP tpus: " + krs.getMethod());
           out.println("Krs tvonala: " + krs.getPathInfo());
           out.println("Krs tvonalnak megfelel tvonal: " +
                        krs.getPathTranslated());
           out.println("Krs paramterei: " + krs.getQueryString());
           out.println("Felhasznl: " + krs.getRemoteUser());
           out.println("Kliensoldali kapcsolatazonost: " +
                        krs.getRequestedSessionId());
           out.println("Krs URI: " + krs.getRequestURI());
           out.println("Servlet tvonala: " + krs.getServletPath());
           out.println(); out.flush();
           out.print("Idhzs");                                     //idhzs
           for (int i=0; i<10; i++) {
           	if (megszntet()) break;
           	try {
           	    Thread.currentThread().sleep(1000);
                } catch (InterruptedException ie) {}
                out.print("."); out.flush();
           }

           out.println("</PRE>"); out.flush();
       } finally {
         programszlVge();
       }
    }

    private boolean megszntets;              //servlet megszntetsre kerlt-e
    private synchronized boolean megszntet() {
            return megszntets;
    }
    private synchronized void megszntet(boolean b) {   //servelet megszntetse
            megszntets=b;
    }
   
    public synchronized void destroy() {
    	   megszntet(true);
           while (programszlSzm() > 0) try {    //fut programszlak megvrsa
                 wait();
           } catch (InterruptedException e) {}
           log(pldnysorszm+": destroy");
    }

}
