import java.io.*;
import java.util.Date;
import javax.servlet.*;
import javax.servlet.http.*;

public class SessionTestServlet extends HttpServlet {

    public void doGet(HttpServletRequest krs, HttpServletResponse vlasz)
           throws IOException, ServletException {

        HttpSession session = krs.getSession();          //j krnyezet krse
        if (krs.getParameter("invalidate")!=null && !session.isNew()) {
           session.invalidate();
           session = krs.getSession(true);
        }
        
        String jnv = krs.getParameter("paramname");
        String jrtk = krs.getParameter("paramvalue");
                                                       //j attribtum felvtele
        if (jnv!=null && jnv.length()>0 && jrtk!=null)
           session.putValue(jnv, jrtk);
        else jnv = null;

        String[] adatok = session.getValueNames();

        String trlnv = krs.getParameter("deletename");
        
        vlasz.setContentType("text/html");

        PrintWriter out = vlasz.getWriter();
        out.println("<html><head><title>" + getClass().getName());
        out.println("</title></head><body>");
        out.println("<H1>Session jellemzi</H1>");         //krnyezet jellemzi

        out.println("Azonost = "+session.getId()+"<br>");
        out.println("j? = "+session.isNew()+"<br>");
        out.println("Ltrehozs idpontja = "+
                    new Date(session.getCreationTime())+"<br>");
        out.println("Utols hozzfrs idpontja = "+
                    new Date(session.getLastAccessedTime())+"<br>");
        out.println("Timeout(sec) = "+session.getMaxInactiveInterval()+"<br>");

        out.println("<H1>Session adatai</H1>");             //krnyezet tartalma
        if (adatok.length > 0) {                             //tblzatban lista
           out.println("<TABLE BORDER=\"1\" CELLPADDING=\"3\" "+
                       "CELLSPACING=\"0\">");
        out.println("<TR><TD><B>Nv</B><TD><B>rtk</B><TD><B>rtk osztlya"+
                    "</B><TD><B>Trls</B>");
           for (int i = 0; i < adatok.length; i++) {
           	Object adat = session.getValue(adatok[i]);
                out.print("<TR><TD>"+adatok[i]+"<TD>"+adat+"<TD>"+
                         (adat==null ? "-" : adat.getClass().getName())+"<TD>");
                if (adatok[i].equals(trlnv)) {
                   out.println("Trlve");
                   session.removeValue(trlnv);
                } else if (adatok[i].equals(jnv)) out.println("j");
                else out.println("<A HREF="+vlasz.encodeURL(
                     getClass().getName()+"?deletename="+
                     java.net.URLEncoder.encode(adatok[i]))+
                     ">trl</A>");
            }
            out.println("</TABLE>");
            out.println("<form action="+getClass().getName()+" method=POST>");
            out.println("<input type=hidden name=invalidate value=now><br>");
            out.println("<input type=submit value=\"Mindent trl\"></form>");
        } else out.println("Nincsenek adatok a session-ban.");

        out.println("<H1>Paramter hozzadsa</H1>");     //paramter hozzadsa
        out.println("<form action="+getClass().getName()+" method=POST>");
        out.println("Nv:<input type=text length=20 name=paramname><br>");
        out.println("rtk:<input type=text length=20 name=paramvalue><br>");
        out.println("<input type=submit value=\"elkld\"></form>");
                        
        out.println("</body>");
        out.println("</html>");
        out.close();
    }

    public void doPost(HttpServletRequest krs, HttpServletResponse vlasz)
           throws IOException, ServletException {
           doGet(krs, vlasz);
    }

}
