import javax.swing.*;
import javax.swing.border.*;

public class SwingBorderTest extends SwingTest
                             implements java.awt.event.ActionListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingBorderTest().init(args);
  }
  
  private JButton gomb;                                           //keretes gomb
  private Icon ikon;                                    //ikon a MatteBorder-hez
                                                         //legyen-e keretfelirat
  private JCheckBox felirat = new JCheckBox("feliratos keretek?");
  protected void buildGUI() {                  //felhasznli fellet felptse
            ikon = loadIcon("images/wood.jpg");                 //ikon betltse
            fellet.add( new JScrollPane(napl) );             //keretek listja
            JPanel panel = new JPanel();                         //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(265, 85));
            panel.add(felirat);                                 //felirat krse
            gomb = new JButton(" + ");                       //keret hozzvtele
            panel.add(gomb);
            gomb.setActionCommand("+");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JButton(" - ");                     //kls keret trlse
            panel.add(gomb);
            gomb.setActionCommand("-");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            for (int i=0; i < stlusvlts.length; i++) {//megjelentsi stlust
                gomb = new JButton(stlusok[i].getName());     //vlt mveletek
                panel.add(gomb);                          //felvtele gombokknt
                gomb.addActionListener(stlusvlts[i]);          //stlusvlts
            }
            gomb = new JButton("keretes gomb");  //kerettel rendelkez komponens
            debugGraphics(gomb);            //lehet nyomkvetni a megjelentst
            fellet.add(gomb, java.awt.BorderLayout.NORTH);
            keretlista();                          //kezdeti keretek kilistzsa
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) {    //gomblenyoms
         Border keret = gomb.getBorder();                         //feldolgozsa
         if (ae.getActionCommand().equals("+")) {          //j keret hozzadsa
            if (keret instanceof CompoundBorder)              //sszetett keret?
                keret = ((CompoundBorder)keret).getOutsideBorder();
            String kerettpus = null;             //jelenlegi kls keret tpusa
            if (keret instanceof TitledBorder) {
               kerettpus = ((TitledBorder)keret).getTitle();
               kerettpus = kerettpus.substring(0, kerettpus.indexOf("@"));
            } else if (keret!=null) {
              kerettpus = keret.getClass().getName();
              kerettpus = kerettpus.substring(kerettpus.lastIndexOf(".")+1);
            }
            Border jkeret = null;
            String jkerettpus = null;
            double rnd;                                           //vletlenszm
            boolean feliratos = felirat.isSelected();       //feliratos legyen-e
            while (true) {              //ne legyen egymson azonos tpus keret
                  rnd = Math.random();
                  if (rnd<0.2) {                                    //res keret
                     jkeret = BorderFactory.createEmptyBorder(
                          (int)(Math.random()*10.0), (int)(Math.random()*10.0),
                          (int)(Math.random()*10.0), (int)(Math.random()*10.0));
                  } else if (rnd<0.4) {                          //kiemelt keret
                    jkeret = BorderFactory.createEtchedBorder();
                  } else if (rnd<0.6) {                          //vonalas keret
                    jkeret = BorderFactory.createLineBorder(
                              gomb.getForeground(), (int)(Math.random()*10.0));
                  } else if (rnd<0.7) {                   //lesllyesztett keret
                    jkeret = BorderFactory.createLoweredBevelBorder();
                  } else if (rnd<0.9) {                              //ikonkeret
                    jkeret = BorderFactory.createMatteBorder(
                           (int)(Math.random()*10.0), (int)(Math.random()*10.0),
                           (int)(Math.random()*10.0), (int)(Math.random()*10.0),
                           ikon);
                  } else                                         //kiemelt keret
                    jkeret = BorderFactory.createRaisedBevelBorder();
                  jkerettpus = jkeret.getClass().getName();
                  jkerettpus = jkerettpus.substring(
                                 jkerettpus.lastIndexOf(".")+1);
                                          //klnbzik az elz keret tpustl?
                  if (keret==null || !kerettpus.equals(jkerettpus)) break;
            }        
            if (feliratos) {                          //plussz felirat a kereten
               rnd = Math.random();
               int pozci;                              //felirat pozcionlsa
               if (rnd < 1.0/6.0)
                  pozci = TitledBorder.ABOVE_TOP;         //fels keret felett
               else if (rnd < 2.0/6.0)
                    pozci = TitledBorder.TOP;                  //fels kereten
               else if (rnd < 3.0/6.0)
                    pozci = TitledBorder.BELOW_TOP;        //fels keret alatt
               else if (rnd < 4.0/6.0)
                    pozci = TitledBorder.ABOVE_BOTTOM;     //als keret felett
               else if (rnd < 5.0/6.0)
                    pozci = TitledBorder.BOTTOM;                //als kereten
               else pozci = TitledBorder.BELOW_BOTTOM;      //als keret alatt
               rnd = Math.random();
               int igazts;                                 //felirat igaztsa
               if (rnd < 1.0/3.0)
                  igazts = TitledBorder.LEFT;                 //balra igazts
               else if (rnd < 2.0/3.0)
                    igazts = TitledBorder.CENTER;           //kzpre igazts
               else igazts = TitledBorder.RIGHT;             //jobbra igazts
                                                    //szveges keret ltrehozsa
               jkeret = BorderFactory.createTitledBorder(jkeret, jkerettpus+
                        "@"+igazts+", "+pozci, igazts, pozci);
            }
            gomb.setBorder( BorderFactory.createCompoundBorder(       //j keret
                            jkeret, gomb.getBorder()) );            //felraksa
         } else if (ae.getActionCommand().equals("-")) {   //kls keret trlse
           if (keret instanceof CompoundBorder)
               keret = ((CompoundBorder)keret).getInsideBorder();                
           else keret = null;
           gomb.setBorder( keret );
         }
         keretlista();                                //keretlista aktualizlsa
  }

  public void run() {
         super.run();                          //megjelentsi stlusvlts utn
         keretlista();                                           //keretlistzs
  }
  
  private void keretlista() {                              //keretek kilistzsa
          napl.setText("Keretlista kvlrl befel: "+
                        "[mretadatok: fent, balra, lent, jobbra]\n");
          Border keret = gomb.getBorder();
          Border klskeret;
          java.awt.Insets mret;
          while (keret != null) {                  //kerethierarchin vgigmenni
                if (keret instanceof CompoundBorder)          //sszetett keret?
                   klskeret = ((CompoundBorder)keret).getOutsideBorder();
                else klskeret = keret;
                napl.append(klskeret.getClass().getName());      //kerettpus
                if (klskeret instanceof TitledBorder) napl.append("("+
                   ((TitledBorder)klskeret).getTitle()+")");
                mret = klskeret.getBorderInsets(gomb);         //keret mrete
                napl.append(" ["+mret.top+", "+mret.left+", "+
                                  mret.bottom+", "+mret.right);
                napl.append("]\n");
                if (!(keret instanceof CompoundBorder)) break; //eggyel bentebbi
                keret = ((CompoundBorder)keret).getInsideBorder();       //keret
          }
          napl.setCaretPosition(0);         //mindig ellrl ltszdjon a napl
          fellet.revalidate();                          //fellet aktualizlsa
  }
}
