import javax.swing.*;
import javax.swing.event.*;

public class SwingInternalFrameTest extends SwingTest
                              implements java.awt.event.ActionListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingInternalFrameTest().init(args);
  }

  private JDesktopPane munkaasztal = new JDesktopPane(); //bels ablakok panelje
  private JTextField rteg = new JTextField(5);        //rteget megad szmmez
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(new JScrollPane(napl), java.awt.BorderLayout.NORTH);
            fellet.add(munkaasztal);                //bels ablakok kezelsnek
            munkaasztal.setDesktopManager(new Manager());           //belltsa
            setPreferredSize(600, 400);
            JPanel panel = new JPanel();                         //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.add(new JLabel("Rteg:"));
            panel.add(rteg);                        //j ablakot ltrehoz gomb
            AbstractButton gomb = new JButton("j ablak");
            panel.add(gomb);
            gomb.addActionListener(this);                  //nyomgomb figyelse
            for (int i=0; i<stlusvlts.length; i++) {     //stlusvlt gombok
                gomb = new JButton(stlusok[i].getName());
                panel.add(gomb);
                gomb.addActionListener(stlusvlts[i]);
            }
            actionPerformed(null);                   //kezdeti ablak ltrehozsa
            debugGraphics(munkaasztal);          //nyomkvethet a megjelentse
            if (nyomkvets) setLaF(1);          //Metal DebugGraphics bug miatt
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) {        //j ablak
         int rteg = 0;                                              //felvtele
         try {
             rteg = Integer.parseInt(this.rteg.getText());//a megadott rtegbe
         } catch (Exception e) {}
         new Ablak(rteg);                                   //ablak ltrehozsa
  }
  
  private int szmll;                                          //ablakszmll
  class Ablak extends JInternalFrame                     //bels ablak komponens
              implements InternalFrameListener, java.awt.event.ActionListener {
        int sorszm = ++szmll;                               //ablak sorszma
        private JTextArea napl = new JTextArea(3, 10);
        private JCheckBox ikon_e = new JCheckBox("ikonizlt?", isIcon());
        private JCheckBox maximum_e=new JCheckBox("maximalizlt?", isMaximum());
        Ablak(int rteg) {                                         //konstruktor
                super();
                setTitle(sorszm+". ablak");
                setVisible( true );
                munkaasztal.add(this, new Integer(rteg));
                napl.setEditable(false);         //ablak felletnek felptse
                JPanel fellet = (JPanel)getContentPane();
                fellet.setBorder( BorderFactory.createTitledBorder(  //szveges
                        getTitle()+" (rteg="+getLayer()+")"));     //kerete van
                fellet.add(new JScrollPane(napl));
                JPanel panel = new JPanel();                      //vezrlpanel
                fellet.add(panel, java.awt.BorderLayout.SOUTH);
                panel.setPreferredSize(new java.awt.Dimension(250, 138));
                AbstractButton gomb = new JCheckBox("bezrhat?", isClosable());
                panel.add(gomb);        //vezrlgombok ltrehozsa s figyelse
                gomb.setToolTipText("closable");
                gomb.setActionCommand("closable");
                gomb.addActionListener(this);
                gomb = new JCheckBox("bezrva?", isClosed());
                panel.add(gomb);
                gomb.setToolTipText("closed");
                gomb.setActionCommand("closed");
                gomb.addActionListener(this);
                gomb = new JCheckBox("ikonizlhat?", isIconifiable());
                panel.add(gomb);
                gomb.setToolTipText("iconifiable");
                gomb.setActionCommand("iconifiable");
                gomb.addActionListener(this);
                gomb = ikon_e;
                panel.add(gomb);
                gomb.setToolTipText("icon");
                gomb.setActionCommand("icon");
                gomb.addActionListener(this);
                gomb = new JCheckBox("maximalizlhat?", isMaximizable());
                panel.add(gomb);
                gomb.setToolTipText("maximizable");
                gomb.setActionCommand("maximizable");
                gomb.addActionListener(this);
                gomb = maximum_e;
                panel.add(gomb);
                gomb.setToolTipText("maximum");
                gomb.setActionCommand("maximum");
                gomb.addActionListener(this);
                gomb = new JCheckBox("mretezhet?", isResizable());
                panel.add(gomb);
                gomb.setToolTipText("resizable");
                gomb.setActionCommand("resizable");
                gomb.addActionListener(this);
                gomb = new JButton("elre");
                panel.add(gomb);
                gomb.setActionCommand("front");
                gomb.setToolTipText("moveToFront");
                gomb.addActionListener(this);
                gomb = new JButton("htra");
                panel.add(gomb);
                gomb.setActionCommand("back");
                gomb.setToolTipText("moveToBack");
                gomb.addActionListener(this);
                addInternalFrameListener(this); //belsablak esemnyek figyelse
                setSize(getPreferredSize());             //kezdmret belltsa
                moveToFront();                               //eltrbe helyezs
        }
        
        private void naplz( String szveg ) {            //zenet megjelentse
                napl.append( szveg );
                napl.append("\n");           //legjabb zenet lthatv ttele
                napl.setCaretPosition( napl.getDocument().getLength() );
        }

        void updateMaximum() { //maximalizlt llapot kijelzsnek aktualizlsa
             maximum_e.setSelected(isMaximum());
        }
        
        public void actionPerformed(java.awt.event.ActionEvent ae){//nyomgombok
               try {                                                  //kezelse
                   AbstractButton gomb = (AbstractButton)ae.getSource();
                   if (ae.getActionCommand().equals("maximizable")) {
                      setMaximizable(gomb.isSelected());   //maximalizlsi ikon
                      SwingUtilities.updateComponentTreeUI(this);//megjelentse
                   } else if (ae.getActionCommand().equals("maximum")) {
                     setMaximum(gomb.isSelected());              //maximalizls
                   } else if (ae.getActionCommand().equals("closable")) {
                     setClosable(gomb.isSelected());             //bezrsi ikon
                     SwingUtilities.updateComponentTreeUI(this); //megjelentse
                   } else if (ae.getActionCommand().equals("closed")) {
                     setClosed(gomb.isSelected());                     //bezrs
                   } else if (ae.getActionCommand().equals("iconifiable")) {
                     setIconifiable(gomb.isSelected());       //ikonizlsi ikon
                     SwingUtilities.updateComponentTreeUI(this); //megjelentse
                   } else if (ae.getActionCommand().equals("icon")) {
                     setIcon(gomb.isSelected());                    //ikonizls
                   } else if (ae.getActionCommand().equals("resizable")) {
                     setResizable(gomb.isSelected());              //mretezhet
                   } else if (ae.getActionCommand().equals("front")) {
                     moveToFront();                          //eltrbe helyezs
                   } else if (ae.getActionCommand().equals("back")) {
                     moveToBack();                           //httrbe helyezs
                   }
               } catch (Exception e) {  //mvelet elvgzse meg lett akadlyozva
                 naplz("set"+ae.getActionCommand()+": "+e);
               }
        }
                                                //belsablak esemnyek naplzsa
        public void internalFrameOpened(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameOpened");
        }
        public void internalFrameClosing(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameClosing");
        }
        public void internalFrameClosed(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameClosed");
        }
        public void internalFrameIconified(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameIconified");
        }
        public void internalFrameDeiconified(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameDeiconified");
               ikon_e.setSelected(false);
        }
        public void internalFrameActivated(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameActivated");
        }
        public void internalFrameDeactivated(InternalFrameEvent ie) {
               naplz("InternalFrameEvent: internalFrameDeactivated");
        }
  }
                                  //bels ablakok viselkedst vezrl komponens
  class Manager extends DefaultDesktopManager {
        public void minimizeFrame(JInternalFrame jif) {   //ablak minimalizlsa
               Ablak ablak = (Ablak)jif;
               super.minimizeFrame(ablak);               
               ablak.updateMaximum();               //maximalizlt jelz trlse
               naplz("DesktopManager: minimizeFrame "+ablak.sorszm);
        }
        
        public void maximizeFrame(JInternalFrame jif) {   //ablak maximalizlsa
               Ablak ablak = (Ablak)jif;
               super.maximizeFrame(ablak);               
               ablak.updateMaximum();            //maximalizlt jelz belltsa
               naplz("DesktopManager: maximizeFrame "+ablak.sorszm);
        }

        public void closeFrame(JInternalFrame jif) {            //ablak bezrsa
               Ablak ablak = (Ablak)jif;
               super.closeFrame(ablak);               
               naplz("DesktopManager: closeFrame "+ablak.sorszm);
               JInternalFrame[] ablakok = munkaasztal.getAllFrames();
                                                   //ha ez volt az utols ablak,
               if (ablakok==null || ablakok.length == 0) {
                  if (applet_e) actionPerformed(null);  //applet esetn j ablak
                  else kilps.actionPerformed(null);//alkalmazs esetn kilps
                  return;
               }
               for (int i=ablakok.length; --i>=0;)  //nen lehet minden megmaradt
                   if (!ablakok[i].isIcon()) return;           //ablak ikonizlt
               try {
                   ablakok[0].setIcon(false);
               } catch (Exception e) {}
        }
        
        public void iconifyFrame(JInternalFrame jif) {       //ablak ikonizlsa
               Ablak ablak = (Ablak)jif;
               JInternalFrame[] ablakok = munkaasztal.getAllFrames();
               int i = ablakok.length;
               for (;--i>=0;)               //msik nem ikonizlt ablak keresse
                   if (!ablak.equals(ablakok[i]) && !ablakok[i].isIcon()) break;
               napl.append("DesktopManager: iconifyFrame "+ablak.sorszm);
               if (i<0) {
                  naplz(" az ablak ikonizlsa nem megengedett!");
                  return;
               }
               super.iconifyFrame(ablak);
               naplz("");
        }
  }
}
