import javax.swing.*;
import javax.swing.event.*;

public class SwingListTest extends SwingTest implements ListSelectionListener,
                     java.awt.event.ItemListener, java.awt.event.ActionListener{
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingListTest().init(args);
  }
  
  private ListaModell modell = new ListaModell();                   //adatmodell
  private SelectionModel kivlasztsmodell =         //kivlasztsmodelli modell
          new SelectionModel(stlusvlts.length);
  private JList lista = new JList(modell);                               //lista
  private ComboBox legrdllista = new ComboBox(modell);      //legrdl lista
  private Editor editor = new Editor();              //s annak szerkesztmezje
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(new JScrollPane(napl));
            fellet.add(new JScrollPane(lista), java.awt.BorderLayout.WEST);
            for (int i=0; i<stlusvlts.length; i++)  //stlusvlt listaelemek
                modell.add(stlusvlts[i]);
            lista.setCellRenderer(new Renderer());      //megjelent belltsa
            lista.setSelectionModel(kivlasztsmodell);
            lista.addListSelectionListener(this);        //kivlaszts figyelse
            fellet.add(legrdllista, java.awt.BorderLayout.NORTH);
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            legrdllista.setActionCommand("add");
            legrdllista.addActionListener(this); //szerkeszts vge figyelse
            legrdllista.setRenderer(lista.getCellRenderer());   //megjelent
            legrdllista.setEditor(editor);              //szerkeszt megadsa
            JPanel panel = new JPanel();                         //vezrl panel
            panel.setPreferredSize(new java.awt.Dimension(350, 70));
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            AbstractButton gomb = new JButton("trl");      //listaelem trlse
            panel.add(gomb);
            gomb.setActionCommand("remove");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JButton("mind");           //minden listaelem megmutatsa
            panel.add(gomb);
            gomb.setActionCommand("show");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JButton("elrejt");                  //listaelem elrejtse
            panel.add(gomb);
            gomb.setActionCommand("hide");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JCheckBox("szerkeszthet?", legrdllista.isEditable());
            panel.add(gomb);
            gomb.setActionCommand("edit");
            gomb.setToolTipText("editable");
            gomb.addActionListener(this);                       //gomb figyelse
            JLabel label = new JLabel("Kivlasztsi md");
            panel.add(label);
            label.setToolTipText("selectionMode");
            Object[] elemek= {"MULTIPLE_INTERVAL", "SINGLE_INTERVAL", "SINGLE"};
            JComboBox md = new JComboBox(elemek);            //kivlasztsi md
            panel.add(md);
            md.setToolTipText("selectionMode");
            md.addItemListener(this);                   //kivlaszts figyelse
            debugGraphics(lista);                 //nyomkvethet a megjelents
            debugGraphics(legrdllista);
  }
  
  public void valueChanged(ListSelectionEvent le) {                //kivlaszts
         naplz("ListSelectionEvent: valueIsAdjusting="+le.getValueIsAdjusting()
               +", firstIndex="+le.getFirstIndex()+
                ", lastIndex="+le.getLastIndex());
         if (!le.getValueIsAdjusting() &&                         //stlusvlts
             kivlasztsmodell.getSelectedIndexCount()==1 &&
             kivlasztsmodell.hozzvtel &&
             lista.getSelectedValue() instanceof Action)
             ((Action)lista.getSelectedValue()).actionPerformed(null);
                                     //legutols elem megjelentse az editorban
         if (kivlasztsmodell.hozzvtel && legrdllista.isEditable())
           legrdllista.getEditor().setItem(legrdllista.getSelectedItem());
         legrdllista.repaint();              //editor megjelentsi bug miatt
  }
                                           //kivlasztott listaelem feldolgozsa
  public void itemStateChanged(java.awt.event.ItemEvent ie) {
         boolean kivlaszts =
                 ie.getStateChange()==java.awt.event.ItemEvent.SELECTED;
         naplz("JComboBox ItemEvent("+                  //kivlaszts naplzsa
                (kivlaszts ? "SELECTED" : "DESELECTED")+") : "+ie.getItem());
         if (legrdllista.equals(ie.getSource()) || !kivlaszts) return;
         int md = 0;
         String vlaszts = (String)ie.getItem();
         if (vlaszts.equals("MULTIPLE_INTERVAL"))                //tetszleges
            md = ListSelectionModel.MULTIPLE_INTERVAL_SELECTION;
         else if (vlaszts.equals("SINGLE_INTERVAL"))             //intervallum
              md = ListSelectionModel.SINGLE_INTERVAL_SELECTION;
         else if (vlaszts.equals("SINGLE"))                        //egyszeres
              md = ListSelectionModel.SINGLE_SELECTION;
         lista.clearSelection();                       //vlasztsi md lltsa
         lista.setSelectionMode(md);
  }
                          //gombnyoms s szerkeszts befejezsnek feldolgozsa
  public void actionPerformed(java.awt.event.ActionEvent ae) {
         if ("add".equals(ae.getActionCommand())) {   //j listaelem hozzvtele
            naplz("JComboBox ActionEvent"); 
            if (!legrdllista.isEditable() || legrdllista.isPopupVisible()
                || !editor.hasFocus()) return;     //szerkesztett elem felvtele
            String elem = legrdllista.getEditor().getItem().toString();
            modell.add(elem);
            lista.clearSelection();                       //j elem kivlasztsa
            lista.setSelectedValue(elem, true);
         } else if ("remove".equals(ae.getActionCommand())) {           //trls
           Object[] kivlasztva = lista.getSelectedValues();
           lista.clearSelection();
           for (int i=kivlasztva.length; --i>=0;)   //elemek egyenknti trlse
               modell.remove(kivlasztva[i]);
         } else if ("hide".equals(ae.getActionCommand())) {           //elrejts
           Object[] kivlasztva = lista.getSelectedValues();
           lista.clearSelection();
           for (int i=kivlasztva.length; --i>=0;) //elemek egyenknti elrejtse
               modell.hide(kivlasztva[i]);
         } else if ("show".equals(ae.getActionCommand())) {        //minden elem
           lista.clearSelection();                                    //mutatsa
           modell.showAll();
         } else if ("edit".equals(ae.getActionCommand())) {      //szerkeszthet
           legrdllista.setEditable(((JCheckBox)ae.getSource()).isSelected());
         }
  }
//------------------------listaelem sorszmval is kivlaszthat legrdl lista
  class ComboBox extends JComboBox implements JComboBox.KeySelectionManager {
        private JComboBox.KeySelectionManager alaprtelmezs =  //alaprtelmezs
                createDefaultKeySelectionManager();         //szerinti kijells

        ComboBox(ListaModell modell) {                             //konstruktor
                super(modell);
                setKeySelectionManager(this);            //kivlaszts vezrlse
        }
                               //adott billentyhz kivlasztsi index rendelse
        public int selectionForKey(char billenty, ComboBoxModel modell) {
               int index = alaprtelmezs.selectionForKey(billenty, modell);
               if (index==-1) {     //nincs alaprtelmezs szerint hozzrendels
                  index = billenty-'1';          //sorszm szerinti kivlaszts
                  if (index<0 || index>=modell.getSize()) index=-1;
               }
               naplz("KeySelectionManager selectionForKey '"+billenty+
                      "' = "+index);
               return index;
      }
  }
//=====================listaelemek elrejtst lehetv tev rendezett adatmodell
  class ListaModell extends DefaultListModel
                    implements ComboBoxModel, ListDataListener {
        java.util.Vector nemlthat = new java.util.Vector(); //elrejtett elemek
        
        ListaModell() {                                            //konstruktor
                super();
                addListDataListener(this);           //modellesemnyek figyelse
        }
        
        public Object getSelectedItem() {        //kivlasztott elem lekrdezse
               return lista.getSelectedValue();
        }
        public void setSelectedItem(Object elem) {  //kivlasztott elem megadsa
               lista.setSelectedValue(elem, true);
        }
        
        public void add(Object elem) {                       //j elem felvtele
               int kezdindex = 0;     //beszrsi pozci logaritmikus keresse
               int vgindex = getSize();
               int jindex = (kezdindex + vgindex) >> 1;
               while (vgindex>kezdindex) {
                     if (nagyobb(elem, getElementAt(jindex)))
                        kezdindex = jindex + 1;
                     else vgindex = jindex;
                     jindex = (kezdindex + vgindex) >> 1;
               }
               insertElementAt(elem, jindex);     //beszrs a megfelel helyre
        }                                      //sszehasonltst vgz objektum
        private java.text.Collator collator = java.text.Collator.getInstance();
        private boolean nagyobb(Object ez, Object ennl) {     //sszehasonlts
                return collator.compare(ez.toString(), ennl.toString())>0;
        }
        
        public boolean remove(Object elem) {                      //elem trlse
               nemlthat.removeElement(elem);
               return removeElement(elem);
        }
        
        public void hide(Object elem) {                         //elem elrejtse
               if (removeElement(elem)) nemlthat.addElement(elem);
        }
        public void show(Object elem) {               //rejtett elem megmutatsa
               if (nemlthat.removeElement(elem)) add(elem);
        }
        public void showAll() {                //minden rejtett elem megmutatsa
               for (int i=nemlthat.size(); --i>=0;)
                   show(nemlthat.elementAt(i));
        }
                                                     //modellesemnyek naplzsa
        public void intervalAdded(ListDataEvent le) {         //elem hozzvtele
               naplz("ListDataEvent intervalAdded: index0="+le.getIndex0()+
                      ", index1="+le.getIndex1());
        }
        public void intervalRemoved(ListDataEvent le) {           //elem trlse
               naplz("ListDataEvent intervalRemoved: index0="+le.getIndex0()+
                      ", index1="+le.getIndex1());
        }
        public void contentsChanged(ListDataEvent le) {    //adatok megvltozsa
               naplz("ListDataEvent felletsChanged: index0="+le.getIndex0()+
                      ", index1="+le.getIndex1());
        }
  }
//====================kivlasztott elemek szmnak maximalizlst lehetv tev
  class SelectionModel extends DefaultListSelectionModel { //kivlasztsi modell
        int maximum;               //maximlisan kivlaszthat listaelemek szma
        int aktulis;                //aktulisan kivlasztott listaelemek szma
        boolean hozzvtel;      //utols mvelet kivlaszts hozzvtele volt-e
      
        SelectionModel(int max) {                                  //konstruktor
            super();
            maximum = max;
        }
                                                     //kivlasztott elemek szma
        public int getSelectedIndexCount() {return aktulis;}
        
        public void setSelectionInterval(int index0, int index1) { //intervallum
               clearSelection();                                  //kivlasztsa
               if (felvtel) {                    //vgtelen rekurzi megelzse
                  super.setSelectionInterval(index0, index1);
                  return;
               }
               addSelectionInterval(index0, index1);
        }

        private boolean felvtel;         //kivlasztott elemek felvtelt jelzi
        public void addSelectionInterval(int index0, int index1) { //intervallum
               if (index0==-1) {                                   //hozzvtele
                  super.addSelectionInterval(index0, index1);
                  return;
               }
               if (maximum == aktulis) return;                 //maximum elrve
               if (getSelectionMode()==ListSelectionModel.SINGLE_SELECTION)
                  index0=index1;                  //csak egy elem vlaszthat ki
               int index;                                //segdvltoz cserhez
               if (index0 > index1) {                             //sorrendcsere
                  index = index0;
                  index0 = index1;
                  index1 = index;
               }
               for (index = index0; index <= index1; index++) {    //kivlaszts
                   if (!isSelectedIndex(index)) {                  //ellenrzse
                      aktulis++;                                 //j szelekci
                      if (aktulis == maximum) {            //tbb mr nem lehet
                         index1 = index;
                         break;
                      }
                   }
               }
               hozzvtel=true;                          //kivlaszts elvgzse
               felvtel=true;
               super.addSelectionInterval(index0, index1);
               felvtel=false;
        }
        
        public void clearSelection() {              //minden kivlaszts trlse
               if (!isSelectionEmpty()) removeSelectionInterval(
                                getMinSelectionIndex(), getMaxSelectionIndex());
        }                                                  //intervallum trlse
        public void removeSelectionInterval(int index0, int index1){
               int index;                                //segdvltoz cserhez
               if (index0 > index1) {                             //sorrendcsere
                  index = index0;
                  index0 = index1;
                  index1 = index;
               }
               for (index = index0; index <= index1; index++) {
                   if (isSelectedIndex(index)) {
                      aktulis--;                           //trlend szelekci
                   }
               }
               if (!felvtel) hozzvtel=false;                //trlse jelzse
               super.removeSelectionInterval(index0, index1);//trlse elvgzse
        }
  }
//=======================================================listaelem megjelentse
  class Renderer extends DefaultListCellRenderer {  //megjelents konfigurlsa
        public java.awt.Component getListCellRendererComponent(JList lista,
                                  Object listaelem, int index,
                                  boolean kivlasztott, boolean fkuszlt) {
               if (listaelem instanceof LaFAction)            //stlusvlt ikon
                  setIcon(((LaFAction)listaelem).getIcon());     //megjelentse
               else setIcon(null);
               return super.getListCellRendererComponent(lista,
                                     listaelem, index, kivlasztott, fkuszlt);
        }
  }
//--------------------------------------------------------listaelem szerkesztse
  class Editor extends JTextField implements ComboBoxEditor {
        public void setItem(Object elem) {    //szerkesztend elem megjelentse
               if (elem==null) setText("");
               else setText(elem.toString());
        }
                                                        //szerkeszt visszaadsa
        public java.awt.Component getEditorComponent() {return this;}
                                                 //szerkesztett elem visszaadsa
        public Object getItem() {return getText();}
                                     //NullPointerException bug miatt workaround
        public void addFocusListener(java.awt.event.FocusListener fl) {
               if (fl instanceof java.awt.event.FocusAdapter) return;
               super.addFocusListener(fl);
        }
  }
}
