import javax.swing.*;
import javax.swing.event.*;

public class SwingMiniBrowser {
  public static void main(String[] args) {
    if (args.length!=1) {
       System.out.println("Hasznlat: java SwingMiniBrowser URL");
       System.exit(1);
    }
    final JFrame frame = new JFrame("SwingMiniBrowser: "+args[0]); //kezd keret
    JEditorPane browser=null;
    try {
    	browser=new JEditorPane(args[0]);               //kezd oldal megnyitsa
    } catch (Exception e) {hiba(args[0], e);}
    browser.setEditable(false);
    final JEditorPane fbrowser = browser;             //nvtelen osztlyhoz kell
    fbrowser.addHyperlinkListener(new HyperlinkListener() {
    	public void hyperlinkUpdate(HyperlinkEvent he) {    //hyperlink kezelse
    	       if (he.getEventType()==HyperlinkEvent.EventType.ENTERED)//rlps
    	          fbrowser.setCursor(java.awt.Cursor.getPredefinedCursor(
    	                            java.awt.Cursor.HAND_CURSOR));
    	       else if (he.getEventType()==HyperlinkEvent.EventType.EXITED)
    	          fbrowser.setCursor(java.awt.Cursor.getDefaultCursor());//kilp
    	       else if (he.getEventType()==HyperlinkEvent.EventType.ACTIVATED)
    	       try {                                        //j oldal betltse
    	          fbrowser.setCursor(java.awt.Cursor.getDefaultCursor());
    	       	  fbrowser.setPage(he.getURL());
    	       	  frame.setTitle("SwingMiniBrowser: "+he.getURL());
    	       } catch (Exception e) {hiba(he.getURL().toString(), e);}
    	}
    });
    frame.addWindowListener(new java.awt.event.WindowAdapter() { //ablakzrskor
    	public void windowClosing(java.awt.event.WindowEvent we) {     //kilps
    	       System.exit(0);
    	}
    });
    frame.setContentPane(new JScrollPane(browser)); //teljeskpernys megjelens
    frame.setSize(java.awt.Toolkit.getDefaultToolkit().getScreenSize());
    frame.setVisible(true);
  }

  private static void hiba(String url, Exception e) {    //hiba URL betltsekor
          System.out.println("Hiba a kvetkez URL megjelentsekor: "+url);
          System.out.println(e);
          System.exit(-1);
  }
}
