import javax.swing.*;
import javax.swing.event.*;


public class SwingScrollPaneTest extends SwingTest
             implements ChangeListener, java.awt.event.ActionListener,
             java.awt.event.ItemListener, java.awt.event.MouseMotionListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingScrollPaneTest().init(args);
  }
  
  private JScrollPane grgethetpanel;
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(new JScrollPane(napl), java.awt.BorderLayout.NORTH);
            FixedImagePanel kp = new FixedImagePanel("images/hatter.jpg");
            kp.addMouseMotionListener(this);           //egrmozgats figyelse
            grgethetpanel = new JScrollPane(kp);              //kp grgetse
            fellet.add(grgethetpanel);  //grgethet tartomny mretvltozsa
            grgethetpanel.getViewport().addChangeListener(this);   //figyelse
            grgethetpanel.setColumnHeaderView(       //oszlopfejlc belltsa
                  new Linear(JSlider.HORIZONTAL, kp.getPreferredSize().width));
            grgethetpanel.setRowHeaderView(             //sorfejlc belltsa
                   new Linear(JSlider.VERTICAL, kp.getPreferredSize().height));
            grgethetpanel.getHorizontalScrollBar().setPreferredSize(
                            new java.awt.Dimension(40, 40)); //grgetsvok fel-
            grgethetpanel.getVerticalScrollBar().setPreferredSize( //nagytsa
                            new java.awt.Dimension(40, 40));
            AbstractButton gomb;                   //sarokkomponensek belltsa
            gomb = new JButton("bal fels sarok");
            gomb.setToolTipText(gomb.getText());
            gomb.addActionListener(this);                  //nyomgomb figyelse
            grgethetpanel.setCorner(JScrollPane.UPPER_LEFT_CORNER, gomb);
            gomb = new JButton("jobb fels sarok");
            gomb.setToolTipText(gomb.getText());
            gomb.addActionListener(this);                  //nyomgomb figyelse
            grgethetpanel.setCorner(JScrollPane.UPPER_RIGHT_CORNER, gomb);
            gomb = new JButton("jobb als sarok");
            gomb.setToolTipText(gomb.getText());
            gomb.addActionListener(this);                  //nyomgomb figyelse
            grgethetpanel.setCorner(JScrollPane.LOWER_RIGHT_CORNER, gomb);
            gomb = new JButton("bal als sarok");
            gomb.setToolTipText(gomb.getText());
            gomb.addActionListener(this);                  //nyomgomb figyelse
            grgethetpanel.setCorner(JScrollPane.LOWER_LEFT_CORNER, gomb);
            JPanel panel = new JPanel();                          //vezrlpanel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(350, 100));
            JLabel cmke = new JLabel("vzszintes grgetsv megjelentse:");
            panel.add(cmke);
            cmke.setToolTipText("horizontalScrollBarPolicy");
            Object[] elemek = {"AS_NEEDED", "ALWAYS", "NEVER"};//legrdl lista
            JComboBox legrdllista = new JComboBox(elemek);
            panel.add(legrdllista);
            legrdllista.setToolTipText("HORIZONTAL_SCROLLBAR_");
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            cmke = new JLabel("fggleges grgetsv megjelentse:");
            panel.add(cmke);
            cmke.setToolTipText("verticalScrollBarPolicy");
            legrdllista = new JComboBox(elemek);
            panel.add(legrdllista);
            legrdllista.setToolTipText("VERTICAL_SCROLLBAR_");
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            for (int i=0; i<stlusvlts.length; i++) {     //stlusvlt gombok
                gomb = new JButton(stlusok[i].getName());
                panel.add(gomb);
                gomb.addActionListener(stlusvlts[i]);
            }
            setPreferredSize(350, 400);                          //kezdeti mret
            debugGraphics(grgethetpanel);      //nyomkvethet a megjelentse
            if (nyomkvets) setLaF(1);          //Metal DebugGraphics bug miatt
  }

  public void stateChanged(ChangeEvent ce) {       //grgethet tartomny mrete
         JViewport tartomny = (JViewport)ce.getSource();         //megvltozott
         java.awt.Point pozci = tartomny.getViewPosition();
         java.awt.Dimension mret = tartomny.getExtentSize();
         naplz("ChangeEvent: pozci="+pozci.x+","+pozci.y+"; mret="+
                                        mret.width+"*"+mret.height);
  }
                                         //grgetsvok lthatsga megvltozott
  public void itemStateChanged(java.awt.event.ItemEvent ie) {
         if (ie.getStateChange()!=java.awt.event.ItemEvent.SELECTED) return;
         int lthatsg = 0;
         String vlaszts = (String)ie.getItem();
         if (((JComboBox)ie.getSource()).getToolTipText().startsWith(
            "HORIZONTAL")) {                             //vzszintes grgetsv
            if (vlaszts.equals("ALWAYS")) lthatsg =                //mindig
               ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS;
            else if (vlaszts.equals("AS_NEEDED")) lthatsg =  //csak ha kell
                 ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED;
            else if (vlaszts.equals("NEVER")) lthatsg =              //soha
                 ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER;
            grgethetpanel.setHorizontalScrollBarPolicy(lthatsg);
         } else {                                        //fggleges grgetsv
           if (vlaszts.equals("ALWAYS")) lthatsg =                 //mindig
              ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS;
           else if (vlaszts.equals("AS_NEEDED")) lthatsg =   //csak ha kell
                ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED;
           else if (vlaszts.equals("NEVER")) lthatsg =               //soha
                ScrollPaneConstants.VERTICAL_SCROLLBAR_NEVER;
           grgethetpanel.setVerticalScrollBarPolicy(lthatsg);
         }
         grgethetpanel.revalidate();          //grgethet panel jrarajzolsa
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) {       //sarokgomb
         AbstractButton gomb = (AbstractButton)ae.getSource();    //lenyomsnak
         naplz(gomb.getText());                                     //naplzsa
  }
                      //egrmozgatskor az egr aktulis pozcijnak brzolsa
  public void mouseDragged(java.awt.event.MouseEvent me) {mouseMoved(me);}
  public void mouseMoved(java.awt.event.MouseEvent me) {
         ((Linear)grgethetpanel.getColumnHeader().getView()).setValue(
                  me.getX());             //oszlopfejlc rtknek aktualizlsa
         ((Linear)grgethetpanel.getRowHeader().getView()).setValue(
                  me.getY());                //sorfejlc rtknek aktualizlsa
         ((FixedImagePanel)grgethetpanel.getViewport().getView()).setPoint(
                  me.getPoint());       //egrkoordintk vizulis megjelentse
  }
  
  class FixedImagePanel extends JComponent {  //fix mret kpbrzol komponens
        java.awt.Point pont;                      //aktulisan kivlasztott pont
        ImageIcon kp;                                                 //kpikon
        java.awt.Dimension mret;                                    //fix mret
        FixedImagePanel(String fjl) {                             //konstruktor
                super();
                kp = loadIcon(fjl);                            //kp betltse
                mret = new java.awt.Dimension(        //fix mret megllaptsa
                        kp.getIconWidth(), kp.getIconHeight());
        }

        public void setPoint(java.awt.Point pont) {   //aktulis pont belltsa
               this.pont = pont;
               repaint();
        }
        
        public void paintComponent(java.awt.Graphics g) {         //megjelents
               g.drawImage(kp.getImage(), 0, 0, this);       //kp megrajzolsa
               if (pont!=null) {       //aktulisan kivlasztott pont brzolsa
                  g.setColor(java.awt.Color.white);             //fehr vonallal
                  g.drawLine(pont.x, 0, pont.x, getHeight() - 1); //fgglegesen
                  g.drawLine(0, pont.y, getWidth() - 1, pont.y);  //vzszintesen
               }
        }
                                                         //fix mret visszaadsa
        public java.awt.Dimension getMinimumSize() {return mret;}
        public java.awt.Dimension getPreferredSize() {return mret;}
        public java.awt.Dimension getMaximumSize() {return mret;}
  }

  class Linear extends JPanel {      //beosztsokat brzol fixmret komponens
        private java.awt.Dimension mret;                            //fix mret
        private JSlider beoszts;
        Linear(int irnytottsg, int hossz) {                     //konstruktor
              super(null);
              beoszts = new JSlider(irnytottsg, 0, hossz, 0);
              beoszts.setPaintTicks(true);              //beosztsok brzolsa
              beoszts.setPaintLabels(true);
              beoszts.setEnabled(false);
              if (irnytottsg==JSlider.HORIZONTAL) {              //vzszintes
                 beoszts.setMajorTickSpacing(50);
                 mret = new java.awt.Dimension(          //fix mret belltsa
                         hossz, beoszts.getPreferredSize().height);
                 setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
              } else {                                              //fggleges
                beoszts.setMajorTickSpacing(20);
                mret = new java.awt.Dimension(           //fix mret belltsa
                        beoszts.getPreferredSize().width, hossz);
                beoszts.setInverted(true);
                setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
              }
              beoszts.setMinimumSize(mret);                 //mret lefixlsa
              beoszts.setPreferredSize(mret);
              beoszts.setMaximumSize(mret);
              add(beoszts);                       //tmretezs megakadlyozsa
              add(Box.createGlue());
        }
                                          //aktulisan brzolt rtk belltsa
        void setValue(int rtk) {beoszts.setValue(rtk);}
                                                         //fix mret visszaadsa
                public java.awt.Dimension getMinimumSize() {return mret;}
        public java.awt.Dimension getPreferredSize() {return mret;}
        public java.awt.Dimension getMaximumSize() {return mret;}
  }
}
 