import javax.swing.*;

public class SwingSplitPaneTest extends SwingTest
                                implements java.awt.event.ActionListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingSplitPaneTest().init(args);
  }
  
  private JSplitPane kettoszthatpanel = new JSplitPane();//kettoszthat panel
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(kettoszthatpanel);
            kettoszthatpanel.setRightComponent(         //jobboldali komponens
                               new ImagePanel("images/hatter.jpg"));
            JPanel panel = new JPanel();                   //baloldali komponens
            kettoszthatpanel.setLeftComponent(panel);
            AbstractButton gomb = null;
            for (int i=0; i<stlusvlts.length; i++) {     //stlusvlt gombok
                gomb = new JButton(stlusok[i].getName());
                panel.add(gomb);
                gomb.addActionListener(stlusvlts[i]);
            }                                 //minimum egy gombnyi szles lehet
            panel.setMinimumSize(gomb.getMinimumSize());
            panel = new JPanel();                                //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(340, 70));   //kezdeti
            setPreferredSize(340, 200);                                  //mret
            gomb = new JRadioButton("vzszintes",   //vzszintes elvlasztvonal
                kettoszthatpanel.getOrientation()==JSplitPane.VERTICAL_SPLIT);
            panel.add(gomb);
            gomb.setToolTipText("VERTICAL_SPLIT");
            ButtonGroup csoport = new ButtonGroup();
            csoport.add(gomb);
            gomb.setActionCommand("vertical");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JRadioButton("fggleges",   //fggleges elvlasztvonal
              kettoszthatpanel.getOrientation()==JSplitPane.HORIZONTAL_SPLIT);
            panel.add(gomb);
            gomb.setToolTipText("HORIZONTAL_SPLIT");
            csoport.add(gomb);
            gomb.setActionCommand("horizontal");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("engedlyezve?",          //panel engedlyezse
                                 kettoszthatpanel.isEnabled());
            panel.add(gomb);
            gomb.setToolTipText("enabled");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("mozgatskor rajzol?",   //rajzols folyamatos?
                                 kettoszthatpanel.isContinuousLayout());
            panel.add(gomb);
            gomb.setToolTipText("continuousLayout");
            gomb.setActionCommand("continuous");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("gyors mini/maximalizls?",
                                 kettoszthatpanel.isOneTouchExpandable());
            panel.add(gomb);
            gomb.setToolTipText("oneTouchExpandable");
            gomb.setActionCommand("expand");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            debugGraphics(kettoszthatpanel);    //nyomkvethet a megjelents
            if (nyomkvets) setLaF(1);          //Metal DebugGraphics bug miatt
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) {          //gombok
         AbstractButton gomb = (AbstractButton)ae.getSource();       //figyelse
         if (ae.getActionCommand().equals("expand"))  //gyors mini/maximalizls
            kettoszthatpanel.setOneTouchExpandable(gomb.isSelected());
         else if (ae.getActionCommand().equals("continuous"))      //mozgatskor
              kettoszthatpanel.setContinuousLayout(gomb.isSelected());//rajzol
         else if (ae.getActionCommand().equals("horizontal")) //fggleges vonal
              kettoszthatpanel.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
         else if (ae.getActionCommand().equals("vertical"))   //vzszintes vonal
              kettoszthatpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
         else                        //kettoszthat panel engedlyezse/tiltsa
              kettoszthatpanel.setEnabled(gomb.isSelected());
  }
  
  class ImagePanel extends JComponent {   //mretezhet kpmegjelent komponens
        ImageIcon kp;                                       //megjelentett kp
        ImagePanel(String fjl) {                                  //konstruktor
                super();
                kp = loadIcon(fjl);                            //kp betltse
        }
        
        public void paintComponent(java.awt.Graphics g) {    //kp megjelentse
               g.drawImage(kp.getImage(), 0, 0, getWidth(), getHeight(), this);
        }
  }
}
