import javax.swing.*;
import javax.swing.event.*;


public class SwingTabbedPaneTest extends SwingTest implements ChangeListener,
                    java.awt.event.ActionListener, java.awt.event.ItemListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingTabbedPaneTest().init(args);
  }
  
  private JTabbedPane tbboldalaspanel = new JTabbedPane();
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(new JScrollPane(napl), java.awt.BorderLayout.NORTH);
            fellet.add(tbboldalaspanel);
            Oldal oldal;
            for (int i=0; i<stlusvlts.length; i++) {    //stlusvlt oldalak
                oldal = new Oldal();
                tbboldalaspanel.addTab(stlusok[i].getName(),
                       stlusvlts[i].getIcon(), oldal, stlusok[i].getName());
            }
            JPanel panel = new JPanel();                         //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            JButton gomb = new JButton("j oldal");       //j oldal hozzvtele
            panel.add(gomb);
            gomb.setToolTipText("addTab");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            JLabel cmke = new JLabel("Flek helye:");
            panel.add(cmke);
            cmke.setToolTipText("tabPlacement");
            Object[] elemek = {"TOP", "BOTTOM", "LEFT", "RIGHT"};
            JComboBox legrdllista = new JComboBox(elemek);
            panel.add(legrdllista);
            legrdllista.setToolTipText("SwingConstants");
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            tbboldalaspanel.addChangeListener(this);    //oldalvlts figyelse
            setPreferredSize(330, 400);
            debugGraphics(tbboldalaspanel);      //nyomkvethet a megjelents
  }
  
  public void stateChanged(ChangeEvent ce) {                       //oldalvlts
         Oldal oldal = (Oldal)tbboldalaspanel.getSelectedComponent();//aktulis
         naplz("ChangeEvent: aktulis oldalindex="+           //oldal naplzsa
                tbboldalaspanel.getSelectedIndex());
         if (oldal==null) return;                                 //stlusvlts
         if (oldal.sorszm<=stlusvlts.length) setLaF(oldal.sorszm-1);
  }
                                                   //flek helynek vltoztatsa
  public void itemStateChanged(java.awt.event.ItemEvent ie) {
         if (ie.getStateChange()!=java.awt.event.ItemEvent.SELECTED) return;
         int flekhelye = 0;
         String vlaszts = (String)ie.getItem();
         if (vlaszts.equals("TOP")) flekhelye = JTabbedPane.TOP;       //fent
         else if (vlaszts.equals("BOTTOM"))
              flekhelye = JTabbedPane.BOTTOM;                            //lent
         else if (vlaszts.equals("LEFT"))
              flekhelye = JTabbedPane.LEFT;                             //balra
         else if (vlaszts.equals("RIGHT"))
              flekhelye = JTabbedPane.RIGHT;                           //jobbra
         tbboldalaspanel.setTabPlacement(flekhelye);
  }
                                                            //j oldal felvtele
  public void actionPerformed(java.awt.event.ActionEvent ae) {
         Oldal oldal = new Oldal();
         tbboldalaspanel.addTab(oldal.sorszm+". oldal",
                                 null, oldal, oldal.sorszm+". segdszveg");
  }
  
  private int szmll;                                          //oldalszmll
  class Oldal extends JPanel implements java.awt.event.ActionListener {//1 oldal
        int sorszm = ++szmll;                   //oldal sorszmnak trolsa
        Oldal() {                                                  //konstruktor
              super();                                                 //keretes
              setBorder(BorderFactory.createTitledBorder(sorszm+". oldal"));
              AbstractButton gomb = new JButton("megelz");  //oldal felptse
              gomb.setToolTipText("selectedIndex");             //lapozs vissza
              gomb.setActionCommand("prev");
              gomb.addActionListener(this);                //nyomgomb figyelse
              add(gomb);
              gomb = new JCheckBox("engedlyezve?", true);        //engedlyezs
              gomb.setToolTipText("enabledAt");
              gomb.setActionCommand("enable");
              gomb.addActionListener(this);     //gomb kivlasztsnak figyelse
              add(gomb);
              gomb = new JButton("kvetkez");                   //lapozs elre
              gomb.setToolTipText("selectedIndex");
              gomb.setActionCommand("next");
              gomb.addActionListener(this);                //nyomgomb figyelse
              add(gomb);
              gomb = new JButton("el beszr");                 //beszrs elje
              gomb.setToolTipText("insertTab");
              gomb.setActionCommand("before");
              gomb.addActionListener(this);                //nyomgomb figyelse
              add(gomb);
              gomb = new JButton("trl");                       //oldal trlse
              gomb.setToolTipText("remove");
              gomb.setActionCommand("remove");
              gomb.addActionListener(this);                //nyomgomb figyelse
              add(gomb);
              gomb = new JButton("mg beszr");               //beszrs mgje
              gomb.setToolTipText("insertTab");
              gomb.setActionCommand("after");
              gomb.addActionListener(this);                //nyomgomb figyelse
              add(gomb);
        }
                                                           //gombnyoms kezelse
        public void actionPerformed(java.awt.event.ActionEvent ae) {  //aktulis
               int index = tbboldalaspanel.indexOfComponent(this); //oldalindex
               AbstractButton gomb = (AbstractButton)ae.getSource();
               if (ae.getActionCommand().equals("after")) {    //beszrs mgje
                  Oldal oldal = new Oldal();
                  tbboldalaspanel.insertTab(oldal.sorszm+". oldal",
                           null, oldal, oldal.sorszm+". segdszveg", index+1);
               } else if (ae.getActionCommand().equals("before")) {      //elje
                  Oldal oldal = new Oldal();
                  tbboldalaspanel.insertTab(oldal.sorszm+". oldal",
                             null, oldal, oldal.sorszm+". segdszveg", index);
               } else if (ae.getActionCommand().equals("remove")) {     //trls
                  tbboldalaspanel.remove(this);
               } else if (ae.getActionCommand().equals("enable")){//engedlyezs
                 tbboldalaspanel.setEnabledAt(index, gomb.isSelected());
               } else if (ae.getActionCommand().equals("prev")){//lapozs vissza
                 if (index>0) tbboldalaspanel.setSelectedIndex(index-1);
               } else if (ae.getActionCommand().equals("next")) {//lapozs elre
                 if (index<tbboldalaspanel.getTabCount()-1)
                    tbboldalaspanel.setSelectedIndex(index+1);
               }
        }
  }
}
