import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

public class SwingTextTest extends SwingTest implements CaretListener,
                    java.awt.event.ActionListener, java.awt.event.ItemListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingTextTest().init(args);
  }
  
  private Modell modell = new Modell(20);                      //szveg modellje
  private JCheckBox korlt = new JCheckBox("szveghossz korltozva?", false);
  private JCheckBox egysoros = new JCheckBox("egysoros?", true);
  private JTextField soreditor = new JTextField();
  private JPasswordField jelsz = new JPasswordField();
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.add(soreditor, java.awt.BorderLayout.NORTH);
            soreditor.setDocument(modell);               //adatmodell belltsa
            soreditor.addCaretListener(this);                 //kurzor figyelse
            soreditor.addActionListener(this);                 //Enter figyelse
            debugGraphics(soreditor);             //nyomkvethet a megjelents
            JPanel panel = new JPanel(new java.awt.BorderLayout());
            fellet.add(panel);                                    //bels panel
            panel.add(new JScrollPane(napl));            //tbbsoros szvegmez
            napl.addCaretListener(this);                     //kurzor figyelse
            napl.setEditable(true);                             //szerkeszthet
            debugGraphics(napl);                 //nyomkvethet a megjelents
            panel.add(jelsz, java.awt.BorderLayout.SOUTH);
            jelsz.setDocument(modell);                             //jelszmez
            jelsz.addCaretListener(this);                    //kurzor figyelse
            jelsz.addActionListener(this);                    //Enter figyelse
            debugGraphics(jelsz);                //nyomkvethet a megjelents
            panel = new JPanel();                                //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(350, 140));
            AbstractButton gomb = new JCheckBox("engedlyezve?", true);
            panel.add(gomb);
            gomb.setToolTipText("JTextComponent.enabled");
            gomb.setActionCommand("enable");
            gomb.addActionListener(this);                       //gomb figyelse
            gomb = new JCheckBox("szerkeszthet?", true);          //szerkeszts
            panel.add(gomb);
            gomb.setToolTipText("JTextComponent.editable");
            gomb.setActionCommand("editable");
            gomb.addActionListener(this);                       //gomb figyelse
            panel.add(egysoros);                         //egysoros megjelents
            panel.add(korlt);                                 //hosszkorltozs
            korlt.setToolTipText(""+modell.maxhossz);
            JLabel label = new JLabel("szvegigazts:");       //szvegigazts
            panel.add(label);
            label.setToolTipText("JTextField.setHorizontalAlignment");
            Object[] elemek = {"LEFT", "CENTER","RIGHT"};
            JComboBox cb = new JComboBox(elemek);
            panel.add(cb);
            cb.setToolTipText("SwingConstants");
            cb.addItemListener(this);                    //kivlaszts figyelse
            gomb = new JCheckBox("sorok trdelse?", napl.getLineWrap());
            panel.add(gomb);                                          //trdels
            gomb.setToolTipText("JTextArea.lineWrap");
            gomb.setActionCommand("wrap");
            gomb.addActionListener(this);                       //gomb figyelse
            gomb = new JCheckBox("trdels csak szavaknl?",
                                 napl.getWrapStyleWord());
            panel.add(gomb);
            gomb.setToolTipText("JTextArea.wrapStyleWord");
            gomb.setActionCommand("word");
            gomb.addActionListener(this);                       //gomb figyelse
            for (int i=0; i<stlusvlts.length; i++) {     //stlusvlt gombok
                gomb = new JButton(stlusok[i].getName());
                panel.add(gomb);
                gomb.addActionListener(stlusvlts[i]);
            }
  }
  
  private String szveg;                                     //naplzand szveg
  protected void naplz(String szveg) {     //naplzs temezse a szvegmodell
        this.szveg = szveg;                              //vltoztatsa utnra
        SwingUtilities.invokeLater(this);
  }
  
  public void run() {
        if (szveg==null) {                                       //stlusvlts
           super.run();
           return;
        }
        super.naplz(szveg);                               //temezett naplzs
        szveg = null;
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) { //gombok kezelse
         if (ae.getSource() instanceof JTextField) {           //Enter naplzsa
            naplz("ActionEvent: forrs="+ae.getSource().getClass().getName());
            return;
         }
         AbstractButton gomb = (AbstractButton)ae.getSource();
         if (ae.getActionCommand().equals("enable")) {            //engedlyezs
            soreditor.setEnabled(gomb.isSelected());
            napl.setEnabled(gomb.isSelected());
            jelsz.setEnabled(gomb.isSelected());
         } else if (ae.getActionCommand().equals("editable")) {  //szerkeszthet
           soreditor.setEditable(gomb.isSelected());
           napl.setEditable(gomb.isSelected());
           jelsz.setEditable(gomb.isSelected());
         } else if (ae.getActionCommand().equals("wrap")) {     //sortrs ki/be
           napl.setLineWrap(gomb.isSelected());
         } else if (ae.getActionCommand().equals("word")) { //sortrs szavaknl
           napl.setWrapStyleWord(gomb.isSelected());
         }
  }
  
  public void itemStateChanged(java.awt.event.ItemEvent ie) {         //igazts
         if (ie.getStateChange()!=java.awt.event.ItemEvent.SELECTED) return;
         int igazts = 0;
         String vlaszts = (String)ie.getItem();
         if (vlaszts.equals("LEFT"))
            igazts = JTextField.LEFT;                                  //balra
         else if (vlaszts.equals("CENTER"))
              igazts = JTextField.CENTER;                            //kzpre
         else if (vlaszts.equals("RIGHT"))
              igazts = JTextField.RIGHT;                              //jobbra
         soreditor.setHorizontalAlignment(igazts);
         jelsz.setHorizontalAlignment(igazts);
  }

  public void caretUpdate(CaretEvent ce) {              //kurzormozgs naplzsa
         naplz("CaretEvent: pozci="+ce.getDot()+
                ", kijells msik vge="+ce.getMark());
  }
                                                 //hosszkorltozott szvegmodell
  class Modell extends PlainDocument implements DocumentListener {
        int maxhossz;                                          //maximlis hossz
        Modell(int maxhossz) {                                     //konstruktor
              super();
              this.maxhossz=maxhossz;
              addDocumentListener(this);      //szvegmodell esemnyek figyelse
        }
                                                //szveg beszrsakor ellenrzs
        public void insertString(int pozci, String szveg, AttributeSet as)
                                                   throws BadLocationException {
                                         //tbbsoros szveg egysoross alaktsa
               if (egysoros.isSelected()) szveg = szveg.replace('\n', ' ');
               if (korlt.isSelected()&&szveg.length()+getLength()>maxhossz) {
                  System.out.print((char)7);  //hosszkorltot nem lehet tllpni
                  return;
               }
               super.insertString(pozci, szveg, as);
        }
                                              //szvegmodell esemnyek naplzsa
        public void insertUpdate(DocumentEvent de) {
               naplz("DocumentEvent: insertUpdate: offset="+de.getOffset()+
                      ", hossz="+de.getLength());
        }
        public void removeUpdate(DocumentEvent de) {
               naplz("DocumentEvent: removeUpdate: offset="+de.getOffset()+
                      ", hossz="+de.getLength());
        }
        public void changedUpdate(DocumentEvent de) {
               naplz("DocumentEvent: changedUpdate: offset="+de.getOffset()+
                      ", hossz="+de.getLength());
        }
  }
}
 