import javax.swing.*;
import javax.swing.event.*;

public class SwingToolBarTest extends SwingTest implements AncestorListener,
                    java.awt.event.ActionListener, java.awt.event.ItemListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingToolBarTest().init(args);
  }
  
  private JToolBar segdeszkzpanel = new JToolBar();      //segdeszkz panel
  private JComboBox legrdllista;
  protected void buildGUI() {                  //felhasznli fellet felptse
                                     //komponenshierarchi vltozsnak figyelse
            segdeszkzpanel.addAncestorListener(this);
            segdeszkzpanel.addSeparator();       //gombok kzt elvlaszt hely
            AbstractButton gomb;
            if (!applet_e) {                     //kilps mvelet megjelentse
                gomb = new JButton("kilps");
                gomb.setAction(kilps);
                segdeszkzpanel.add(gomb);
                if (nyomkvets) gomb.setIcon(null);   //DebugGraphics bug miatt
            }
            segdeszkzpanel.addSeparator();
            for (int i = 0; i < stlusvlts.length; i++) {        //stlusvlt
                gomb=new JButton(stlusok[i].getName());
                gomb.setAction(stlusvlts[i]);
                segdeszkzpanel.add(gomb);                //mveletek felvtele
                gomb.setMnemonic( gomb.getText().charAt(0) );     //gyorstgomb
                segdeszkzpanel.addSeparator();
                if (nyomkvets) gomb.setIcon(null);   //DebugGraphics bug miatt
            }                                                     //kezdpozci
            fellet.add(segdeszkzpanel, java.awt.BorderLayout.NORTH);
            JPanel vezrlpanel = new JPanel(new java.awt.BorderLayout());
            fellet.add(vezrlpanel);
            vezrlpanel.add(new JScrollPane(napl));
            JPanel panel = new JPanel();                        //gombok panelje
            vezrlpanel.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(300, 155));
            gomb = new JCheckBox("engedlyezett", segdeszkzpanel.isEnabled());
            panel.add(gomb);                                  //engedlyez gomb
            gomb.setToolTipText("enabled");
            gomb.setActionCommand("enable");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("mozgathat", segdeszkzpanel.isFloatable());
            panel.add(gomb);                               //mozgathatsgi gomb
            gomb.setToolTipText("floatable");
            gomb.setActionCommand("float");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("keretes", segdeszkzpanel.isBorderPainted());
            panel.add(gomb);                               //keretrajzolsi gomb
            gomb.setToolTipText("borderPainted");
            gomb.setActionCommand("border");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            panel.add(new JLabel("Segdeszkz panel helye:"));
            Object[] elemek = {"NORTH", "EAST", "SOUTH", "WEST"};
            legrdllista = new JComboBox(elemek);
            panel.add(legrdllista);
            legrdllista.setToolTipText("BorderLayout.");
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            setPreferredSize(400, 400);                          //kezdeti mret
            debugGraphics(segdeszkzpanel);     //nyomkvethet a megjelentse
            if (nyomkvets) setLaF(1);          //Metal DebugGraphics bug miatt
  }
  
  public void actionPerformed(java.awt.event.ActionEvent ae) {    //megjelents
         JCheckBox gomb = (JCheckBox)ae.getSource();                 //vezrlse
         if (ae.getActionCommand().equals("float"))     //mozgathatsg lltsa
            segdeszkzpanel.setFloatable(gomb.isSelected());
         else if (ae.getActionCommand().equals("border"))  //keretrajzols ki/be
              segdeszkzpanel.setBorderPainted(gomb.isSelected());
         else                          //segdeszkz panel engedlyezse/tiltsa
              segdeszkzpanel.setEnabled(gomb.isSelected());
  }
  
  private boolean thelyezs = false;             //segdeszkzpanel thelyezse
  public void itemStateChanged(java.awt.event.ItemEvent ie) {
         if (thelyezs) return;
         if (ie.getStateChange()!=java.awt.event.ItemEvent.SELECTED) return;
         String vlaszts = (String)ie.getItem();
         thelyezs = true;
         fellet.remove(segdeszkzpanel);       //rgi pozcijrl eltvolts
         thelyezs = false;
         if (vlaszts.equals("NORTH")) {                                 //fent
            segdeszkzpanel.setOrientation(JToolBar.HORIZONTAL);
            fellet.add(segdeszkzpanel, java.awt.BorderLayout.NORTH);
         } else if (vlaszts.equals("EAST")) {                         //jobbra
           segdeszkzpanel.setOrientation(JToolBar.VERTICAL);
           fellet.add(segdeszkzpanel, java.awt.BorderLayout.EAST);
         } else if (vlaszts.equals("SOUTH")) {                          //lent
           segdeszkzpanel.setOrientation(JToolBar.HORIZONTAL);
           fellet.add(segdeszkzpanel, java.awt.BorderLayout.SOUTH);
         } else if (vlaszts.equals("WEST")) {                          //balra
           segdeszkzpanel.setOrientation(JToolBar.VERTICAL);
           fellet.add(segdeszkzpanel, java.awt.BorderLayout.WEST);
         }
         getRootPane().revalidate();                              //jrarajzols
  }

  public void ancestorAdded(AncestorEvent ae) {     //segdeszkzpanel felvtele
         java.awt.Component szl = ae.getAncestorParent();
         naplz("ancestorAdded: komponens="+ae.getAncestor());
         naplz("               szl="+szl);
         if (!fellet.equals(szl)||legrdllista.getSelectedIndex()>-1)
            return;
         thelyezs=true;   //segdeszkz panel thelyezse esetn az j pozci
         SwingUtilities.invokeLater(this);          //megllaptsnak temezse
  }        //azrt kell temezni, hogy mr a vgleges pozcit tudjuk lekrdezni
  
  public void run() {          //segdeszkz panel j pozcijnak megllaptsa
         if (!thelyezs) {super.run();return;}                   //stlusvlts
         java.awt.Point pont = segdeszkzpanel.getLocation();
         if (pont.x==0) {
            if (pont.y==0) {
               if (segdeszkzpanel.getOrientation()==JToolBar.HORIZONTAL)
                  legrdllista.setSelectedItem("NORTH");                //fent
               else legrdllista.setSelectedItem("WEST");              //balra
            } else legrdllista.setSelectedItem("SOUTH");               //lent
         } else legrdllista.setSelectedItem("EAST");                 //jobbra
        thelyezs=false;
  }

  public void ancestorRemoved(AncestorEvent ae) {     //segdeszkzpanel trlse
         java.awt.Component szl = ae.getAncestorParent();
         naplz("ancestorRemoved: komponens="+ae.getAncestor());
         naplz("                 szl="+szl);
         if (thelyezs) return;                  //interaktv thelyezs esetn
         if (fellet.equals(szl)) {       //meg kell llaptani az j pozcit
            legrdllista.setSelectedIndex(-1);
            return;
         }  //klnll ablakbl trtn visszahelyezs esetn az ablak bezrsa
         if (szl!=null) SwingUtilities.windowForComponent(szl).hide();
  }
  
  public void ancestorMoved(AncestorEvent ae) {     //segdeszkzpanel elmozdult
         java.awt.Component szl = ae.getAncestorParent();
         naplz("ancestorMoved: komponens="+ae.getAncestor());
         naplz("               szl="+szl);
  }
}
