import javax.swing.*;

public class SwingToolTipTest extends SwingTest
                              implements java.awt.event.ActionListener,
                                         java.awt.event.AdjustmentListener {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingToolTipTest().init(args);
  }
                            //aktulis segdszvegmegjelentst vezrl objektum
  private ToolTipManager tooltipmanager = ToolTipManager.sharedInstance();
              //a megjelentsig szksges vrakozsi idt szablyoz grgetsv
  private ToolTipScrollBar kezdet = new ToolTipScrollBar();
 //a megjelents eltntetshez szksges vrakozsi idt szablyoz grgetsv
  private ToolTipScrollBar hossz = new ToolTipScrollBar();
 //megjelents jraidztshez szksges vrakozsi idt szablyoz grgetsv
  private ToolTipScrollBar jra = new ToolTipScrollBar();
  protected void buildGUI() {                  //felhasznli fellet felptse
            fellet.setLayout(new java.awt.GridLayout(7, 1));
            fellet.add( new ToolTipLabel(
                             "Megjelentsig szksges vrakozsi id (msec)",
                             "initialDelay"));
            fellet.add(kezdet);                         //kezdrtk belltsa
            kezdet.setValue(tooltipmanager.getInitialDelay());
            kezdet.addAdjustmentListener(this);           //grgetsv figyelse
            fellet.add( new ToolTipLabel(
                  "Megjelents eltntetshez szksges vrakozsi id (msec)",
                  "dismissDelay"));
            fellet.add(hossz);                          //kezdrtk belltsa
            hossz.setValue(tooltipmanager.getDismissDelay());
            hossz.addAdjustmentListener(this);            //grgetsv figyelse
            fellet.add( new ToolTipLabel(
                "Megjelents jraidztshez szksges vrakozsi id (msec)",
                "reshowDelay"));
            fellet.add(jra);                           //kezdrtk belltsa
            jra.setValue(tooltipmanager.getReshowDelay());
            jra.addAdjustmentListener(this);             //grgetsv figyelse
            JPanel panel = new JPanel();
            fellet.add(panel);            //segdszvegek engedlyezse/tiltsa
            AbstractButton gomb = new ToolTipCheckBox( "segdszveg?",
                                      tooltipmanager.isEnabled(), "enabled");
            panel.add(gomb);           
            gomb.addActionListener(this);                       //gomb figyelse
            for (int i=0; i < stlusvlts.length; i++) {//megjelentsi stlust
                gomb = new JButton(stlusok[i].getName());     //vlt mveletek
                panel.add(gomb);                          //felvtele gombokknt
                gomb.addActionListener(stlusvlts[i]);          //stlusvlts
                gomb.setToolTipText(stlusok[i].getClassName());
            }
            fellet.setToolTipText(getClass().getName()+" program");
  }
                                             //grgetsv esemnyek feldolgozsa
  public void adjustmentValueChanged(java.awt.event.AdjustmentEvent ae) {
         JScrollBar grgetsv = (JScrollBar)ae.getSource();
         if (kezdet.equals(grgetsv))                 //paramterek belltsa
            tooltipmanager.setInitialDelay(ae.getValue());
         else if (hossz.equals(grgetsv))
                 tooltipmanager.setDismissDelay(ae.getValue());
         else if (jra.equals(grgetsv))
                 tooltipmanager.setReshowDelay(ae.getValue());
  }
                                              //nyomgomb esemnyek feldolgozsa
  public void actionPerformed(java.awt.event.ActionEvent ae) {
         tooltipmanager.setEnabled(                        //engedlyezs/tilts
                       ((JCheckBox)ae.getSource()).isSelected() );
  }
       //dinamikusan vltoz HTML segdszveggel rendelkez grgetsv komponens
  class ToolTipScrollBar extends JScrollBar {
        ToolTipScrollBar() {                                       //konstruktor
               super(HORIZONTAL,0,0,0,10000);                      //rendelkezik
               tooltipmanager.registerComponent(this);          //segdszveggel
        }
        
        public String getToolTipText(){//alaprtelmezett segdszveg visszaadsa
               return "<html><center>HTML segdszveg!</center><hr>"+
                      "aktulis rtk = <B><I>"+        //a grgetsv rtknek
                      getValue()+"</B></I>";       //visszaadsa HTML szvegknt
        }
                         //egrkurzor pozcijtl fgg segdszveg visszaadsa
        public String getToolTipText(java.awt.event.MouseEvent me) {
               return getToolTipText()+    //alaprtelmezett szveg + egrkurzor
                      "<P>Egresemny koordinti:<UL><LI>x = "+  // koordinti
                      me.getX()+"<LI>y = "+me.getY()+"</UL>";   //HTML listaknt
        }
                            //segdszveg megjelentsi pozcijnak visszaadsa
        public java.awt.Point getToolTipLocation(java.awt.event.MouseEvent me) {
               java.awt.Point pont = me.getPoint();
               pont.y = 0;   //pozci igaztsa a grgetsv aktulis rtknek
               pont.x = (int)((float)getWidth()*                  // megfelelen
                              (float)getValue()/(float)getMaximum());
               return pont;
        }
        
        public JToolTip createToolTip() {         //segdszveg megjelentsnek
               JToolTip segdszveg = super.createToolTip();     // nyomkvetse
//             debugGraphics(segdszveg);  //Swing ClassCastException bug miatt
               return segdszveg;
        }
  }
                       //nyomkvethet segdszveggel rendelkez cmke komponens
  class ToolTipLabel extends JLabel {
        ToolTipLabel(String felirat, String segdszveg) {         //konstruktor
               super(felirat);
               setToolTipText(segdszveg);             //segdszveg belltsa
        }
        
        public JToolTip createToolTip() {         //segdszveg megjelentsnek
               JToolTip segdszveg = super.createToolTip();     // nyomkvetse
               debugGraphics(segdszveg);
               return segdszveg;
        }
  }
          //nyomkvethet segdszveggel rendelkez kivlaszthat gomb komponens
  class ToolTipCheckBox extends JCheckBox {                        //konstruktor
        ToolTipCheckBox(String felirat, boolean llapot, String segdszveg) {
               super(felirat, llapot);
               setToolTipText(segdszveg);             //segdszveg belltsa
        }
        
        public JToolTip createToolTip() {         //segdszveg megjelentsnek
               JToolTip segdszveg = super.createToolTip();     // nyomkvetse
               debugGraphics(segdszveg);
               return segdszveg;
        }
  }
}
