import javax.swing.*;
import javax.swing.event.*;
import javax.swing.tree.*;

public class SwingTreeTest extends SwingTest implements TreeModelListener,
       TreeExpansionListener, TreeWillExpandListener, TreeSelectionListener, 
                   java.awt.event.ActionListener, java.awt.event.ItemListener  {
  public static void main(String[] args) {              //indts alkalmazsknt
         new SwingTreeTest().init(args);
  }
  
  private Modell modell = new Modell(10);                           //adatmodell
  private JTree fa = new JTree(modell);                            //fastruktra
  private JCheckBox levlikon = new JCheckBox("levlikon", true);
  private JCheckBox gikon = new JCheckBox("gikon", true);
  protected void buildGUI() {                  //felhasznli fellet felptse
            modell.addTreeModelListener(this);            //adatmodell figyelse
            fellet.add(new JScrollPane(fa));
            fa.putClientProperty("JTree.lineStyle", "Angled");
                                                //kivlasztsi modell belltsa
            fa.setSelectionModel(new SelectionModell());
            fa.addTreeSelectionListener(this);           //kivlaszts figyelse
            fa.addTreeExpansionListener(this);   //fapont kinyitsnak figyelse
            fa.addTreeWillExpandListener(this);
            fa.setCellRenderer(new Renderer());         //megjelent belltsa
            fa.setCellEditor(new Editor(fa));            //szerkeszt belltsa
            fellet.add(new JScrollPane(napl), java.awt.BorderLayout.NORTH);
            JPanel panel = new JPanel();                         //vezrl panel
            fellet.add(panel, java.awt.BorderLayout.SOUTH);
            panel.setPreferredSize(new java.awt.Dimension(350, 180));
            AbstractButton gomb = new JButton("elrejt");                //elrejt
            panel.add(gomb);
            gomb.setActionCommand("hide");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JButton("megmutat");                           //megmutat
            panel.add(gomb);
            gomb.setActionCommand("show");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            gomb = new JButton("visszallt");                     //visszallt
            panel.add(gomb);
            gomb.setActionCommand("reset");
            gomb.addActionListener(this);                  //nyomgomb figyelse
            JLabel cmke = new JLabel("kivlasztsi md:");   //kivlasztsi md
            panel.add(cmke);
            cmke.setToolTipText("selectionMode");
            Object[] elemek = {"DISCONTIGUOUS", "CONTIGUOUS", "SINGLE"};
            JComboBox legrdllista = new JComboBox(elemek);
            panel.add(legrdllista);
            legrdllista.setToolTipText("_TREE_SELECTION");
            legrdllista.addItemListener(this);        //kivlaszts figyelse
            gomb = new JCheckBox("gykr lthat?", fa.isRootVisible());//gykr
            panel.add(gomb);
            gomb.setActionCommand("root");
            gomb.setToolTipText("rootVisible");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb=gikon;                                                //gikon
            panel.add(gomb);
            gomb.setActionCommand("folder");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb=levlikon;                                          //levlikon
            panel.add(gomb);
            gomb.setActionCommand("leaf");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("szerkeszthet?", fa.isEditable());
            panel.add(gomb);                                     //szerkeszthet
            gomb.setActionCommand("editable");
            gomb.setToolTipText("editable");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            gomb = new JCheckBox("szerkeszts megszakthat?",
                                 fa.getInvokesStopCellEditing());
            panel.add(gomb);                         //szerkeszts megszakthat
            gomb.setActionCommand("invoke");
            gomb.setToolTipText("invokesStopCellEditing");
            gomb.addActionListener(this);       //gomb kivlasztsnak figyelse
            for (int i=0; i<stlusvlts.length; i++) {//stlusvlt nyomgombok
                gomb = new JButton(stlusok[i].getName());
                panel.add(gomb);
                gomb.addActionListener(stlusvlts[i]);
            }
            debugGraphics(fa);                    //nyomkvethet a megjelents
            if (nyomkvets) setLaF(1);          //Metal DebugGraphics bug miatt
  }
                                                   //kivlasztsi md belltsa
  public void itemStateChanged(java.awt.event.ItemEvent ie) {
         if (ie.getStateChange()!=java.awt.event.ItemEvent.SELECTED) return;
         int md = 0;
         String vlaszts = (String)ie.getItem();
         if (vlaszts.equals("DISCONTIGUOUS"))                    //tetszleges
            md = TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION;
         else if (vlaszts.equals("CONTIGUOUS"))                   //egybefgg
              md = TreeSelectionModel.CONTIGUOUS_TREE_SELECTION;
         else if (vlaszts.equals("SINGLE"))                    //csak egy elem
              md = TreeSelectionModel.SINGLE_TREE_SELECTION;
         fa.getSelectionModel().setSelectionMode(md);
  }
                                            //adatmodell vltozsainak naplzsa
  public void treeNodesChanged(TreeModelEvent te) {               //adatvltozs
         naplz("treeNodesChanged", te);
  }
  public void treeNodesInserted(TreeModelEvent te) {                  //beszrs
         naplz("treeNodesInserted", te);
  }
  public void treeNodesRemoved(TreeModelEvent te) {                     //trls
         naplz("treeNodesRemoved", te);
  }
  public void treeStructureChanged(TreeModelEvent te) {   //fastruktra vltozs
         naplz("treeStructureChanged", te);
  }                                                  //rintett fapont naplzsa
  private void naplz(String esemny, TreeModelEvent te) {
          napl.append("TreeModelEvent: "+esemny+
                       ", fapont="+te.getTreePath().getLastPathComponent()+
                       ", indexek=");
          int[] indexek = te.getChildIndices();              //indexek listzsa
          if (indexek==null) napl.append("null");
          else {
               napl.append("[");
               for (int i=0; i<indexek.length; i++) {
                   if (i>0) napl.append(", ");
                   napl.append(""+indexek[i]);
               }
               napl.append("]");
          }
          napl.append(", pontok=");                        //fapontok listzsa
          Object[] pontok = te.getChildren();
          if (pontok==null) napl.append("null");
          else {
               napl.append("[");
               for (int i=0; i<pontok.length; i++) {
                   if (i>0) napl.append(", ");
                   napl.append(pontok[i].toString());
               }
               napl.append("]");
          }
          naplz("");
  }
                                    //fapont kinyitsnak/becsuksnak naplzsa
  public void treeExpanded(TreeExpansionEvent te) {              //kinyits utn
         naplz("TreeExpansionEvent: treeExpanded, fapont="+
                te.getPath().getLastPathComponent());
  }
  public void treeCollapsed(TreeExpansionEvent te) {             //becsuks utn
         naplz("TreeExpansionEvent: treeCollapsed, fapont="+
                te.getPath().getLastPathComponent());
  }
  public void treeWillExpand(TreeExpansionEvent te) {           //kinyits eltt
         naplz("TreeExpansionEvent: treeWillExpand, fapont="+
                te.getPath().getLastPathComponent());
  }
  public void treeWillCollapse(TreeExpansionEvent te) {         //becsuks eltt
         naplz("TreeExpansionEvent: treeWillCollapse, fapont="+
                te.getPath().getLastPathComponent());
  }
  
  public void valueChanged(TreeSelectionEvent te) {      //kivlaszts naplzsa
         naplz("TreeSelectionEvent: megvltozott kivlasztsok szma="+
                te.getPaths().length);
  }
                                                       //gombnyoms feldolgozsa
  public void actionPerformed(java.awt.event.ActionEvent ae) {    
         AbstractButton gomb = (AbstractButton)ae.getSource();
         if (gomb.getActionCommand().equals("hide")) {                  //elrejt
            TreePath[] pontok = fa.getSelectionPaths();
            if (pontok==null) return;          //kivlasztott fapontok elrejtse
            for (int i=0; i<pontok.length; i++) modell.hideNode(pontok[i]);
         } else if (gomb.getActionCommand().equals("show")) {         //megmutat
           TreePath[] pontok = fa.getSelectionPaths();
           if (pontok==null) return;  //kivlasztott fapontok minden gyermeknek
           for (int i=0; i<pontok.length; i++)                     //megmutatsa
               modell.showChildren(pontok[i]);
         } else if (gomb.getActionCommand().equals("reset")) {     //visszallt
            TreePath[] pontok = fa.getSelectionPaths();
            if (pontok==null) return;     //kivlasztott fapontok visszalltsa
            for (int i=0; i<pontok.length; i++) modell.resetNode(pontok[i]);
         } else if (gomb.getActionCommand().equals("editable")) {//szerkeszthet
           fa.setEditable(gomb.isSelected());
         } else if (gomb.getActionCommand().equals("invoke")) {    //szerkeszts
           fa.setInvokesStopCellEditing(gomb.isSelected());      //megszakthat
         } else if (gomb.getActionCommand().equals("root")) {   //gykr lthat
           fa.setRootVisible(gomb.isSelected());
         } else if (gomb.getActionCommand().equals("leaf")) {        //levlikon
           fa.repaint();
         } else if (gomb.getActionCommand().equals("folder")) {         //gikon
           fa.repaint();
         }
  }
//=================================vgtelen, rendezett, szerkeszthet adatmodell
  class Modell implements TreeModel {
        private int gakszma;                               // elgazsok szma
        private java.util.Hashtable pontok =        //a modell realizlt pontjai
                new java.util.Hashtable();
  
        static private final String JEL = "\\";         //azonost felpt jel
        static private final String ROOTID = "gykr";    //gykrpont azonost
        
        Modell(int gakszma) {                                    //konstruktor
              this.gakszma = gakszma;
              initRoot();                                //gykrpont belltsa
        }
        
        class Fapont {//---------------------------------------elrejthet fapont
              private String azonost;                     //fapont azonostja
              private String tartalom;                         //fapont tartalma
              private boolean lthat = true;               //lthat-e a fapont
              private boolean rendezett = false; //rendezve vannak-e a gyermekei
      
              Fapont(String azonost) {                           //konstruktor
                    this.azonost = azonost;
                    pontok.put(azonost, this);    //realizlt fapont naplzsa
                    naplz("j fapont! azonost="+azonost+
                           ", trolt fapontok szma="+pontok.size());
              }
              
              public int hashCode() { return azonost.hashCode(); }  //hash-kd

              public String toString() {         //szveges tartalom lekrdezse
                     if (tartalom!=null) return tartalom;
                     return azonost;
              }
        }

        private void initRoot() {                        //gykrpont belltsa
                Fapont root = new Fapont(ROOTID);
                root.tartalom = gakszma+"-alap teljes fa";
        }

        public Object getRoot() {                       //gykrelem lekrdezse
               return pontok.get(ROOTID);
        }

        public int getChildCount(Object szl) {       //lthat gyermekek szma
               int szm = 0;
               Fapont pont;
               String azonost = ((Fapont)szl).azonost+JEL;
               for (int i=gakszma; --i>=0;) {
                   pont = (Fapont)pontok.get(azonost+i);
                   if (pont==null || pont.lthat) szm++;
               }
               return szm;
        }
                                                     //adott gyermek lekrdezse
        public Object getChild(Object szl, int index) {
               String azonost = ((Fapont)szl).azonost+JEL;
               Fapont pont = (Fapont)szl;
               if (!pont.rendezett) {            //fapont gyermekeinek rendezse
                  pont.rendezett = true;
                  Fapont[] rendezs = new Fapont[gakszma];
                  for (int i=0; i<gakszma; i++) {        //beszrsos rendezs
                      pont = (Fapont)pontok.remove(azonost+i);
                      if (pont==null) pont = new Fapont(azonost+i);
                      int kezdindex = 0;                    //beszrsi pozci
                      int vgindex = i;                  //logaritmikus keresse
                      int jindex = (kezdindex + vgindex) >> 1;
                      while (vgindex>kezdindex) {
                            if (nagyobb(pont, rendezs[jindex]))
                               kezdindex = jindex + 1;
                            else vgindex = jindex;
                            jindex = (kezdindex + vgindex) >> 1;
                      }
                      for (int j=i; --j>=jindex;) rendezs[j+1]=rendezs[j];
                      rendezs[jindex]=pont;                         //beszrs
                  }
                  for (int i=0; i<gakszma; i++){//rendezett fapontok felvtele
                      rendezs[i].azonost = azonost + i;
                      pontok.put(rendezs[i].azonost, rendezs[i]);
                  }
               }
               for (int i=0; i<gakszma; i++) { //adott index elem megkeresse
                   pont = (Fapont)pontok.get(azonost+i);
                   if (pont==null || pont.lthat) {
                      if (index == 0) {                                 //megvan
                         if (pont!=null) return pont;
                         return new Fapont(azonost+i);       //realizlni kell
                      }
                      index--;
                   }
               }
               return null;                         //nincs ilyen index gyermek
        }
                                                //rendezettsget megad objektum
        private java.text.Collator collator = java.text.Collator.getInstance();
        private boolean nagyobb(Fapont ez, Fapont ennl) {     //sszehasonlts
                return collator.compare(ez.toString(), ennl.toString())>0;
        }
                                          //adott szl adott gyermeknek indexe
        public int getIndexOfChild(Object szl, Object gyermek) {
               Fapont pont = (Fapont)gyermek;
               if (!pont.lthat) return -1;                       //nem ltszik
               String azonost = ((Fapont)szl).azonost+JEL;
               int index = 0;
               try {
                   index= Integer.parseInt(//valban gyermeke az adott fapontnak
                                  pont.azonost.substring(azonost.length()));
               } catch (Exception e) {return -1;}
               for (int i=index; --i>=0;) {     //index korriglsa a nemlthat
                   pont = (Fapont)pontok.get(azonost+i);     //gyermekek miatt
                   if (pont!=null && !pont.lthat) index--;
               }
               return index;
        }

        public boolean isLeaf(Object fapont) {   //akkor levl, ha nincs lthat
               return getChildCount(fapont)==0;                       //gyermeke
        }
  
        public void resetNode(TreePath tvonal) {  //adott fapont visszalltsa
               removeNode((Fapont)tvonal.getLastPathComponent());
               fireTreeStructureChanged(tvonal);      //fastruktra jraptse
        }                       //adott fapont s realizlt gyermekeinek trlse
        private void removeNode(Fapont pont) {
                if (pontok.remove(pont.azonost)!=null)
                    naplz("Fapont trlve! azonost="+pont.azonost+
                           ", trolt fapontok szma="+pontok.size());
                if (getRoot()==null) initRoot();     //gykr jrainicializlsa
                Fapont gyermek;
                String azonost = pont.azonost+JEL;
                for (int i=gakszma; --i>=0;) {   //realizlt gyermekek trlse
                    gyermek = (Fapont)pontok.get(azonost+i);
                    if (gyermek!=null) removeNode(gyermek);
                }
        }

        public void hideNode(TreePath tvonal) {        //adott fapont elrejtse
               Fapont pont = (Fapont)tvonal.getLastPathComponent();
               if (pont == getRoot()) return;            //gykr mindig ltszik
               pont.lthat = false;
               fireTreeStructureChanged(tvonal);      //fastruktra jraptse
        }
                          //adott fapont elrejtett gyermekeinek jra megmutatsa
        public void showChildren(TreePath tvonal) {
               Fapont pont = (Fapont)tvonal.getLastPathComponent();
               boolean vltozs = false;       //fastruktrt jra kell pteni?
               Fapont gyermek;
               String azonost = pont.azonost+JEL;
               for (int i=gakszma; --i>=0;) {
                   gyermek = (Fapont)pontok.get(azonost+i);
                   if (gyermek!=null && !gyermek.lthat) { //nemlthat gyermek
                      gyermek.lthat=true;                   //lthatv ttele
                      vltozs = true;
                   }
               }                                       //fastruktra jraptse
               if (vltozs) fireTreeStructureChanged(tvonal);
        }
                                            //adott fapont tartalma megvltozott
        public void valueForPathChanged(TreePath tvonal, Object jrtk) {
               Fapont pont = (Fapont)tvonal.getLastPathComponent();
               if (!pont.toString().equals(jrtk.toString())) {
                  pont.tartalom = jrtk.toString();     //valban megvltozott
                  fireTreeStructureChanged(tvonal);   //fastruktra jraptse
               }
        }
                                        //adatmodell vltozst figyelk listja
        private java.util.Vector figyelk = new java.util.Vector();
        public void addTreeModelListener(TreeModelListener figyel) {
               figyelk.add(figyel);                        //figyel felvtele
        }
        public void removeTreeModelListener(TreeModelListener figyel) {
               figyelk.remove(figyel);                       //figyel trlse
        }
                                                    //fastruktra jrapttetse
        private void fireTreeStructureChanged(TreePath tvonal) {
                //vltozs kezdete a szl fapont, ha nem a gykrelem vltozott
                if (tvonal.getPathCount()>1) tvonal = tvonal.getParentPath();
                Fapont pont = (Fapont)tvonal.getLastPathComponent();
                pont.rendezett = false;                //jra kell majd rendezni
                TreeModelEvent esemny = new TreeModelEvent(this, tvonal);
                for (int i=0; i<figyelk.size(); i++)         //vltozs jelzse
                    ((TreeModelListener)                         //a figyelknek
                           figyelk.elementAt(i)).treeStructureChanged(esemny);
        }
  }                                          //csak azonos szinten lev fapontok
//=================================kivlasztst engedlyez kivlasztsi modell
  class SelectionModell extends DefaultTreeSelectionModel {
        public void setSelectionPath(TreePath tvonal) {  //csak az adott fapont
               TreePath[] utak = new TreePath[1];                 //kivlasztsa
               utak[0] = tvonal;
               setSelectionPaths(utak);
        }
        public void setSelectionPaths(TreePath[] utak) {//csak az adott fapontok
               clearSelection();                                  //kivlasztsa
               addSelectionPaths(utak);
        }

        public void addSelectionPath(TreePath tvonal) {          //adott fapont
               TreePath[] utak = new TreePath[1];                 //kivlasztsa
               utak[0] = tvonal;
               addSelectionPaths(utak);
        }
        private boolean kivlaszts = false;       //kivlaszts folyamatban van
        public void addSelectionPaths(TreePath[] utak) {
               if (kivlaszts) {                 //vgtelen rekurzi elkerlse
                  super.addSelectionPaths(utak);
                  return;
               }
               kivlaszts = true;
               TreePath szl = getLeadSelectionPath();
               if (szl==null) szl=utak[0];
               szl=szl.getParentPath();          //csak ezen szl gyermekei
               for (int i=0; i<utak.length; i++) {             //vlaszthatk ki
                   if (utak[i].getParentPath()==szl)
                      super.addSelectionPath(utak[i]);
               }
               kivlaszts = false;
        }
  }
//========levl s gikon megjelentst szablyoz megjelentst vgz osztly
  class Renderer extends DefaultTreeCellRenderer {
        private java.awt.Font alapbettpus;      //az rtk nlkli fapontokhoz
                                                 //megjelents felkonfigurlsa
        public java.awt.Component getTreeCellRendererComponent(JTree fa,
                            Object rtk, boolean kivlasztva, boolean kinyitva,
                                    boolean levl, int sor, boolean fkuszlt) {
               Modell.Fapont pont = (Modell.Fapont)rtk;
               if (alapbettpus==null) {         //az rtk nlkli fapontokhoz
                  alapbettpus = fa.getFont().deriveFont(java.awt.Font.ITALIC,
                                  fa.getFont().getSize()*0.8f);
               }
               if (pont.tartalom == null) {               //rtk nlkli fapont
                  setBackground(fa.getBackground());
                  setBackgroundNonSelectionColor(fa.getBackground());
                  setFont(alapbettpus);
               } else {                             //rtkkel rendelkez fapont
                 setBackground(java.awt.Color.yellow);        //sznes httrrel
                 setBackgroundNonSelectionColor(java.awt.Color.yellow);
                 setFont(fa.getFont());
               }                                    //megjelents elvgeztetse
               return super.getTreeCellRendererComponent(fa, rtk, kivlasztva,
                                               kinyitva, levl, sor, fkuszlt);
        }
       
        public Icon getOpenIcon() {                //nyitott bels fapont ikonja
               if (gikon.isSelected()) return getDefaultOpenIcon();
               return null;                       //nincs a bels pontokhoz ikon
        }
       
        public Icon getClosedIcon() {                 //zrt bels fapont ikonja
               if (gikon.isSelected()) return getDefaultClosedIcon();
               return null;                       //nincs a bels pontokhoz ikon
        }
       
        public Icon getLeafIcon() {              //levlikon csak akkor, ha kell
               if (levlikon.isSelected()) return getDefaultLeafIcon();
               return null;
        }
  }
//==================================jobb egrgombbal is indthat szerkesztmez
  class Editor extends DefaultTreeCellEditor {
        Editor(JTree fa) {                                         //konstruktor
               super(fa, (Renderer)fa.getCellRenderer());
        }
                                                      //szerkeszts megkezdhet?
        public boolean isCellEditable(java.util.EventObject esemny) {
               if (!fa.isEditable()) return false;  //csak ha szerkeszthet a fa
               if (esemny instanceof java.awt.event.MouseEvent &&              
                  SwingUtilities.isRightMouseButton(             //jobb egrgomb
                                        (java.awt.event.MouseEvent)esemny)) {
                  prepareForEditing();           //esetn indulhat a szerkeszts
                  return true;
               }
               return super.isCellEditable(esemny);
        }
                                               //szerkesztmez felkonfigurlsa
        public java.awt.Component getTreeCellEditorComponent(JTree fa,
                            Object rtk, boolean kivlasztva, boolean kinyitva,
                                                       boolean levl, int sor) {
               java.awt.Component szerkeszt = super.getTreeCellEditorComponent(
                                  fa, rtk, kivlasztva, kinyitva, levl, sor);
               szerkeszt.setFont(fa.getFont());    //szerkesztmez tartalmnak
               ((JTextField)editingComponent).selectAll();          //kijellse
               return szerkeszt;
        }
  }
}
 