// DaemonThread.java
class Daemon extends Thread {               // Dmon szl osztlya
  public void run() {                       // vgtelen ciklusban
    while (true) {                          // fut
      System.out.println( getName() + " dmon? " + isDaemon() );
      try { sleep(500); } catch (InterruptedException e) {}
    }
  }
}

class Regular extends Thread {              // ltalnos szl
  volatile boolean mehet = true;

  public void run() {
    while (mehet) {                         // fut, amg csak kell
      System.out.println( getName() + " dmon? " + isDaemon() );
      try { sleep(500); } catch (InterruptedException e) {}
    }
  }

  public void eleg() { mehet = false; }     // lelltja a szlat
}

public class DaemonThread {
  static public void main(String s[]) {
    Regular a;                              // szablyos szl
    Daemon  b;                              // dmon szl

    a = new Regular(); 
    b = new Daemon();
    System.out.println("Szlak indtsa");
    a.start();                              // indts,
    b.setDaemon(true); b.start();           // dmon bellts

    try { Thread.sleep(2000); } catch (InterruptedException e) {}
    System.out.println("A sima szl(ak) leltsa");
    a.eleg();                               // az ltalnos lell
  }
}
