// Runnable implementcija
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Color;
import java.util.Date;

public class DigiClock extends java.applet.Applet implements Runnable {
  Thread timer;                                  // a szl, ami fut
  Point mp_koord[];                              // msodpercek koordinti
  Image szamjegyek[],                            // 7-szegmenses szmjegyek
        colon,                                   // kettspont
        background,                              // httrkp (ralap)
        ora1,                                    // ra tzes helyrtk
        ora2,                                    // ra egyes helyrtk
        perc1,                                   // perc tzes helyrtk
        perc2;                                   // perc egyes helyrtk

  int mp;                                        // akt. msodperc

  public void init() {
    initImages();                                // kpek feltltse
    initPositions();                             // msodperc koord. belltsa
  }

  private void initImages() {
    szamjegyek = new Image[10];                  // tz szmjegy
    for (int i=0; i<10; i++) 
      szamjegyek[i] = getImage( getCodeBase(),  i + ".gif" );
    colon = getImage( getCodeBase(), "points.gif" );
    background = getImage( getCodeBase(), "clock.gif" );
  }

  private void initPositions() {                 // msodpercek helyei
    double p = Math.PI / 30;

    mp_koord = new Point[61];
    for (int i = 0; i < 61; i++)
      mp_koord[i] = new Point( (int)(50 + 38 * Math.sin(i*p)),
                               (int)(50 - 38 * Math.cos(i*p)) );
  }

  public void start() {                          // A szl max. prioritson
    if (timer == null) {                         // fut, hiszen pontosnak kell 
      timer = new Thread(this);                  // lennie
      timer.setPriority(Thread.MAX_PRIORITY);
      timer.start();
    }
  }

  public void stop() {
      timer = null;
  }

  public void run() {
    long now,                                    // ciklus belpsi pillanat
         waiting,                                // mennyit kell vrni (korrig)
         updateTime = 0;                         // "a kv. msodperc"
    Date time;                                   // a dtum, id lekrse
    int ora, perc;                               // segdvltozk

    while (timer != null) {
      if ( (updateTime += 1000) < (now = System.currentTimeMillis()) )
	updateTime = now;

      time = new Date(); 
      ora  = Integer.parseInt( time.toString().substring(11,13) );
      perc = Integer.parseInt( time.toString().substring(14,16) );
      mp   = Integer.parseInt( time.toString().substring(17,19) );
                                                 // Szmjegyekre bonts
      ora1  = szamjegyek[ora / 10];
      ora2  = szamjegyek[ora % 10];
      perc1 = szamjegyek[perc / 10];
      perc2 = szamjegyek[perc % 10];

      repaint();                                 // kirs s korrigls
      if ((waiting = updateTime - System.currentTimeMillis()) > 0) {
        try {
          timer.sleep( waiting );
        } catch (InterruptedException e) {}
      }
    }
  }

  public void paint(Graphics g) {
    g.setColor(Color.black);
    g.fillRect(0, 0, 100, 100);                  // ralap felhelyezs
    g.drawImage(background, 0, 0, Color.black, this);
                                                 // szmjegyek+kettspont
    g.drawImage(ora1, 17, 38, this);  g.drawImage(ora2, 32, 38, this);
    g.drawImage(colon, 46, 38, this);
    g.drawImage(perc1, 53, 38, this); g.drawImage(perc2, 68, 38, this);

    g.setColor(Color.white);
    int vege = (mp == 0 ? 60 : mp);              // hogy mind a 60 pont
    for (int temp=vege; temp>0; temp--)          // ltszdjk
	g.drawLine(mp_koord[temp].x, mp_koord[temp].y, 
                   mp_koord[temp].x, mp_koord[temp].y);
  }

  public void update (Graphics g) {
    paint(g);
  }
}

