// Felfggeszts plda a Java 2-ben
// Plda Runnable interfsszel
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.lang.Math;

public class SusRes1 extends Applet implements Runnable, MouseListener {
    int akt = 0;                      // a karikn melyik pont piros aktulisan
    Thread runner = null;             // a szl, amelyik a pontokat rajzolja
    volatile boolean threadSuspended; // felfggesztett-e a szl (egr miatt)

    public void init() {
        threadSuspended = false;
        setFont(new Font("TimesRoman", Font.BOLD, 12));  // a szveg kirshoz
        addMouseListener(this);                  // egr kezelse miatt
    }

    public void destroy() {                      // befejezsnl az egr-
        removeMouseListener(this);               // kezel lelltsa
    }

    public void start() {
        runner = new Thread(this);               // Az applet indtsakor a
        runner.start();                          // szlat is elindtjuk
    }

    public synchronized void stop() {            // Az applet lelltsakor a 
        runner = null;                           // szlnak stop jelzs
        if (threadSuspended) {                   // Ha ppen felfggesztett 
            threadSuspended = false;             // volt, akkor elengedjk
            notify();
        }
    }

    public void run() {
        Thread me = Thread.currentThread();      // Amg a szl l,
        while (runner == me) {                   // addig fut a run() metdus
            try {
                Thread.sleep(200);
                if (threadSuspended)             // Ha felfggesztett,
                  synchronized(this) {
                     while (threadSuspended) {   // akkor vr, amg el nem
                        wait();                  // eresztik
                     }
                  }
            } catch (InterruptedException e){
            }
            repaint();                           // kirajzoljuk az appletet
        }
    }

    public void paint(Graphics g) {
      g.drawString( "Nyomd meg az egrgombot", 35, 180); // Szveg
      for (int i=0; i<12; i++) {
        if (i==akt) g.setColor(Color.red);       // az aktulis piros
        else        g.setColor(Color.blue);      // amgy kk pontok
        g.fillOval( (int) (100 + 50*Math.sin((double)i/6*Math.PI)), 
                    (int) (100 - 50*Math.cos((double)i/6*Math.PI)),
                    10,10);                      // a szines pont kirajzolsa
      }                                          // egy karika mentn
      akt = ++akt % 12;                          // legyen a kv. pont az akt.
    }

    // ha megnyomtk az egr flt
    public synchronized void mousePressed(MouseEvent e) {
        e.consume();                             // vltunk a felfggeszts 
        threadSuspended = !threadSuspended;      // llapotn
        if (!threadSuspended)                    // ha eddig felfgg. volt
            notify();                            // akkor most eleresztjk
    }

    public void mouseReleased(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { }
    public void mouseExited(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { }

    public String getAppletInfo() {
        return "Title: Sus2\nAuthor: Selmaci\nSuspend/Resume az 1.2-ben.";
    }
}

