// Felfggeszts a Java 2-ben
// Thread osztly rklsvel
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.lang.Math;

class Karika extends Thread {
    Graphics g;                      // ugyanarra a grafikus terletre rajzolunk
    volatile boolean threadSuspended;// Igaz, ha a szl suspend llapotba ker-l
    volatile Thread runner;
    int x, y, st, akt=0;

    Karika(Graphics graphics, int origo_x, int origo_y, int sleeping_time) {
        g = graphics; 
        x = origo_x; y = origo_y;               // A karika origja
        st = sleeping_time;                     // akt. pont vlts kzti id
        runner = this;
    }

    // A szl biztonsgos lelltshoz (nem felfggesztett llaotban hagyva)
    // Nem rsze a standard Thread osztlynak!
    public synchronized void stopp() {
        runner = null;                  
        if (threadSuspended) {                  // Ha ppen felfggesztett 
            threadSuspended = false;            // volt, akkor elengedjk
            notify();
        }
    }

    public void run() {
        Thread me = Thread.currentThread();     // Amg a szl l,
        while (runner == me) {                  // addig fut a run() metdus
            try {
                sleep(st);                      // st ideig alszik
                if (threadSuspended)            // Ha felfggesztett,
                  synchronized(this) {
                     while (threadSuspended) {  // akkor vr, amg el nem
                        wait();                 // eresztik
                     }
                  }
            } catch (InterruptedException e){
            }
            repaint();                          // kirajzoljuk az appletet
        }
    }

    // A szl felfggesztsnl ezt az j metdust hvjk meg a fprogram
    // mint neve is mutatja, teljesen gy mkdik, mint a pause gomb a magnn
    // Nem rsze a standard Thread osztlynak!
    public synchronized void pause() {          // Vltunk a szl
        threadSuspended = !threadSuspended;     // felfggesztsi llapotn
        if (!threadSuspended)                   // ha eddig felfgg. volt
            notify();                           // akkor most eleresztjk
    }

    // Az Appletekben hasznlatos repaint() metdus msa, egyszerstsi 
    // okokbl.  Nem rsze a standard Thread osztlynak!
    private void repaint() {                     
      for (int i=0; i<12; i++) {                         
        if (i==akt) g.setColor(Color.red);      // az aktulis piros
        else        g.setColor(Color.blue);     // amgy kk pontok
        g.fillOval( (int) (x + 50*Math.sin((double)i/6*Math.PI)), 
                    (int) (y - 50*Math.cos((double)i/6*Math.PI)),
                    10,10);                     // a szines pont kirajzolsa
      }                                         // egy karika mentn
      akt = ++akt % 12;                         // legyen a kv. pont az akt.
    }
}


public class SusRes2 extends Applet implements MouseListener {
    Karika bal, jobb;

    public void init() {
        setFont(new Font("TimesRoman", Font.BOLD, 12));  // a szveg kirshoz
        addMouseListener(this);                          // egr kezelse miatt
    }

    public void start() {
        bal  = new Karika(getGraphics(),  70,100,  200); // egyik s msik
        jobb = new Karika(getGraphics(), 200,100,  300); // karika pldny
        bal.start(); jobb.start();
    }

    public void paint(Graphics g) {
        g.drawString( "Prblgasd az egrgombokat", 65, 30); // Szveg
    }

    public void stop() {                        // Az Applet lellsakor
        bal.stopp();                            // A szlakat is lelltjuk
        jobb.stopp();                           // egy specilis metdussal
    }

    public void destroy() {                     // befejezsnl az egr-
        removeMouseListener(this);              // kezel lelltsa
    }

    // Ha a bal egr gombot nyomtuk meg, akkor a bal oldali, 
    // ha a jobb oldali gombot nyomtuk meg, a jobb oldali 
    // karika szla fog felfggesztdni ill. tovbb menni
    public void mousePressed(MouseEvent e) {
        if ( (e.getModifiers() & InputEvent.BUTTON1_MASK) 
                == InputEvent.BUTTON1_MASK) {
          bal.pause();
        }
        else {
           if ( (e.getModifiers() & InputEvent.BUTTON3_MASK) 
                   == InputEvent.BUTTON3_MASK) {
              jobb.pause();
           }
        }
    }

    public void mouseReleased(MouseEvent e) { }
    public void mouseEntered(MouseEvent e) { }
    public void mouseExited(MouseEvent e) { }
    public void mouseClicked(MouseEvent e) { }
}

