// ThreadLocalTest.java
import java.util.Date;

// Ez lesz az az osztly, ami pldnyostva tartalmazza a
// szlanknti objektumot (itt ppen egy egyedi dtum)
class MyThreadLocal extends ThreadLocal {          
  protected Object initialValue() {                // ezt trva adjuk az
    Date d = new Date();                           // j rtket
    System.out.println("\tThreadLocal initialValue-> " + 
                       d.toString().substring(11,19));
    return d;
  }
}


// Az osztly minden szla kln tl rtket kap pldnyostskor
class Show extends Thread {
  static private MyThreadLocal lokal_id = new MyThreadLocal();

  Show(String name) {
    super(name);
    System.out.println(getName() + " konstruktora= " + 
                       lokal_id.get().toString().substring(11,19));
  }

  public void run() {
    for (int i=0; i<6; i++) { 
      System.out.println(getName() + "= " + 
                         lokal_id.get().toString().substring(11,19) );
      try { Thread.sleep(900); } catch (InterruptedException e) {}
    }
  }
}
 
public class ThreadLocalTest {
  static public void main(String args[]) {
    System.out.println("Nhny Show objektum ltrehozsa");    
    Show a = new Show("a szl");
    Show b = new Show("b szl");
    Show c = new Show("c szl");
    a.start(); try { Thread.sleep(1000); } catch (InterruptedException e) {}
    b.start(); try { Thread.sleep(2000); } catch (InterruptedException e) {}
    c.start();
  }
}
