import java.awt.*;
import java.awt.geom.*;

public class Abra extends Canvas {
    private int            szog = 0;       // forgatsi szg
    private GeneralPath    abra = null;    // az bra lersa
    private RenderingHints minoseg = null; // megjelents mdja

    public Abra() {
        abra = new GeneralPath();          // tetszleges bra
        abra.append(new Ellipse2D.Double(5.0, 12.5, 30.0, 15.0), false);
        abra.append(new Ellipse2D.Double(12.5, 5.0, 15.0, 30.0), false);
        minoseg = new RenderingHints(      // "antialiasing" bekapcsolsa
            RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
        setSize(40, 40);                   // az elem mrete
    }
    
    public void paint(Graphics g) {
        Graphics2D g2 = (Graphics2D) g;    // ez a tpusknyszerts 
                                           // csak Java 2-ben rvnyes!
        g2.setRenderingHints(minoseg);
        g2.rotate(Math.PI * szog / 180.0, 20.0, 20.0);
        g2.draw(abra);
    }

    public void forgat() {
        szog = (szog + 1) % 360;           // szg nvelse
        repaint();
    }
}
